import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { appNaviItemStyle } from './style';
const appNaviAnchor = tv({
    extend: appNaviItemStyle,
    slots: {
        wrapper: ['smarthr-ui-AppNavi-anchor', 'forced-colors:shr-underline'],
    },
});
export const AppNaviAnchor = ({ children, href, icon: Icon, current = false, }) => {
    const { wrapperStyle, iconStyle } = useMemo(() => {
        const { wrapper, icon } = appNaviAnchor({ active: current });
        return {
            wrapperStyle: wrapper(),
            iconStyle: icon(),
        };
    }, [current]);
    return (React.createElement("a", { "aria-current": current ? 'page' : undefined, href: href, className: wrapperStyle },
        Icon && React.createElement(Icon, { className: iconStyle }),
        children));
};
//# sourceMappingURL=AppNaviAnchor.js.map