import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { UnstyledButton } from '../Button';
import { appNaviItemStyle } from './style';
const appNaviButton = tv({
    extend: appNaviItemStyle,
    slots: {
        wrapper: 'smarthr-ui-AppNavi-button',
    },
});
export const AppNaviButton = ({ children, icon: Icon, current = false, onClick, }) => {
    const { wrapperStyle, iconStyle } = useMemo(() => {
        const { wrapper, icon } = appNaviButton({ active: current });
        return {
            wrapperStyle: wrapper(),
            iconStyle: icon(),
        };
    }, [current]);
    return (React.createElement(UnstyledButton, { "aria-current": current ? 'page' : undefined, onClick: onClick, className: wrapperStyle },
        Icon && React.createElement(Icon, { className: iconStyle }),
        children));
};
//# sourceMappingURL=AppNaviButton.js.map