import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { appNaviItemStyle } from './style';
const appNaviCustomTag = tv({
    extend: appNaviItemStyle,
    slots: {
        wrapper: 'smarthr-ui-AppNavi-customTag',
    },
});
export const AppNaviCustomTag = ({ children, tag: Tag, icon: Icon, current = false, ...props }) => {
    const { wrapperStyle, iconStyle } = useMemo(() => {
        const { wrapper, icon } = appNaviCustomTag({ active: current });
        return {
            wrapperStyle: wrapper(),
            iconStyle: icon(),
        };
    }, [current]);
    return (React.createElement(Tag, { ...props, "aria-current": current ? 'page' : undefined, className: wrapperStyle },
        Icon && React.createElement(Icon, { className: iconStyle }),
        children));
};
//# sourceMappingURL=AppNaviCustomTag.js.map