import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { Base } from '../Base';
const baseColumn = tv({
    base: '[&&&]:shr-rounded-[unset]',
    variants: {
        bgColor: {
            BACKGROUND: '[&&&]:shr-bg-background',
            COLUMN: '[&&&]:shr-bg-column',
            BASE_GREY: '[&&&]:shr-bg-base-grey',
            OVER_BACKGROUND: '[&&&]:shr-bg-over-background',
            HEAD: '[&&&]:shr-bg-head',
            BORDER: '[&&&]:shr-bg-[theme(colors.grey.20)]',
            ACTION_BACKGROUND: '[&&&]:shr-bg-action-background',
            WHITE: '[&&&]:shr-bg-white',
            GREY_5: '[&&&]:shr-bg-[theme(colors.grey.5)]',
            GREY_6: '[&&&]:shr-bg-[theme(colors.grey.6)]',
            GREY_7: '[&&&]:shr-bg-[theme(colors.grey.7)]',
            GREY_9: '[&&&]:shr-bg-[theme(colors.grey.9)]',
            GREY_20: '[&&&]:shr-bg-[theme(colors.grey.20)]',
            GREY_30: '[&&&]:shr-bg-[theme(colors.grey.30)]',
            GREY_65: '[&&&]:shr-bg-[theme(colors.grey.65)]',
            GREY_100: '[&&&]:shr-bg-[theme(colors.grey.100)]',
        },
    },
    defaultVariants: {
        bgColor: 'COLUMN',
    },
});
export const BaseColumn = ({ bgColor, padding = 1, className, ...props }) => {
    const styles = useMemo(() => baseColumn({ bgColor, className }), [bgColor, className]);
    return React.createElement(Base, { ...props, padding: padding, layer: 0, className: styles });
};
//# sourceMappingURL=BaseColumn.js.map