import { ComponentProps, ComponentPropsWithRef, ComponentType, FC, FunctionComponentElement, MouseEventHandler, ReactNode } from 'react';
import { AnchorButton, Button } from '../Button';
import { ComponentProps as IconProps } from '../Icon';
export type Primary = FunctionComponentElement<ComponentProps<typeof Button>> | FunctionComponentElement<ComponentProps<typeof AnchorButton>>;
export type Secondary = FunctionComponentElement<ComponentProps<typeof Button>> | FunctionComponentElement<ComponentProps<typeof AnchorButton>>;
type ElementProps = Omit<ComponentPropsWithRef<'div'>, keyof Props>;
type Props = {
    /** この領域の説明 */
    description?: ReactNode;
    /** 表示する `Button` または `AnchorButton` （`variant="primary"` である必要がある） */
    primaryButton?: Primary;
    /** 表示する `Button` または `AnchorButton` （`variant="secondary"` である必要がある）*/
    secondaryButton?: Secondary;
    /** 表示する tertialy link のプロパティの配列 */
    tertiaryLinks?: Array<ComponentPropsWithRef<'button'> & {
        text: ReactNode;
        icon?: ComponentType<IconProps>;
        type?: 'button' | 'reset';
        onClick?: MouseEventHandler<HTMLButtonElement>;
    }>;
    /** コンポーネントに適用する z-index 値 */
    zIndex?: number;
};
export declare const BottomFixedArea: FC<Props & ElementProps>;
export {};
