import React, { forwardRef, useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { ButtonInner } from './ButtonInner';
import { ButtonWrapper } from './ButtonWrapper';
const anchorButton = tv({
    base: 'smarthr-ui-AnchorButton',
});
export const AnchorButton = forwardRef(({ size = 'default', square = false, prefix, suffix, wide = false, variant = 'secondary', className, children, ...props }, ref) => {
    const styles = useMemo(() => anchorButton({ className }), [className]);
    return (React.createElement(ButtonWrapper, { ...props, size: size, square: square, wide: wide, variant: variant, className: styles, isAnchor: true, anchorRef: ref },
        React.createElement(ButtonInner, { prefix: prefix, suffix: suffix, size: size }, children)));
});
// BottomFixedArea での判定に用いるために displayName を明示的に設定する
AnchorButton.displayName = 'AnchorButton';
//# sourceMappingURL=AnchorButton.js.map