import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
const buttonInner = tv({
    base: [
        /* LineClamp を併用する場合に、幅を計算してもらうために指定 */
        'shr-min-w-0',
    ],
    variants: {
        size: {
            default: '',
            s: [
                /* SVG とテキストコンテンツの縦位置を揃えるために指定 */
                'shr-leading-[0]',
            ],
        },
    },
});
export const ButtonInner = ({ prefix, suffix, size, ...props }) => {
    const styles = useMemo(() => buttonInner({ size }), [size]);
    return (React.createElement(React.Fragment, null,
        prefix,
        React.createElement("span", { ...props, className: styles }),
        suffix));
};
//# sourceMappingURL=ButtonInner.js.map