import React, { forwardRef, useMemo } from 'react';
import { tv } from 'tailwind-variants';
const unstyledButton = tv({
    base: [
        'shr-box-content shr-inline shr-cursor-auto shr-select-auto shr-appearance-none shr-items-stretch shr-overflow-visible shr-border-none shr-border-current shr-bg-transparent shr-bg-none shr-bg-origin-padding shr-p-0 shr-text-left shr-font-inherit shr-text-inherit focus-visible:shr-focus-indicator',
    ],
});
export const UnstyledButton = forwardRef(({ className, type = 'button', ...props }, ref) => {
    const styles = useMemo(() => unstyledButton({ className }), [className]);
    return React.createElement("button", { ...props, type: type, ref: ref, className: styles });
});
//# sourceMappingURL=UnstyledButton.js.map