import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { Cluster } from '../Layout';
import { DefinitionListItem } from './DefinitionListItem';
const definitionList = tv({
    base: 'smarthr-ui-DefinitionList shr-my-[initial]',
});
export const DefinitionList = ({ items, maxColumns, termStyleType = 'subBlockTitle', className, }) => {
    const styles = useMemo(() => definitionList({ className }), [className]);
    return (React.createElement(Cluster, { as: "dl", gap: 1.5, className: styles }, items.map((item, index) => (React.createElement(DefinitionListItem, { ...item, key: index, maxColumns: maxColumns, termStyleType: termStyleType })))));
};
//# sourceMappingURL=DefinitionList.js.map