import React, { createContext, useState } from 'react';
export const DialogContext = createContext({
    onClickTrigger: () => {
        /* noop */
    },
    onClickClose: () => {
        /* noop */
    },
    active: false,
});
export const DialogWrapper = (props) => {
    const [active, setActive] = useState(false);
    return (React.createElement(DialogContext.Provider, { ...props, value: {
            onClickTrigger: () => setActive(true),
            onClickClose: () => setActive(false),
            active,
        } }));
};
//# sourceMappingURL=DialogWrapper.js.map