import React, { useCallback } from 'react';
import { useId } from '../../../hooks/useId';
import { DialogContentInner } from '../DialogContentInner';
import { useDialogPortal } from '../useDialogPortal';
import { FormDialogContentInner } from './FormDialogContentInner';
export const FormDialog = ({ children, title, subtitle, titleTag, actionText, actionTheme, onSubmit, onClickClose, onPressEscape = onClickClose, responseMessage, actionDisabled = false, closeDisabled, subActionArea, className, portalParent, decorators, id, ...props }) => {
    const { createPortal } = useDialogPortal(portalParent, id);
    const titleId = useId();
    const handleClickClose = useCallback(() => {
        if (!props.isOpen) {
            return;
        }
        onClickClose();
    }, [onClickClose, props.isOpen]);
    const handleSubmitAction = useCallback((close, e) => {
        if (!props.isOpen) {
            return;
        }
        onSubmit(close, e);
    }, [onSubmit, props.isOpen]);
    return createPortal(React.createElement(DialogContentInner, { ...props, ariaLabelledby: titleId, className: className, onPressEscape: onPressEscape },
        React.createElement(FormDialogContentInner, { title: title, titleId: titleId, subtitle: subtitle, titleTag: titleTag, actionText: actionText, actionTheme: actionTheme, actionDisabled: actionDisabled, closeDisabled: closeDisabled, subActionArea: subActionArea, onClickClose: handleClickClose, onSubmit: handleSubmitAction, responseMessage: responseMessage, decorators: decorators }, children)));
};
//# sourceMappingURL=FormDialog.js.map