import React, { FC } from 'react';
import { HeadingTagTypes } from '../../Heading';
import type { DecoratorsType } from '../../../types';
export type BaseProps = {
    /**
     * ダイアログのタイトル
     */
    title: React.ReactNode;
    /**
     * ダイアログのサブタイトル
     */
    subtitle?: React.ReactNode;
    /**
     * @deprecated SectioningContent(Article, Aside, Nav, Section)でDialog全体をラップして、ダイアログタイトルのHeadingレベルを設定してください
     */
    titleTag?: HeadingTagTypes;
    /**
     * ダイアログの説明
     */
    description: React.ReactNode;
    /** コンポーネント内の文言を変更するための関数を設定 */
    decorators?: DecoratorsType<'closeButtonLabel'>;
};
export type MessageDialogContentInnerProps = BaseProps & {
    onClickClose: () => void;
    titleId: string;
};
export declare const MessageDialogContentInner: FC<MessageDialogContentInnerProps>;
