import React from 'react';
import { MessageDialog } from '../MessageDialog';
import { useRemoteTrigger } from '../useRemoteTrigger';
export const RemoteTriggerMessageDialog = ({ id, onClickClose, onToggle, onOpen, onClose, ...props }) => {
    const { isOpen, onClickClose: actualOnClickClose } = useRemoteTrigger({
        id,
        onClickClose,
        onToggle,
        onOpen,
        onClose,
    });
    return React.createElement(MessageDialog, { ...props, id: id, isOpen: isOpen, onClickClose: actualOnClickClose });
};
//# sourceMappingURL=RemoteTriggerMessageDialog.js.map