import React, { useContext, useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { DropdownContentContext } from './DropdownContent';
import { DropdownContentInnerContext } from './DropdownContentInner';
const closer = tv({
    base: 'smarthr-ui-Dropdown-closer',
    variants: {
        controllable: {
            false: 'shr-flex shr-flex-col',
        },
    },
});
export const DropdownCloser = ({ children, className }) => {
    const { onClickCloser, controllable, scrollable } = useContext(DropdownContentContext);
    const { maxHeight } = useContext(DropdownContentInnerContext);
    const styleProps = useMemo(() => {
        const maxHeightStyle = !controllable && scrollable ? maxHeight : undefined;
        return {
            className: closer({ controllable, className }),
            style: {
                maxHeight: maxHeightStyle,
            },
        };
    }, [className, controllable, maxHeight, scrollable]);
    return (
    // eslint-disable-next-line smarthr/a11y-delegate-element-has-role-presentation
    React.createElement("div", { ...styleProps, onClick: onClickCloser, role: "presentation" }, children));
};
//# sourceMappingURL=DropdownCloser.js.map