import React, { useContext } from 'react';
import { DropdownContext } from './Dropdown';
import { DropdownContentInner } from './DropdownContentInner';
export const DropdownContentContext = React.createContext({
    onClickCloser: () => {
        /* noop */
    },
    controllable: false,
    scrollable: true,
});
export const DropdownContent = ({ controllable = false, scrollable = true, ...props }) => {
    const { DropdownContentRoot, triggerRect, onClickCloser } = useContext(DropdownContext);
    return (React.createElement(DropdownContentRoot, null,
        React.createElement(DropdownContentContext.Provider, { value: { onClickCloser, controllable, scrollable } },
            React.createElement(DropdownContentInner, { ...props, triggerRect: triggerRect, scrollable: scrollable, controllable: controllable }))));
};
//# sourceMappingURL=DropdownContent.js.map