import React, { forwardRef, useMemo } from 'react';
import { tv } from 'tailwind-variants';
const scrollArea = tv({
    base: 'smarthr-ui-Dropdown-scrollArea shr-flex-auto shr-overflow-y-auto',
});
export const DropdownScrollArea = forwardRef(({ as: Component = 'div', className, ...props }, ref) => {
    const styles = useMemo(() => scrollArea({ className }), [className]);
    return React.createElement(Component, { ...props, ref: ref, className: styles });
});
//# sourceMappingURL=DropdownScrollArea.js.map