import { ComponentProps, ComponentPropsWithRef } from 'react';
import { type FC, type MouseEventHandler } from 'react';
import { Select } from '../../Select';
import type { DecoratorsType } from '../../../types';
type ArgsOnApply = {
    field: string;
    order: 'asc' | 'desc';
    newfields: ComponentProps<typeof Select>['options'];
};
type Props = {
    /** 並び替え項目 */
    sortFields: ComponentProps<typeof Select>['options'];
    /** 並び順の初期値 */
    defaultOrder: 'asc' | 'desc';
    /** 適用時に発火するイベント */
    onApply: (args: ArgsOnApply) => void;
    /** キャンセル時に発火するイベント */
    onCancel?: MouseEventHandler<HTMLButtonElement>;
    decorators?: DecoratorsType<'sortFieldLabel' | 'sortOrderLabel' | 'ascLabel' | 'descLabel' | 'applyButtonLabel' | 'cancelButtonLabel'>;
};
type ElementProps = Omit<ComponentPropsWithRef<'button'>, keyof Props>;
export declare const SortDropdown: FC<Props & ElementProps>;
export {};
