import React from 'react';
import { Button } from '../../Button';
import { Fieldset } from '../../Fieldset';
import { FormControl } from '../../FormControl';
import { Cluster, Stack } from '../../Layout';
import { RadioButton } from '../../RadioButton';
import { Select } from '../../Select';
import { Dropdown } from '../Dropdown';
import { DropdownCloser } from '../DropdownCloser';
import { DropdownContent } from '../DropdownContent';
import { DropdownScrollArea } from '../DropdownScrollArea';
import { DropdownTrigger } from '../DropdownTrigger';
import { useSortDropdown } from './useSortDropdown';
export const SortDropdown = ({ sortFields, defaultOrder, onApply, onCancel, decorators, ...props }) => {
    const { labels: { triggerLabel, sortFieldLabel, sortOrderLabel, ascLabel, descLabel, applyButtonLabel, cancelButtonLabel, }, SortIcon, setCheckedInnerOrder, innerValues: { innerFields, innerCheckedOrder }, handler: { handleApply, handleChange }, styles: { bodyStyle, selectStyle, footerStyle }, } = useSortDropdown({
        sortFields,
        defaultOrder,
        onApply,
        decorators,
    });
    return (React.createElement(Dropdown, null,
        React.createElement(DropdownTrigger, null,
            React.createElement(Button, { ...props, suffix: React.createElement(SortIcon, null) }, triggerLabel)),
        React.createElement(DropdownContent, { controllable: true },
            React.createElement(DropdownScrollArea, null,
                React.createElement(Stack, { className: bodyStyle },
                    React.createElement(FormControl, { title: sortFieldLabel },
                        React.createElement(Select, { name: "sortFields", options: innerFields, onChange: handleChange, className: selectStyle })),
                    React.createElement(Fieldset, { title: sortOrderLabel, innerMargin: 0.5 },
                        React.createElement(Cluster, { gap: 1.25 },
                            React.createElement(RadioButton, { name: "sortOrder", value: "asc", defaultChecked: innerCheckedOrder === 'asc', onChange: () => setCheckedInnerOrder('asc') }, ascLabel),
                            React.createElement(RadioButton, { name: "sortOrder", value: "desc", defaultChecked: innerCheckedOrder === 'desc', onChange: () => setCheckedInnerOrder('desc') }, descLabel)))),
                React.createElement(Cluster, { gap: 1, align: "center", justify: "flex-end", as: "footer", className: footerStyle },
                    React.createElement(DropdownCloser, null,
                        React.createElement(Button, { onClick: onCancel }, cancelButtonLabel)),
                    React.createElement(DropdownCloser, null,
                        React.createElement(Button, { variant: "primary", onClick: handleApply }, applyButtonLabel)))))));
};
//# sourceMappingURL=SortDropdown.js.map