import { ChangeEventHandler, ComponentProps, MouseEventHandler } from 'react';
import { SortDropdown } from './SortDropdown';
type Props = Omit<ComponentProps<typeof SortDropdown>, 'onCancel'>;
export declare const useSortDropdown: ({ sortFields, defaultOrder, onApply, decorators }: Props) => {
    setCheckedInnerOrder: import("react").Dispatch<import("react").SetStateAction<"desc" | "asc">>;
    labels: {
        triggerLabel: string;
        sortFieldLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
        sortOrderLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
        ascLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
        descLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
        applyButtonLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
        cancelButtonLabel: string | number | true | import("react").ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<import("react").ReactNode>;
    };
    handler: {
        handleApply: MouseEventHandler<HTMLButtonElement>;
        handleChange: ChangeEventHandler<HTMLSelectElement>;
    };
    innerValues: {
        innerFields: (({
            value: string;
        } & Omit<import("react").OptionHTMLAttributes<HTMLOptionElement>, "value">) | ({
            label: string;
            options: ({
                value: string;
            } & Omit<import("react").OptionHTMLAttributes<HTMLOptionElement>, "value">)[];
        } & import("react").OptgroupHTMLAttributes<HTMLOptGroupElement>))[];
        innerSelectedField: string | undefined;
        innerCheckedOrder: "desc" | "asc";
    };
    SortIcon: import("react").FC<import("../../Icon").ComponentProps>;
    styles: {
        bodyStyle: string;
        selectStyle: string;
        footerStyle: string;
    };
};
export {};
