import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { Stack } from '../../Layout';
import { Text } from '../../Text';
const sideMenuGroup = tv({
    slots: {
        wrapper: ['smarthr-ui-SideMenu-group', '[&_+_&]:shr-border-t-shorthand [&_+_&]:shr-pt-1.25'],
        list: 'shr-list-none',
    },
});
export const SideMenuGroup = ({ name, nameTag = 'h3', children, className, ...rest }) => {
    const { wrapperStyle, listStyle } = useMemo(() => {
        const { wrapper, list } = sideMenuGroup();
        return {
            wrapperStyle: wrapper({ className }),
            listStyle: list(),
        };
    }, [className]);
    return (React.createElement(Stack, { ...rest, as: "li", gap: 0.5, className: wrapperStyle },
        React.createElement(Text, { color: "TEXT_GREY", leading: "TIGHT", size: "S", weight: "normal", as: nameTag }, name),
        React.createElement(Stack, { as: "ul", gap: 0, className: listStyle }, children)));
};
//# sourceMappingURL=SideMenuGroup.js.map