import { ComponentPropsWithoutRef, FC, ReactNode } from 'react';
import { VariantProps } from 'tailwind-variants';
export declare const messageTypes: readonly ["success", "info", "warning", "error"];
export declare const roles: readonly ["alert", "status"];
export type Props = {
    /** true のときに FlashMessage を表示する */
    visible: boolean;
    /** 表示するアイコンのタイプ */
    type: (typeof messageTypes)[number];
    /** メッセージの内容 */
    text: ReactNode;
    /** コンポーネントに適用する role 属性 */
    role?: (typeof roles)[number];
    /** 閉じるボタンを押下、または表示してから8秒後に発火するコールバック関数 */
    onClose: () => void;
    /** FlashMessage が表示されてから一定時間後に自動で閉じるかどうか */
    autoClose?: boolean;
} & VariantProps<typeof flashMessage>;
type ElementProps = Omit<ComponentPropsWithoutRef<'div'>, keyof Props>;
declare const flashMessage: import("tailwind-variants").TVReturnType<{
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}, {
    wrapper: string[];
    responseMessage: string[];
    closeButton: string[];
}, undefined, import("tailwind-variants/dist/config").TVConfig<{
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}, {
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}>, {
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}, {
    wrapper: string[];
    responseMessage: string[];
    closeButton: string[];
}, import("tailwind-variants").TVReturnType<{
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}, {
    wrapper: string[];
    responseMessage: string[];
    closeButton: string[];
}, undefined, import("tailwind-variants/dist/config").TVConfig<{
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}, {
    animation: {
        bounce: {
            wrapper: string[];
        };
        none: {};
    };
}>, unknown, unknown, undefined>>;
/**
 * @deprecated `FlashMessage` は気づきにくいため、安易な使用はお勧めしません。`NotificationBar` や `Dialog` の使用を検討してください。
 */
export declare const FlashMessage: FC<Props & ElementProps>;
export {};
