import React, { ComponentProps, PropsWithChildren, ReactElement, ReactNode } from 'react';
type Tenant = PropsWithChildren<{
    id: string;
    name: ReactNode;
}>;
type Props = {
    /** ロゴ */
    logo?: ReactElement;
    /** ロゴリンク */
    logoHref?: string;
    /** テナント一覧 */
    tenants?: Tenant[];
    /** 現在のテナント ID */
    currentTenantId?: string;
    /** テナントが選択された時に発火するコールバック関数 */
    onTenantSelect?: (id: string) => void;
};
type ElementProps = Omit<ComponentProps<'header'>, keyof Props>;
export declare const Header: React.FC<PropsWithChildren<Props> & ElementProps>;
export {};
