import React, { forwardRef, useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { Tooltip } from '../../Tooltip';
import { Input } from '../Input';
const inputWithTooltip = tv({
    base: 'smarthr-ui-InputWithTooltip [&]:shr-overflow-y-visible',
});
export const InputWithTooltip = forwardRef(({ tooltipMessage, width, ...props }, ref) => {
    const widthStyle = typeof width === 'number' ? `${width}px` : width;
    const tooltipStyleProps = useMemo(() => {
        const tooltip = inputWithTooltip();
        return {
            className: tooltip,
            style: {
                width: widthStyle,
            },
        };
    }, [widthStyle]);
    return (React.createElement(Tooltip, { ...tooltipStyleProps, message: tooltipMessage, tabIndex: -1, ariaDescribedbyTarget: "inner" },
        React.createElement(Input, { ...props, width: widthStyle, ref: ref })));
});
//# sourceMappingURL=InputWithTooltip.js.map