import React from 'react';
import { Button } from '../Button';
import { FaAngleDoubleLeftIcon, FaAngleDoubleRightIcon, FaChevronLeftIcon, FaChevronRightIcon, } from '../Icon';
const getIconProps = (direction, double) => direction === 'prev'
    ? double
        ? { Icon: FaAngleDoubleLeftIcon, alt: '最初へ' }
        : { Icon: FaChevronLeftIcon, alt: '前へ' }
    : double
        ? { Icon: FaAngleDoubleRightIcon, alt: '最後へ' }
        : { Icon: FaChevronRightIcon, alt: '次へ' };
export const PaginationControllerItemButton = ({ direction, disabled, double = false, targetPage, onClick, }) => {
    const { Icon, ...iconProps } = getIconProps(direction, double);
    return (React.createElement(Button, { square: true, size: "s", className: "shr-rounded-s", onClick: () => onClick(targetPage), disabled: disabled, "aria-label": iconProps.alt },
        React.createElement(Icon, { color: disabled ? 'TEXT_DISABLED' : 'TEXT_BLACK', alt: iconProps.alt })));
};
//# sourceMappingURL=PaginationControllerItemButton.js.map