import React, { useMemo } from 'react';
import { Button } from '../Button';
export const PaginationItemButton = ({ page, currentPage, onClick }) => {
    const isCurrent = useMemo(() => page === currentPage, [page, currentPage]);
    return (React.createElement(Button, { square: true, size: "s", className: "shr-rounded-s aria-current-page:shr-cursor-default aria-current-page:shr-border-solid aria-current-page:shr-border-main aria-current-page:shr-bg-main aria-current-page:shr-text-white", "aria-current": isCurrent ? 'page' : undefined, "aria-label": `${page}ページ目`, onClick: isCurrent ? undefined : () => onClick(page), disabled: isCurrent }, page));
};
//# sourceMappingURL=PaginationItemButton.js.map