import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { FaCircleCheckIcon, FaCircleExclamationIcon, FaCircleInfoIcon, FaRotateIcon, WarningIcon, } from '../Icon';
const responseMessage = tv({
    base: '',
    variants: {
        type: {
            info: 'shr-fill-grey',
            success: 'shr-fill-main',
            warning: '',
            error: 'shr-fill-danger',
            sync: 'shr-fill-main',
        },
    },
});
export const ResponseMessage = ({ type = 'info', children, ...other }) => {
    const styles = useMemo(() => responseMessage({ type }), [type]);
    const Icon = useMemo(() => {
        switch (type) {
            case 'info':
                return FaCircleInfoIcon;
            case 'success':
                return FaCircleCheckIcon;
            case 'warning':
                return WarningIcon;
            case 'error':
                return FaCircleExclamationIcon;
            case 'sync':
                return FaRotateIcon;
        }
    }, [type]);
    return React.createElement(Icon, { ...other, text: children, className: styles });
};
//# sourceMappingURL=ResponseMessage.js.map