import React, { forwardRef, useContext } from 'react';
import { LevelContext } from './levelContext';
const SectioningContent = forwardRef(({ children, baseLevel, as: Wrapper = 'section', ...props }, ref) => (React.createElement(Wrapper, { ...props, ref: ref },
    React.createElement(SectioningFragment, { baseLevel: baseLevel }, children))));
export const Section = SectioningContent;
export const Article = (props) => React.createElement(SectioningContent, { ...props, as: "article" });
export const Aside = (props) => React.createElement(SectioningContent, { ...props, as: "aside" });
export const Nav = (props) => React.createElement(SectioningContent, { ...props, as: "nav" });
export const SectioningFragment = ({ children, baseLevel, }) => {
    const level = useContext(LevelContext);
    return React.createElement(LevelContext.Provider, { value: baseLevel || level + 1 }, children);
};
//# sourceMappingURL=SectioningContent.js.map