import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { SideNavItemButton } from './SideNavItemButton';
const sideNav = tv({
    base: ['smarthr-ui-SideNav', 'shr-list-none shr-bg-column'],
});
export const SideNav = ({ items, size = 'default', onClick, className, ...props }) => {
    const styles = useMemo(() => sideNav({ className }), [className]);
    return (React.createElement("ul", { ...props, className: styles }, items.map((item) => (React.createElement(SideNavItemButton, { id: item.id, title: item.title, prefix: item.prefix, isSelected: item.isSelected, size: size, key: item.id, onClick: onClick })))));
};
//# sourceMappingURL=SideNav.js.map