import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { SpreadsheetTableCorner } from './SpreadsheetTableCorner';
const spreadsheetTable = tv({
    base: [
        'smarthr-ui-SpreadsheetTable shr-border-shorthand shr-border-collapse shr-bg-head',
        // th
        '[&_th]:shr-p-0.25 [&_th]:shr-text-sm [&_th]:shr-font-normal [&_th]:shr-text-grey',
        // th + th
        '[&_th_+_th]:shr-border-l-shorthand [&_th_+_th]:shr-border-[theme(backgroundColor[head-darken])]',
        // 左上の角： tr:first-child th:first-child
        '[&_tr:first-child_th:first-child]:shr-w-[calc(1em_*_theme(lineHeight.normal))]',
        // tr + tr th
        '[&_tr_+_tr_th]:shr-border-t-shorthand [&_tr_+_tr_th]:shr-border-[theme(backgroundColor[head-darken])]',
        // td
        '[&_td]:shr-border-shorthand [&_td]:shr-bg-white [&_td]:shr-p-0.25 [&_td]:shr-text-sm',
    ],
});
export const SpreadsheetTable = ({ data, className, children, ...props }) => {
    const style = useMemo(() => spreadsheetTable({ className }), [className]);
    return (React.createElement("table", { ...props, className: style },
        data && (React.createElement(React.Fragment, null,
            React.createElement("thead", null,
                React.createElement("tr", null,
                    React.createElement(SpreadsheetTableCorner, null),
                    data[0].map((_, i) => (React.createElement("th", { key: `headRow-${i}` }, String.fromCharCode(65 + i)))))),
            React.createElement("tbody", null, data.map((row, i) => (React.createElement("tr", { key: `bodyRow-${i}` },
                React.createElement("th", null, i + 1),
                row.map((cell, j) => (React.createElement("td", { key: `bodyCell-${i}-${j}` }, cell))))))))),
        children));
};
//# sourceMappingURL=SpreadsheetTable.js.map