import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { Reel } from '../Layout';
const tabBar = tv({
    slots: {
        wrapper: ['smarthr-ui-TabBar'],
        inner: ['shr-grow', 'shr-m-0.25'],
    },
    variants: {
        bordered: {
            true: {
                inner: [
                    'shr-relative',
                    'before:shr-absolute',
                    'before:shr-inset-x-0',
                    'before:shr-bottom-0',
                    'before:shr-border-b-shorthand',
                    'before:shr-content-[""]',
                ],
            },
        },
    },
});
export const TabBar = ({ className, bordered = true, children, ...props }) => {
    const { wrapperStyle, innerStyle } = useMemo(() => {
        const { wrapper, inner } = tabBar();
        return {
            wrapperStyle: wrapper({ className }),
            innerStyle: inner({ bordered }),
        };
    }, [bordered, className]);
    return (React.createElement(Reel, { ...props, role: "tablist", className: wrapperStyle },
        React.createElement("div", { className: innerStyle }, children)));
};
//# sourceMappingURL=TabBar.js.map