import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { useTableHeadCellCount } from './useTableHeadCellCount';
const bulkActionRow = tv({
    slots: {
        wrapper: 'smarthr-ui-BulkActionRow',
        cell: [
            'shr-bg-action-background shr-p-1 shr-text-base',
            'forced-colors:shr-border-t-shorthand',
        ],
    },
});
export const BulkActionRow = ({ children, className, ...props }) => {
    const { countHeadCellRef, count } = useTableHeadCellCount();
    const { wrapperStyle, cellStyle } = useMemo(() => {
        const { wrapper, cell } = bulkActionRow();
        return {
            wrapperStyle: wrapper({ className }),
            cellStyle: cell(),
        };
    }, [className]);
    return (React.createElement("tr", { ...props, ref: countHeadCellRef, className: wrapperStyle },
        React.createElement("td", { colSpan: count, className: cellStyle }, children)));
};
//# sourceMappingURL=BulkActionRow.js.map