import React, { useMemo } from 'react';
import { tv } from 'tailwind-variants';
import { useReelCells } from './useReelCells';
import { reelShadowStyle } from './useReelShadow';
const tableReel = tv({
    slots: {
        wrapper: ['smarthr-ui-TableReel', 'shr-relative'],
        inner: ['smarthr-ui-TableReel-inner', 'shr-relative shr-overflow-auto'],
    },
});
export const TableReel = ({ className, ...props }) => {
    const { showShadow, tableWrapperRef } = useReelCells();
    const { wrapperStyle, innerStyle } = useMemo(() => {
        const { wrapper, inner } = tableReel();
        return {
            wrapperStyle: reelShadowStyle({ showShadow, className: wrapper({ className }) }),
            innerStyle: inner(),
        };
    }, [className, showShadow]);
    return (React.createElement("div", { className: wrapperStyle },
        React.createElement("div", { ...props, ref: tableWrapperRef, className: innerStyle })));
};
//# sourceMappingURL=TableReel.js.map