import React, { useMemo } from 'react';
import { VisuallyHiddenText } from '../VisuallyHiddenText';
const DEFAULT_TEXT = '〜';
const DEFAULT_VISUALLY_HIDDEN_TEXT = 'から';
const executeDecorator = (defaultText, decorator) => decorator?.(defaultText) || defaultText;
export const RangeSeparator = ({ decorators }) => {
    const text = useMemo(() => executeDecorator(DEFAULT_TEXT, decorators?.text), [decorators?.text]);
    const visuallyHiddenText = useMemo(() => executeDecorator(DEFAULT_VISUALLY_HIDDEN_TEXT, decorators?.visuallyHiddenText), [decorators?.visuallyHiddenText]);
    return (React.createElement(React.Fragment, null,
        React.createElement("span", { "aria-hidden": "true" }, text),
        React.createElement(VisuallyHiddenText, null, visuallyHiddenText)));
};
//# sourceMappingURL=RangeSeparator.js.map