export declare const useTheme: () => {
    fill: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    stroke: {
        black: string;
    };
    flex: Record<"auto" | "none" | "1" | "initial", string>;
    data: Record<string, string>;
    height: import("tailwindcss/types/config").KeyValuePair<string, string>;
    width: import("tailwindcss/types/config").KeyValuePair<string, string>;
    invert: Record<"0" | "DEFAULT", string>;
    accentColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    animation: Record<"none" | "ping" | "spin" | "pulse" | "bounce", string>;
    aspectRatio: Record<"auto" | "square" | "video", string>;
    backgroundColor: {
        black: string;
        white: string;
        'white-darken': any;
        link: string;
        background: string;
        border: any;
        brand: any;
        column: string;
        'column-darken': string;
        'base-grey': string;
        'over-background': string;
        head: string;
        'head-darken': string;
        'action-background': string;
        main: string;
        'main-darken': any;
        danger: string;
        'danger-darken': any;
        'warning-yellow': string;
        'warning-yellow-darken': any;
        overlay: string;
        scrim: string;
        grey: {
            9: any;
            '9-darken': string;
        };
        inherit: string;
        transparent: string;
    };
    backgroundImage: Record<"none" | "gradient-to-t" | "gradient-to-tr" | "gradient-to-r" | "gradient-to-br" | "gradient-to-b" | "gradient-to-bl" | "gradient-to-l" | "gradient-to-tl", string>;
    backgroundPosition: Record<"center" | "left" | "top" | "bottom" | "right" | "left-bottom" | "left-top" | "right-bottom" | "right-top", string>;
    backgroundSize: Record<"auto" | "contain" | "cover", string>;
    borderColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string> & {
        default: any;
        disabled: any;
        darken: string;
        'high-contrast': any;
    };
    borderRadius: {
        none: string;
        s: string;
        m: string;
        l: string;
        em: string;
        full: string;
    };
    borderSpacing: import("tailwindcss/types/config").KeyValuePair<string, string>;
    borderWidth: Record<"0" | "2" | "4" | "8" | "DEFAULT", string>;
    boxShadow: {
        'layer-0': string;
        'layer-1': string;
        'layer-2': string;
        'layer-3': string;
        'layer-4': string;
        outline: string;
        underline: string;
        'input-hover': string;
        none: string;
    };
    caretColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    columns: Record<"auto" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "sm" | "md" | "lg" | "xl" | "2xl" | "3xl" | "3xs" | "2xs" | "xs" | "4xl" | "5xl" | "6xl" | "7xl", string>;
    container: Partial<{
        screens: import("tailwindcss/types/config").ScreensConfig;
        center: boolean;
        padding: string | Record<string, string>;
    }>;
    content: Record<"none", string>;
    cursor: Record<"progress" | "auto" | "none" | "default" | "not-allowed" | "copy" | "move" | "text" | "alias" | "all-scroll" | "cell" | "col-resize" | "context-menu" | "crosshair" | "e-resize" | "ew-resize" | "grab" | "grabbing" | "help" | "n-resize" | "ne-resize" | "nesw-resize" | "no-drop" | "ns-resize" | "nw-resize" | "nwse-resize" | "pointer" | "row-resize" | "s-resize" | "se-resize" | "sw-resize" | "vertical-text" | "w-resize" | "wait" | "zoom-in" | "zoom-out", string>;
    flexBasis: import("tailwindcss/types/config").KeyValuePair<string, string>;
    flexGrow: Record<"0" | "DEFAULT", string>;
    flexShrink: Record<"0" | "DEFAULT", string>;
    fontFamily: {
        inherit: string;
    };
    fontSize: {
        '2xs': string;
        xs: string;
        sm: string;
        base: string;
        lg: string;
        xl: string;
        '2xl': string;
        inherit: string;
    };
    fontWeight: Record<"bold" | "normal" | "medium" | "black" | "thin" | "light" | "extralight" | "semibold" | "extrabold", string>;
    gap: import("tailwindcss/types/config").KeyValuePair<string, string>;
    gridAutoColumns: Record<"max" | "auto" | "min" | "fr", string>;
    gridAutoRows: Record<"max" | "auto" | "min" | "fr", string>;
    gridColumn: Record<"auto" | "span-1" | "span-2" | "span-3" | "span-4" | "span-5" | "span-6" | "span-7" | "span-8" | "span-9" | "span-10" | "span-11" | "span-12" | "span-full", string>;
    gridColumnEnd: Record<"auto" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13", string>;
    gridColumnStart: Record<"auto" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13", string>;
    gridRow: Record<"auto" | "span-1" | "span-2" | "span-3" | "span-4" | "span-5" | "span-6" | "span-7" | "span-8" | "span-9" | "span-10" | "span-11" | "span-12" | "span-full", string>;
    gridRowEnd: Record<"auto" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13", string>;
    gridRowStart: Record<"auto" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "13", string>;
    gridTemplateColumns: Record<"none" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "subgrid", string>;
    gridTemplateRows: Record<"none" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "subgrid", string>;
    inset: import("tailwindcss/types/config").KeyValuePair<string, string>;
    letterSpacing: Record<"normal" | "tighter" | "tight" | "wide" | "wider" | "widest", string>;
    lineHeight: {
        none: string;
        tight: string;
        normal: string;
        loose: string;
    };
    listStyleType: Record<"none" | "decimal" | "disc", string>;
    margin: import("tailwindcss/types/config").KeyValuePair<string, string>;
    maxHeight: import("tailwindcss/types/config").KeyValuePair<string, string>;
    maxWidth: {
        none: string;
        full: string;
        min: string;
        max: string;
        fit: string;
    };
    minHeight: any;
    minWidth: import("tailwindcss/types/config").KeyValuePair<string, string>;
    objectPosition: Record<"center" | "left" | "top" | "bottom" | "right" | "left-bottom" | "left-top" | "right-bottom" | "right-top", string>;
    opacity: Record<"0" | "5" | "10" | "15" | "20" | "50" | "75" | "90" | "95" | "100" | "30" | "60" | "25" | "35" | "40" | "45" | "55" | "65" | "70" | "80" | "85", string>;
    order: Record<"none" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" | "10" | "11" | "12" | "first" | "last", string>;
    outlineColor: {
        DEFAULT: string;
    };
    outlineOffset: Record<"0" | "1" | "2" | "4" | "8", string>;
    outlineWidth: Record<"0" | "1" | "2" | "4" | "8", string>;
    padding: import("tailwindcss/types/config").KeyValuePair<string, string>;
    rotate: Record<"0" | "1" | "2" | "3" | "6" | "12" | "90" | "180" | "45", string>;
    scale: Record<"0" | "50" | "75" | "90" | "95" | "100" | "105" | "110" | "125" | "150", string>;
    scrollMargin: import("tailwindcss/types/config").KeyValuePair<string, string>;
    scrollPadding: import("tailwindcss/types/config").KeyValuePair<string, string>;
    strokeWidth: Record<"0" | "1" | "2", string> & {
        '0.5': string;
    };
    textDecorationColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    textDecorationThickness: Record<"auto" | "0" | "1" | "2" | "4" | "8" | "from-font", string>;
    textIndent: import("tailwindcss/types/config").KeyValuePair<string, string>;
    textUnderlineOffset: Record<"auto" | "0" | "1" | "2" | "4" | "8", string>;
    transformOrigin: Record<"center" | "left" | "top" | "bottom" | "right" | "top-right" | "bottom-right" | "bottom-left" | "top-left", string>;
    transitionDelay: Record<"0" | "75" | "100" | "150" | "200" | "300" | "500" | "700" | "1000", string>;
    transitionDuration: Record<"0" | "DEFAULT" | "75" | "100" | "150" | "200" | "300" | "500" | "700" | "1000", string>;
    transitionProperty: Record<"all" | "none" | "opacity" | "transform" | "colors" | "shadow" | "DEFAULT", string>;
    transitionTimingFunction: Record<"linear" | "in" | "out" | "in-out" | "DEFAULT", string>;
    translate: import("tailwindcss/types/config").KeyValuePair<string, string>;
    willChange: Record<"auto" | "transform" | "scroll" | "contents", string>;
    zIndex: {
        auto: string;
        0: string;
        1: string;
        'fixed-menu': string;
        'overlap-base': string;
        overlap: string;
        'flash-message': string;
    };
    supports: Record<string, string>;
    blur: Record<"none" | "0" | "sm" | "DEFAULT" | "md" | "lg" | "xl" | "2xl" | "3xl", string>;
    space: import("tailwindcss/types/config").KeyValuePair<string, string>;
    spacing: {
        0: string;
        2: string;
        1: string;
        3: string;
        4: string;
        8: string;
        [-1]: string;
        1.25: string;
        1.5: string;
        2.5: string;
        0.5: string;
        [-2]: string;
        [-3]: string;
        0.25: string;
        0.75: string;
        3.5: string;
        [-0.25]: string;
        [-0.5]: string;
        [-0.75]: string;
        [-1.25]: string;
        [-1.5]: string;
        [-2.5]: string;
        [-3.5]: string;
        [-4]: string;
        [-8]: string;
        px: string;
        em: string;
    };
    brightness: Record<"0" | "50" | "75" | "90" | "95" | "100" | "105" | "110" | "125" | "150" | "200", string>;
    colors: {
        black: string;
        white: string;
        'white-darken': string;
        main: string;
        'main-darken': string;
        brand: string;
        outline: string;
        danger: string;
        'danger-darken': string;
        'warning-yellow': string;
        'warning-yellow-darken': string;
        grey: {
            DEFAULT: string;
            5: string;
            6: string;
            7: string;
            9: string;
            20: string;
            30: string;
            65: string;
            100: string;
        };
        transparency: {
            15: string;
            30: string;
            50: string;
        };
        inherit: string;
        transparent: string;
        current: string;
    };
    contrast: Record<"0" | "50" | "75" | "100" | "125" | "150" | "200", string>;
    gradientColorStops: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    grayscale: Record<"0" | "DEFAULT", string>;
    hueRotate: Record<"0" | "15" | "90" | "30" | "60" | "180", string>;
    saturate: Record<"0" | "50" | "100" | "150" | "200", string>;
    sepia: Record<"0" | "DEFAULT", string>;
    skew: Record<"0" | "1" | "2" | "3" | "6" | "12", string>;
    divideWidth: import("tailwindcss/types/config").KeyValuePair<string, string>;
    divideColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    divideOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    borderOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backgroundOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    textColor: {
        main: any;
        black: any;
        white: any;
        'white-darken': any;
        disabled: any;
        link: string;
        grey: any;
        danger: any;
        inherit: string;
        transparent: string;
    };
    textOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    placeholderColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    placeholderOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    boxShadowColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    ringWidth: Record<"0" | "1" | "2" | "4" | "8" | "DEFAULT", string>;
    ringColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    ringOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    ringOffsetWidth: Record<"0" | "1" | "2" | "4" | "8", string>;
    ringOffsetColor: import("tailwindcss/types/config").RecursiveKeyValuePair<string, string>;
    dropShadow: Record<"none" | "sm" | "DEFAULT" | "md" | "lg" | "xl" | "2xl", string | string[]>;
    backdropBlur: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropBrightness: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropContrast: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropGrayscale: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropHueRotate: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropInvert: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropOpacity: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropSaturate: import("tailwindcss/types/config").KeyValuePair<string, string>;
    backdropSepia: import("tailwindcss/types/config").KeyValuePair<string, string>;
    screens: Record<"sm" | "md" | "lg" | "xl" | "2xl", string>;
    keyframes: Record<"ping" | "spin" | "pulse" | "bounce", Record<string, import("tailwindcss/types/generated/default-theme").CSSDeclarationList>> & {
        'loader-line-full-unfill-rotate': {
            '12.5%': {
                transform: string;
            };
            '25%': {
                transform: string;
            };
            '37.5%': {
                transform: string;
            };
            '50%': {
                transform: string;
            };
            '62.5%': {
                transform: string;
            };
            '75%': {
                transform: string;
            };
            '87.5%': {
                transform: string;
            };
            to: {
                transform: string;
            };
        };
        'loader-line1-fade-in-out': {
            '0%': {
                opacity: string;
            };
            '25%': {
                opacity: string;
            };
            '26%': {
                opacity: string;
            };
            '89%': {
                opacity: string;
            };
            '90%': {
                opacity: string;
            };
            to: {
                opacity: string;
            };
        };
        'loader-line2-fade-in-out': {
            '0%': {
                opacity: string;
            };
            '15%': {
                opacity: string;
            };
            '25%': {
                opacity: string;
            };
            '50%': {
                opacity: string;
            };
            '51%': {
                opacity: string;
            };
        };
        'loader-line3-fade-in-out': {
            '0%': {
                opacity: string;
            };
            '40%': {
                opacity: string;
            };
            '50%': {
                opacity: string;
            };
            '75%': {
                opacity: string;
            };
            '76%': {
                opacity: string;
            };
        };
        'loader-line4-fade-in-out': {
            '0%': {
                opacity: string;
            };
            '65%': {
                opacity: string;
            };
            '75%': {
                opacity: string;
            };
            '90%': {
                opacity: string;
            };
            to: {
                opacity: string;
            };
        };
        'loader-left-spin': {
            '0%, 100%': {
                transform: string;
            };
            '50%': {
                transform: string;
            };
        };
        'loader-right-spin': {
            '0%, 100%': {
                transform: string;
            };
            '50%': {
                transform: string;
            };
        };
        'notification-bar-slide-in': {
            from: {
                opacity: string;
                transform: string;
            };
            to: {
                opacity: string;
                transform: string;
            };
        };
        'flash-message-bounce': {
            'from, 20%, 53%, 80%, to': {
                'animation-timing-function': string;
                transform: string;
            };
            '40%, 43%': {
                'animation-timing-function': string;
                transform: string;
            };
            '70%': {
                'animation-timing-function': string;
                transform: string;
            };
            '90%': {
                transform: string;
            };
        };
    };
};
