"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccordionPanelContent = void 0;
const react_1 = __importStar(require("react"));
const react_transition_group_1 = require("react-transition-group");
const tailwind_variants_1 = require("tailwind-variants");
const map_1 = require("../../libs/map");
const AccordionPanel_1 = require("./AccordionPanel");
const AccordionPanelItem_1 = require("./AccordionPanelItem");
const accordionPanelContent = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-AccordionPanel-content',
        'shr-max-h-0',
        'shr-transition-[max-height,_visible,_opacity]',
        'shr-duration-150',
        'shr-ease-in-out',
        'shr-invisible',
        'shr-opacity-0',
        '[&.entered]:shr-max-h-[revert]',
        '[&.entered]:shr-visible',
        '[&.entered]:shr-opacity-100',
    ],
});
const AccordionPanelContent = ({ className, ...props }) => {
    const { name } = (0, react_1.useContext)(AccordionPanelItem_1.AccordionPanelItemContext);
    const { expandedItems } = (0, react_1.useContext)(AccordionPanel_1.AccordionPanelContext);
    const isInclude = (0, map_1.getIsInclude)(expandedItems, name);
    const wrapperRef = (0, react_1.useRef)(null);
    const styles = (0, react_1.useMemo)(() => accordionPanelContent({ className }), [className]);
    return (react_1.default.createElement(react_transition_group_1.Transition, { in: isInclude, timeout: 150 }, (status) => (react_1.default.createElement("div", { ...props, id: `${name}-content`, className: `${styles} ${status}`, "aria-labelledby": `${name}-trigger`, "aria-hidden": !isInclude, ref: wrapperRef }))));
};
exports.AccordionPanelContent = AccordionPanelContent;
//# sourceMappingURL=AccordionPanelContent.js.map