"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccordionPanelTrigger = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const map_1 = require("../../libs/map");
const Heading_1 = require("../Heading");
const Icon_1 = require("../Icon");
const Layout_1 = require("../Layout");
const AccordionPanel_1 = require("./AccordionPanel");
const AccordionPanelItem_1 = require("./AccordionPanelItem");
const accordionPanelHelper_1 = require("./accordionPanelHelper");
const accordionPanelTrigger = (0, tailwind_variants_1.tv)({
    slots: {
        title: 'shr-grow',
        button: [
            'smarthr-ui-AccordionPanel-trigger',
            'shr-group',
            'shr-bg-transparent',
            'shr-border-none',
            'shr-appearance-none',
            'shr-w-full',
            'shr-px-1',
            'shr-py-0.75',
            'shr-cursor-pointer',
            'shr-text-inherit',
            'shr-text-left',
            'hover:shr-bg-white-darken',
            'hover:shr-shadow-none',
            'focus-visible:shr-focus-indicator',
        ],
        leftIcon: 'shr-transition-transform shr-duration-100 group-aria-expanded:shr-rotate-90',
        rightIcon: 'group-aria-expanded:-shr-rotate-180',
    },
    compoundSlots: [
        {
            slots: ['leftIcon', 'rightIcon'],
            className: 'group-aria-expanded:shrink-0',
        },
    ],
});
const AccordionPanelTrigger = ({ children, className, headingType = 'blockTitle', headingTag, ...props }) => {
    const { titleStyle, buttonStyle, leftIconStyle, rightIconStyle } = (0, react_1.useMemo)(() => {
        const { title, button, leftIcon, rightIcon } = accordionPanelTrigger();
        return {
            titleStyle: title(),
            buttonStyle: button({ className }),
            leftIconStyle: leftIcon(),
            rightIconStyle: rightIcon(),
        };
    }, [className]);
    const { name } = (0, react_1.useContext)(AccordionPanelItem_1.AccordionPanelItemContext);
    const { iconPosition, displayIcon, expandedItems, onClickTrigger, onClickProps, expandableMultiply, } = (0, react_1.useContext)(AccordionPanel_1.AccordionPanelContext);
    const isExpanded = (0, map_1.getIsInclude)(expandedItems, name);
    const handleClick = (0, react_1.useCallback)(() => {
        if (onClickTrigger)
            onClickTrigger(name, !isExpanded);
        if (onClickProps) {
            const newExpandedItems = (0, accordionPanelHelper_1.getNewExpandedItems)(expandedItems, name, !isExpanded, expandableMultiply);
            onClickProps((0, map_1.mapToKeyArray)(newExpandedItems));
        }
    }, [onClickTrigger, name, isExpanded, onClickProps, expandedItems, expandableMultiply]);
    return (
    // eslint-disable-next-line smarthr/a11y-heading-in-sectioning-content
    react_1.default.createElement(Heading_1.Heading, { tag: headingTag, type: headingType },
        react_1.default.createElement("button", { ...props, id: `${name}-trigger`, "aria-expanded": isExpanded, "aria-controls": `${name}-content`, onClick: handleClick, className: buttonStyle, "data-component": "AccordionHeaderButton", type: "button" },
            react_1.default.createElement(Layout_1.Cluster, { className: "shr-flex-nowrap", align: "center", as: "span" },
                displayIcon && iconPosition === 'left' && react_1.default.createElement(Icon_1.FaCaretRightIcon, { className: leftIconStyle }),
                react_1.default.createElement("span", { className: titleStyle }, children),
                displayIcon && iconPosition === 'right' && (react_1.default.createElement(Icon_1.FaCaretDownIcon, { className: rightIconStyle }))))));
};
exports.AccordionPanelTrigger = AccordionPanelTrigger;
//# sourceMappingURL=AccordionPanelTrigger.js.map