import { ComponentPropsWithoutRef, FC, PropsWithChildren, ReactNode } from 'react';
import { AppNaviAnchorProps } from './AppNaviAnchor';
import { AppNaviButtonProps } from './AppNaviButton';
import { AppNaviCustomTagProps } from './AppNaviCustomTag';
import { AppNaviDropdownProps } from './AppNaviDropdown';
type ElementProps = Omit<ComponentPropsWithoutRef<'div'>, keyof Props>;
type Props = PropsWithChildren<{
    /** ラベルのテキスト */
    label?: ReactNode;
    /** 表示するボタンの Props の配列 */
    buttons?: Array<AppNaviButtonProps | AppNaviAnchorProps | AppNaviDropdownProps | AppNaviCustomTagProps>;
    /** ドロップダウンにキャレットを表示するかどうか */
    displayDropdownCaret?: boolean;
}>;
export declare const AppNavi: FC<Props & ElementProps>;
export {};
