"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppNavi = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const SectioningContent_1 = require("../SectioningContent");
const StatusLabel_1 = require("../StatusLabel");
const AppNaviAnchor_1 = require("./AppNaviAnchor");
const AppNaviButton_1 = require("./AppNaviButton");
const AppNaviCustomTag_1 = require("./AppNaviCustomTag");
const AppNaviDropdown_1 = require("./AppNaviDropdown");
const appNavi = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-AppNavi',
            'shr-flex shr-min-w-max shr-items-center shr-bg-white shr-px-1.5 shr-shadow-layer-1',
        ],
        statusLabel: ['smarthr-ui-AppNavi-label', 'shr-me-1'],
        buttonsEl: [
            'smarthr-ui-AppNavi-buttons',
            'shr-flex shr-items-stretch shr-gap-1 shr-self-stretch',
        ],
        listItem: ['smarthr-ui-AppNavi-listItem', 'shr-list-none'],
    },
});
const AppNavi = ({ label, buttons, className, children, displayDropdownCaret = false, ...props }) => {
    const { wrapperStyle, statusLabelStyle, buttonsStyle, listItemStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, statusLabel, buttonsEl, listItem } = appNavi();
        return {
            wrapperStyle: wrapper({ className }),
            statusLabelStyle: statusLabel(),
            buttonsStyle: buttonsEl(),
            listItemStyle: listItem(),
        };
    }, [className]);
    return (
    // eslint-disable-next-line smarthr/a11y-heading-in-sectioning-content
    react_1.default.createElement(SectioningContent_1.Nav, { ...props, className: wrapperStyle },
        label && react_1.default.createElement(StatusLabel_1.StatusLabel, { className: statusLabelStyle }, label),
        buttons && (react_1.default.createElement("ul", { className: buttonsStyle }, buttons.map((button, i) => {
            if ('tag' in button) {
                return (react_1.default.createElement("li", { key: i, className: listItemStyle },
                    react_1.default.createElement(AppNaviCustomTag_1.AppNaviCustomTag, { ...button })));
            }
            if ('href' in button) {
                return (react_1.default.createElement("li", { key: i, className: listItemStyle },
                    react_1.default.createElement(AppNaviAnchor_1.AppNaviAnchor, { ...button })));
            }
            if ('dropdownContent' in button) {
                return (react_1.default.createElement("li", { key: i, className: listItemStyle },
                    react_1.default.createElement(AppNaviDropdown_1.AppNaviDropdown, { ...button, displayCaret: displayDropdownCaret })));
            }
            return (react_1.default.createElement("li", { key: i, className: listItemStyle },
                react_1.default.createElement(AppNaviButton_1.AppNaviButton, { ...button })));
        }))),
        children));
};
exports.AppNavi = AppNavi;
//# sourceMappingURL=AppNavi.js.map