"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppNaviDropdown = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Dropdown_1 = require("../Dropdown");
const Icon_1 = require("../Icon");
const style_1 = require("./style");
const appNaviDropdown = (0, tailwind_variants_1.tv)({
    extend: style_1.appNaviItemStyle,
    variants: {
        displayCaret: {
            true: {
                wrapper: [
                    'smarthr-ui-AppNavi-dropdown',
                    '[&[aria-expanded="true"]_.smarthr-ui-Icon:last-child]:shr-rotate-180',
                ],
            },
        },
        active: {
            true: {
                wrapper: 'shr-cursor-pointer',
            },
        },
    },
});
const AppNaviDropdown = ({ children, dropdownContent, icon: Icon, current = false, displayCaret, }) => {
    const { wrapperStyle, iconStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, icon } = appNaviDropdown({ active: current, displayCaret });
        return {
            wrapperStyle: wrapper(),
            iconStyle: icon(),
        };
    }, [current, displayCaret]);
    return (react_1.default.createElement(Dropdown_1.Dropdown, null,
        react_1.default.createElement(Dropdown_1.DropdownTrigger, null,
            react_1.default.createElement(Button_1.UnstyledButton, { "aria-current": current ? 'page' : undefined, className: wrapperStyle },
                Icon && react_1.default.createElement(Icon, { className: iconStyle }),
                children,
                displayCaret && react_1.default.createElement(Icon_1.FaCaretDownIcon, null))),
        react_1.default.createElement(Dropdown_1.DropdownContent, null, dropdownContent)));
};
exports.AppNaviDropdown = AppNaviDropdown;
//# sourceMappingURL=AppNaviDropdown.js.map