"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Badge = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Text_1 = require("../Text");
const badge = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-Badge shr-relative shr-inline-flex',
        pill: ['shr-h-[1.75em] shr-min-w-[1.75em] shr-px-[0.5em] shr-tabular-nums'],
        dotElement: ['shr-h-[0.625em] shr-w-[0.625em]'],
    },
    variants: {
        color: {
            grey: {},
            blue: {},
            yellow: {},
            red: {},
        },
        withChildren: {
            true: {},
        },
    },
    compoundSlots: [
        {
            slots: ['pill', 'dotElement'],
            className: [
                'shr-box-border shr-flex shr-items-center shr-justify-center',
                'shr-rounded-full',
            ],
        },
        {
            slots: ['pill', 'dotElement'],
            withChildren: true,
            className: [
                'shr-absolute -shr-translate-y-1/2 shr-translate-x-1/2 [inset-block-start:0] [inset-inline-end:0]',
            ],
        },
        {
            slots: ['pill', 'dotElement'],
            color: 'blue',
            className: 'shr-bg-main',
        },
        {
            slots: ['pill', 'dotElement'],
            color: 'yellow',
            className: 'shr-bg-warning-yellow',
        },
        {
            slots: ['pill', 'dotElement'],
            color: 'red',
            className: 'shr-bg-danger',
        },
        {
            slots: ['pill', 'dotElement'],
            color: 'grey',
            className: 'shr-bg-[theme(colors.grey.65)]',
        },
        {
            slots: ['pill', 'dotElement'],
            color: ['grey', 'blue', 'red'],
            className: 'shr-shadow-[0_0_0_1px_theme(colors.white)]',
        },
        {
            slots: ['pill', 'dotElement'],
            color: 'yellow',
            className: 'shr-shadow-[0_0_0_1px_theme(colors.black)]',
        },
        {
            slots: ['pill'],
            color: ['grey', 'blue', 'red'],
            className: 'shr-text-white',
        },
        {
            slots: ['pill'],
            color: ['yellow'],
            className: 'shr-text-black',
        },
    ],
});
const Badge = ({ count, overflowCount = 99, showZero = false, type = 'blue', dot = false, children, className, ...props }) => {
    const actualCount = count && count > 0 ? count : showZero ? 0 : undefined;
    const { wrapperStyle, pillStyle, dotStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, pill, dotElement } = badge({ color: type, withChildren: !!children });
        return {
            wrapperStyle: wrapper({ className }),
            pillStyle: pill(),
            dotStyle: dotElement(),
        };
    }, [children, className, type]);
    // ドット表示でもなく、0値を表示するでもない場合は何も表示しない
    if (!dot && !children && actualCount === undefined)
        return null;
    return (react_1.default.createElement("span", { ...props, className: wrapperStyle },
        children,
        dot ? (react_1.default.createElement("span", { className: dotStyle })) : (actualCount !== undefined && (react_1.default.createElement(Text_1.Text, { size: "XS", className: pillStyle }, actualCount > overflowCount ? `${overflowCount}+` : actualCount)))));
};
exports.Badge = Badge;
//# sourceMappingURL=Badge.js.map