"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Balloon = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
// HINT: trianble部分はRetinaディスプレイなどで途切れてしまう場合があるので
// 1pxほど大きめに描画してbody部分と被るようにしています。
const balloon = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-Balloon',
        'shr-relative',
        'shr-inline-block',
        'shr-text-sm',
        'shr-rounded-s',
        /* drop-shadow は spread-radius を受け付けないので shadow.LAYER2 に近い値をハードコーディングしている */
        'shr-drop-shadow-[0_2px_2.5px_theme(colors.transparency.30)]',
        'shr-whitespace-nowrap',
        'shr-bg-white',
        'shr-text-black',
        'after:shr-block',
        'after:shr-absolute',
        'after:shr-content-[""]',
        'after:shr-bg-white',
        'contrast-more:shr-border-shorthand',
        'contrast-more:shr-border-high-contrast',
        'contrast-more:before:shr-block',
        'contrast-more:before:shr-absolute',
        'contrast-more:before:shr-content-[""]',
        'contrast-more:before:shr-bg-black',
    ],
    variants: {
        horizontal: {
            center: [
                'before:shr-left-1/2',
                'before:-shr-translate-x-[5px]',
                'after:shr-left-1/2',
                'after:-shr-translate-x-[5px]',
            ],
            right: '',
            left: '',
        },
        vertical: {
            top: [
                'before:-shr-top-[5px]',
                'before:shr-w-[10px]',
                'before:shr-h-[5px]',
                'before:[clip-path:polygon(50%_0,100%_100%,0_100%)]',
                'after:-shr-top-0.25',
                'after:shr-w-[10px]',
                'after:shr-h-[5px]',
                'after:[clip-path:polygon(50%_0,100%_100%,0_100%)]',
            ],
            bottom: [
                'before:-shr-bottom-[5px]',
                'before:shr-w-[10px]',
                'before:shr-h-[5px]',
                'before:[clip-path:polygon(0_0,100%_0,50%_100%)]',
                'after:-shr-bottom-0.25',
                'after:shr-w-[10px]',
                'after:shr-h-[5px]',
                'after:[clip-path:polygon(0_0,100%_0,50%_100%)]',
            ],
            middle: [
                'before:shr-top-1/2',
                'before:-shr-translate-y-[5px]',
                'after:shr-top-1/2',
                'after:-shr-translate-y-[5px]',
            ],
        },
    },
    compoundVariants: [
        {
            vertical: ['top', 'bottom'],
            horizontal: 'left',
            className: ['before:shr-left-1.5', 'after:shr-left-1.5'],
        },
        {
            vertical: ['top', 'bottom'],
            horizontal: 'right',
            className: ['before:shr-right-1.5', 'after:shr-right-1.5'],
        },
        {
            vertical: 'middle',
            horizontal: 'left',
            className: [
                'before:-shr-left-[5px]',
                'before:shr-w-[5px]',
                'before:shr-h-[10px]',
                'before:[clip-path:polygon(100%_0,100%_100%,0_50%)]',
                'after:-shr-left-0.25',
                'after:shr-w-[5px]',
                'after:shr-h-[10px]',
                'after:[clip-path:polygon(100%_0,100%_100%,0_50%)]',
            ],
        },
        {
            vertical: 'middle',
            horizontal: 'right',
            className: [
                'before:-shr-right-[5px]',
                'before:shr-w-[5px]',
                'before:shr-h-[10px]',
                'before:[clip-path:polygon(0_0,100%_50%,0_100%)]',
                'after:-shr-right-0.25',
                'after:shr-w-[5px]',
                'after:shr-h-[10px]',
                'after:[clip-path:polygon(0_0,100%_50%,0_100%)]',
            ],
        },
    ],
});
const Balloon = ({ horizontal, vertical, className, as: Component = 'div', ...props }) => {
    const styles = (0, react_1.useMemo)(() => balloon({ horizontal, vertical, className }), [className, horizontal, vertical]);
    return react_1.default.createElement(Component, { ...props, className: styles });
};
exports.Balloon = Balloon;
//# sourceMappingURL=Balloon.js.map