"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Base = exports.layerMap = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useSectioningWrapper_1 = require("../SectioningContent/useSectioningWrapper");
const base = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-Base shr-bg-white forced-colors:shr-border-shorthand contrast-more:shr-border-high-contrast',
    variants: {
        paddingBlock: {
            0: 'shr-py-0',
            0.25: 'shr-py-0.25',
            0.5: 'shr-py-0.5',
            0.75: 'shr-py-0.75',
            1: 'shr-py-1',
            1.25: 'shr-py-1.25',
            1.5: 'shr-py-1.5',
            2: 'shr-py-2',
            2.5: 'shr-py-2.5',
            3: 'shr-py-3',
            3.5: 'shr-py-3.5',
            4: 'shr-py-4',
            8: 'shr-py-8',
            X3S: 'shr-py-0.25',
            XXS: 'shr-py-0.5',
            XS: 'shr-py-1',
            S: 'shr-py-1.5',
            M: 'shr-py-2',
            L: 'shr-py-2.5',
            XL: 'shr-py-3',
            XXL: 'shr-py-3.5',
            X3L: 'shr-py-4',
        },
        paddingInline: {
            0: 'shr-px-0',
            0.25: 'shr-px-0.25',
            0.5: 'shr-px-0.5',
            0.75: 'shr-px-0.75',
            1: 'shr-px-1',
            1.25: 'shr-px-1.25',
            1.5: 'shr-px-1.5',
            2: 'shr-px-2',
            2.5: 'shr-px-2.5',
            3: 'shr-px-3',
            3.5: 'shr-px-3.5',
            4: 'shr-px-4',
            8: 'shr-px-8',
            X3S: 'shr-px-0.25',
            XXS: 'shr-px-0.5',
            XS: 'shr-px-1',
            S: 'shr-px-1.5',
            M: 'shr-px-2',
            L: 'shr-px-2.5',
            XL: 'shr-px-3',
            XXL: 'shr-px-3.5',
            X3L: 'shr-px-4',
        },
        radius: {
            s: 'shr-rounded-m',
            m: 'shr-rounded-l',
        },
        overflowBlock: {
            visible: 'shr-overflow-y-visible',
            hidden: 'shr-overflow-y-hidden',
            clip: 'shr-overflow-y-clip',
            scroll: 'shr-overflow-y-scroll',
            auto: 'shr-overflow-y-auto',
        },
        overflowInline: {
            visible: 'shr-overflow-x-visible',
            hidden: 'shr-overflow-x-hidden',
            clip: 'shr-overflow-x-clip',
            scroll: 'shr-overflow-x-scroll',
            auto: 'shr-overflow-x-auto',
        },
        layer: {
            0: 'shr-shadow-layer-0',
            1: 'shr-shadow-layer-1',
            2: 'shr-shadow-layer-2',
            3: 'shr-shadow-layer-3',
            4: 'shr-shadow-layer-4',
        },
    },
});
exports.layerMap = {
    0: 'LAYER0',
    1: 'LAYER1',
    2: 'LAYER2',
    3: 'LAYER3',
    4: 'LAYER4',
};
exports.Base = (0, react_1.forwardRef)(({ padding, radius = 'm', overflow, layer = 1, as: Component = 'div', className, ...props }, ref) => {
    const styles = (0, react_1.useMemo)(() => {
        const paddingBlock = padding instanceof Object ? padding.block : padding;
        const paddingInline = padding instanceof Object ? padding.inline : padding;
        const overflowBlock = overflow instanceof Object ? overflow.y : overflow;
        const overflowInline = overflow instanceof Object ? overflow.x : overflow;
        return base({
            paddingBlock,
            paddingInline,
            radius,
            overflowBlock,
            overflowInline,
            layer,
            className,
        });
    }, [className, layer, overflow, padding, radius]);
    const Wrapper = (0, useSectioningWrapper_1.useSectionWrapper)(Component);
    return (react_1.default.createElement(Wrapper, null,
        react_1.default.createElement(Component, { ...props, ref: ref, className: styles })));
});
//# sourceMappingURL=Base.js.map