"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseColumn = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Base_1 = require("../Base");
const baseColumn = (0, tailwind_variants_1.tv)({
    base: '[&&&]:shr-rounded-[unset]',
    variants: {
        bgColor: {
            BACKGROUND: '[&&&]:shr-bg-background',
            COLUMN: '[&&&]:shr-bg-column',
            BASE_GREY: '[&&&]:shr-bg-base-grey',
            OVER_BACKGROUND: '[&&&]:shr-bg-over-background',
            HEAD: '[&&&]:shr-bg-head',
            BORDER: '[&&&]:shr-bg-[theme(colors.grey.20)]',
            ACTION_BACKGROUND: '[&&&]:shr-bg-action-background',
            WHITE: '[&&&]:shr-bg-white',
            GREY_5: '[&&&]:shr-bg-[theme(colors.grey.5)]',
            GREY_6: '[&&&]:shr-bg-[theme(colors.grey.6)]',
            GREY_7: '[&&&]:shr-bg-[theme(colors.grey.7)]',
            GREY_9: '[&&&]:shr-bg-[theme(colors.grey.9)]',
            GREY_20: '[&&&]:shr-bg-[theme(colors.grey.20)]',
            GREY_30: '[&&&]:shr-bg-[theme(colors.grey.30)]',
            GREY_65: '[&&&]:shr-bg-[theme(colors.grey.65)]',
            GREY_100: '[&&&]:shr-bg-[theme(colors.grey.100)]',
        },
    },
    defaultVariants: {
        bgColor: 'COLUMN',
    },
});
const BaseColumn = ({ bgColor, padding = 1, className, ...props }) => {
    const styles = (0, react_1.useMemo)(() => baseColumn({ bgColor, className }), [bgColor, className]);
    return react_1.default.createElement(Base_1.Base, { ...props, padding: padding, layer: 0, className: styles });
};
exports.BaseColumn = BaseColumn;
//# sourceMappingURL=BaseColumn.js.map