"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BottomFixedArea = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Base_1 = require("../Base");
const Button_1 = require("../Button");
const Layout_1 = require("../Layout");
const bottomFixedAreaHelper_1 = require("./bottomFixedAreaHelper");
const bottomFixedArea = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-BottomFixedArea',
            'shr-fixed shr-bottom-0 shr-z-fixed-menu shr-box-border shr-w-full shr-rounded-none shr-p-1.5 shr-text-center',
            // Layer 3 だが、上方向への指定のためベタ書き： https://smarthr.design/products/design-tokens/shadow/
            '[box-shadow:_0_-4px_8px_2px_rgba(0,_0,_0,_0.24)]',
            '[&_ul]:shr-list-none',
        ],
        tertiaryButton: [
            'smarthr-ui-BottomFixedArea-tertiaryLink',
            '-shr-mb-0.5 shr-font-normal shr-text-main',
        ],
    },
});
const BottomFixedArea = ({ description, primaryButton, secondaryButton, tertiaryLinks, zIndex, className, ...props }) => {
    const { wrapperStyleProps, tertiaryButtonStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, tertiaryButton } = bottomFixedArea();
        return {
            wrapperStyleProps: { className: wrapper({ className }), style: { zIndex } },
            tertiaryButtonStyle: tertiaryButton(),
        };
    }, [className, zIndex]);
    (0, react_1.useEffect)(() => {
        (0, bottomFixedAreaHelper_1.validateElement)(primaryButton, secondaryButton);
    }, [primaryButton, secondaryButton]);
    return (react_1.default.createElement(Base_1.Base, { ...props, ...wrapperStyleProps },
        react_1.default.createElement(Layout_1.Stack, null,
            description && react_1.default.createElement("p", { className: "smarthr-ui-BottomFixedArea-description" }, description),
            react_1.default.createElement(Layout_1.Stack, { gap: 0.25 },
                (secondaryButton || primaryButton) && (react_1.default.createElement(Layout_1.Cluster, { as: "ul", justify: "center", gap: { row: 0.5, column: 1 } },
                    secondaryButton && (react_1.default.createElement("li", { className: "smarthr-ui-BottomFixedArea-secondaryButton" }, secondaryButton)),
                    primaryButton && (react_1.default.createElement("li", { className: "smarthr-ui-BottomFixedArea-primaryButton" }, primaryButton)))),
                tertiaryLinks && tertiaryLinks.length > 0 && (react_1.default.createElement(Layout_1.Cluster, { as: "ul", justify: "center", gap: { row: 0.5, column: 0 } }, tertiaryLinks.map(({ text, icon: Icon, onClick, ...tertiaryProps }, index) => (react_1.default.createElement("li", { key: index, className: "smarthr-ui-BottomFixedArea-tertiaryListItem" },
                    react_1.default.createElement(Button_1.Button, { ...tertiaryProps, variant: "text", prefix: Icon && react_1.default.createElement(Icon, null), onClick: onClick, className: tertiaryButtonStyle }, text))))))))));
};
exports.BottomFixedArea = BottomFixedArea;
//# sourceMappingURL=BottomFixedArea.js.map