"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarTable = void 0;
const dayjs_1 = __importDefault(require("dayjs"));
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const calendarHelper_1 = require("./calendarHelper");
const calendarTable = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'shr-px-0.75 shr-pb-1 shr-pt-0.25',
        table: 'smarthr-ui-CalendarTable shr-border-spacing-0 shr-text-base shr-text-black',
        th: 'smarthr-ui-CalendarTable-headCell shr-px-0 shr-py-0.5 shr-text-center shr-align-middle shr-font-normal shr-text-grey',
        td: 'smarthr-ui-CalendarTable-dataCell shr-p-0 shr-align-middle',
        cellButton: 'shr-group shr-flex shr-items-center shr-justify-center shr-px-0.5 shr-py-0.25 disabled:shr-cursor-not-allowed disabled:shr-text-disabled [&&&]:shr-cursor-pointer',
        dateCell: 'shr-box-border shr-flex shr-h-[1.75rem] shr-w-[1.75rem] shr-items-center shr-justify-center shr-rounded-[50%] shr-leading-[0] group-[:not(:disabled)]:group-hover:shr-bg-base-grey group-[:not(:disabled)]:group-hover:shr-text-black',
    },
    variants: {
        isToday: {
            true: {
                dateCell: 'shr-border-shorthand contrast-more:shr-border-high-contrast',
            },
        },
        isSelected: {
            true: {
                dateCell: '[&&&&]:shr-bg-main [&&&&]:shr-text-white',
            },
        },
    },
});
const CalendarTable = ({ current, from, to, onSelectDate, selected, className, ...props }) => {
    const { wrapper, table, th, td, cellButton, dateCell } = calendarTable();
    const { wrapperStyle, tableStyle, thStyle, tdStyle, cellButtonStyle } = (0, react_1.useMemo)(() => ({
        wrapperStyle: wrapper({ className }),
        tableStyle: table(),
        thStyle: th(),
        tdStyle: td(),
        cellButtonStyle: cellButton(),
    }), [cellButton, className, table, td, th, wrapper]);
    const currentDay = (0, dayjs_1.default)(current);
    const selectedDay = selected ? (0, dayjs_1.default)(selected) : null;
    const now = (0, dayjs_1.default)().startOf('date');
    const fromDay = (0, dayjs_1.default)(from);
    const toDay = (0, dayjs_1.default)(to);
    const array = (0, calendarHelper_1.getMonthArray)(currentDay.toDate());
    return (react_1.default.createElement("div", { className: wrapperStyle },
        react_1.default.createElement("table", { ...props, className: tableStyle },
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null, calendarHelper_1.daysInWeek.map((day, i) => (react_1.default.createElement("th", { key: i, className: thStyle }, day))))),
            react_1.default.createElement("tbody", null, array.map((week, weekIndex) => (react_1.default.createElement("tr", { key: weekIndex }, week.map((date, dateIndex) => {
                const isOutRange = !date ||
                    !(0, calendarHelper_1.isBetween)(currentDay.date(date).toDate(), fromDay.toDate(), toDay.toDate());
                const isSelectedDate = !!date && !!selectedDay && currentDay.date(date).isSame(selectedDay, 'date');
                return (react_1.default.createElement("td", { key: dateIndex, className: tdStyle }, date && (react_1.default.createElement(Button_1.UnstyledButton, { disabled: isOutRange, onClick: (e) => !isOutRange && onSelectDate(e, currentDay.date(date).toDate()), "aria-pressed": isSelectedDate, type: "button", className: cellButtonStyle },
                    react_1.default.createElement("span", { className: dateCell({
                            isToday: currentDay.date(date).isSame(now, 'date'),
                            isSelected: isSelectedDate,
                        }) }, date)))));
            }))))))));
};
exports.CalendarTable = CalendarTable;
//# sourceMappingURL=CalendarTable.js.map