"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.YearPicker = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const yearPicker = (0, tailwind_variants_1.tv)({
    slots: {
        overlay: 'smarthr-ui-YearPicker shr-absolute shr-inset-0 shr-bg-white',
        container: 'shr-box-border shr-flex shr-h-full shr-w-full shr-flex-wrap shr-items-start shr-overflow-y-auto shr-px-0.25 shr-py-0.5',
        yearButton: 'smarthr-ui-YearPicker-selectYear shr-group shr-flex shr-w-1/4 shr-cursor-pointer shr-items-center shr-justify-center shr-px-0 shr-py-0.5 shr-leading-none',
        yearWrapper: 'shr-box-border shr-inline-block shr-rounded-full shr-px-0.75 shr-py-0.5 shr-text-base shr-leading-none group-hover:shr-bg-base-grey group-hover:shr-text-black',
    },
    variants: {
        isDisplayed: {
            false: {
                overlay: 'shr-hidden',
            },
        },
        isThisYear: {
            true: {
                yearWrapper: 'shr-border-shorthand',
            },
        },
        isSelected: {
            true: {
                yearWrapper: 'shr-bg-main shr-text-white',
            },
        },
    },
});
const YearPicker = ({ selectedYear, fromYear, toYear, onSelectYear, isDisplayed, id, ...props }) => {
    const { overlay, container, yearButton, yearWrapper } = yearPicker();
    const { overlayStyle, containerStyle, yearButtonStyle } = (0, react_1.useMemo)(() => ({
        overlayStyle: overlay({ isDisplayed }),
        containerStyle: container(),
        yearButtonStyle: yearButton(),
    }), [container, isDisplayed, overlay, yearButton]);
    const focusingRef = (0, react_1.useRef)(null);
    const thisYear = new Date().getFullYear();
    const numOfYear = Math.max(Math.min(toYear, 9999) - fromYear + 1, 0);
    const yearArray = Array(numOfYear)
        .fill(null)
        .map((_, i) => fromYear + i);
    (0, react_1.useEffect)(() => {
        if (focusingRef.current && isDisplayed) {
            focusingRef.current.focus();
            focusingRef.current.blur();
        }
    }, [isDisplayed]);
    return (react_1.default.createElement("div", { ...props, id: id, className: overlayStyle },
        react_1.default.createElement("div", { className: containerStyle }, yearArray.map((year) => {
            const isThisYear = thisYear === year;
            const isSelectedYear = selectedYear === year;
            return (react_1.default.createElement(Button_1.UnstyledButton, { key: year, onClick: () => onSelectYear(year), "aria-pressed": isSelectedYear, ref: isThisYear ? focusingRef : null, className: yearButtonStyle },
                react_1.default.createElement("span", { className: yearWrapper({ isThisYear, isSelected: isSelectedYear }) }, year)));
        }))));
};
exports.YearPicker = YearPicker;
//# sourceMappingURL=YearPicker.js.map