"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckBox = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useId_1 = require("../../hooks/useId");
const Icon_1 = require("../Icon");
const checkbox = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-CheckBox shr-inline-flex shr-items-baseline',
        box: [
            'shr-border-shorthand shr-pointer-events-none shr-absolute shr-box-border shr-h-full shr-w-full shr-rounded-s shr-bg-white',
            'contrast-more:shr-border-high-contrast',
            /* 強制カラーモードのときは、ブラウザ標準のUIを表示する */
            'forced-colors:shr-hidden',
            'peer-checked:shr-border-main peer-checked:shr-bg-main contrast-more:peer-checked:shr-border-high-contrast',
            'peer-indeterminate:shr-border-main peer-indeterminate:shr-bg-main contrast-more:peer-indeterminate:shr-border-high-contrast',
            'peer-disabled:shr-border-disabled peer-disabled:shr-bg-white-darken',
            'peer-disabled:peer-checked:shr-border-default peer-disabled:peer-checked:shr-bg-border',
            'peer-disabled:peer-indeterminate:shr-border-default peer-disabled:peer-indeterminate:shr-bg-border',
            'peer-focus-visible:shr-focus-indicator',
            'peer-hover:shr-shadow-input-hover',
        ],
        input: [
            'smarthr-ui-CheckBox-checkBox shr-peer shr-absolute shr-left-0 shr-top-0 shr-m-0 shr-h-full shr-w-full shr-cursor-pointer shr-opacity-0 disabled:shr-pointer-events-none',
            /* 強制カラーモードのときは、ブラウザ標準のUIを表示する */
            'forced-colors:shr-static forced-colors:shr-opacity-100',
        ],
        icon: 'shr-fill-current',
        iconWrap: [
            'shr-pointer-events-none shr-absolute shr-left-1/2 shr-top-1/2 shr-inline-block shr-h-[theme(fontSize.2xs)] shr-w-[theme(fontSize.2xs)] -shr-translate-x-1/2 -shr-translate-y-1/2 shr-text-2xs',
            'shr-text-transparent peer-checked:shr-text-white peer-indeterminate:shr-text-white',
            'peer-disabled:peer-indeteminate:shr-text-white-darken peer-disabled:peer-checked:shr-text-white-darken',
            'forced-colors:shr-hidden',
        ],
        innerWrapper: 'shr-relative shr-box-border shr-inline-block shr-h-[theme(fontSize.base)] shr-w-[theme(fontSize.base)] shr-shrink-0 shr-translate-y-[0.125em] shr-leading-none',
        label: [
            'smarthr-ui-CheckBox-label shr-ms-0.5 shr-cursor-pointer shr-text-base shr-leading-tight',
        ],
    },
    variants: {
        disabled: {
            true: {
                label: 'shr-pointer-events-none shr-cursor-not-allowed shr-text-disabled',
            },
        },
        error: {
            true: {
                box: 'shr-border-danger',
            },
            false: {
                box: 'shr-border-default',
            },
        },
    },
    defaultVariants: {
        error: false,
    },
});
exports.CheckBox = (0, react_1.forwardRef)(({ checked, mixed = false, error, onChange, className, children, ...props }, ref) => {
    const { wrapperStyle, innerWrapperStyle, boxStyle, inputStyle, iconWrapStyle, iconStyle, labelStyle, } = (0, react_1.useMemo)(() => {
        const { wrapper, innerWrapper, box, input, iconWrap, icon, label } = checkbox();
        return {
            wrapperStyle: wrapper({ className }),
            innerWrapperStyle: innerWrapper(),
            boxStyle: box({ error }),
            inputStyle: input(),
            iconWrapStyle: iconWrap(),
            iconStyle: icon(),
            labelStyle: label({ disabled: props.disabled }),
        };
    }, [className, error, props.disabled]);
    const handleChange = (0, react_1.useCallback)((e) => {
        if (onChange)
            onChange(e);
    }, [onChange]);
    const inputRef = (0, react_1.useRef)(null);
    (0, react_1.useImperativeHandle)(ref, () => inputRef.current);
    (0, react_1.useEffect)(() => {
        if (inputRef.current) {
            inputRef.current.indeterminate = !!(checked && mixed);
        }
    }, [checked, mixed]);
    const checkBoxId = (0, useId_1.useId)(props.id);
    return (react_1.default.createElement("span", { className: wrapperStyle },
        react_1.default.createElement("span", { className: innerWrapperStyle },
            react_1.default.createElement("input", { ...props, type: "checkbox", id: checkBoxId, checked: checked, onChange: handleChange, className: inputStyle, ref: inputRef, "aria-invalid": error || undefined }),
            react_1.default.createElement("span", { className: boxStyle, "aria-hidden": "true" }),
            react_1.default.createElement("span", { className: iconWrapStyle }, mixed ? react_1.default.createElement(Icon_1.FaMinusIcon, { className: iconStyle }) : react_1.default.createElement(Icon_1.FaCheckIcon, { className: iconStyle }))),
        children && (react_1.default.createElement("label", { className: labelStyle, htmlFor: checkBoxId }, children))));
});
//# sourceMappingURL=CheckBox.js.map