"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListBoxItemButton = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Icon_1 = require("../Icon");
const Text_1 = require("../Text");
const button = (0, tailwind_variants_1.tv)({
    base: [
        'shr-block shr-min-w-full shr-cursor-pointer shr-border-none shr-px-1 shr-py-0.5 shr-text-left shr-text-base shr-leading-tight',
        'aria-selected:shr-text-white',
        'disabled:shr-cursor-not-allowed disabled:shr-text-disabled',
    ],
    variants: {
        active: {
            true: ['shr-bg-white-darken shr-text-inherit', 'aria-selected:shr-bg-main-darken'],
            false: ['shr-bg-white', 'aria-selected:shr-bg-main'],
        },
        new: {
            true: 'smarthr-ui-ComboBox-addButton shr-flex shr-items-center',
            false: 'smarthr-ui-ComboBox-selectButton',
        },
    },
});
const ListBoxItemButton = ({ option, isActive, onAdd, onSelect, onMouseOver, activeRef, }) => {
    const { item, selected, isNew } = option;
    const { label, disabled } = item;
    const handleAdd = (0, react_1.useCallback)(() => {
        onAdd(option);
    }, [onAdd, option]);
    const handleSelect = (0, react_1.useCallback)(() => {
        onSelect(option);
    }, [onSelect, option]);
    const handleMouseOver = (0, react_1.useCallback)(() => {
        onMouseOver(option);
    }, [onMouseOver, option]);
    const buttonStyle = (0, react_1.useMemo)(() => button({
        active: !!isActive,
        new: isNew,
    }), [isActive, isNew]);
    return isNew ? (
    // eslint-disable-next-line smarthr/a11y-clickable-element-has-text
    react_1.default.createElement("button", { type: "button", key: option.id, onClick: handleAdd, onMouseOver: handleMouseOver, id: option.id, role: "option", className: buttonStyle, ref: isActive ? activeRef : undefined },
        react_1.default.createElement(Icon_1.FaPlusCircleIcon, { color: "TEXT_LINK", text: react_1.default.createElement(Text_1.Text, { color: "TEXT_LINK" },
                "\u300C",
                label,
                "\u300D\u3092\u8FFD\u52A0") }))) : (react_1.default.createElement("button", { type: "button", key: option.id, disabled: disabled, onClick: handleSelect, onMouseOver: handleMouseOver, id: option.id, role: "option", className: buttonStyle, "aria-selected": selected, ref: isActive ? activeRef : undefined }, label));
};
const typedMemo = react_1.default.memo;
const Memoized = typedMemo(ListBoxItemButton);
exports.ListBoxItemButton = Memoized;
//# sourceMappingURL=ListBoxItemButton.js.map