"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiSelectedItem = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Chip_1 = require("../Chip");
const Icon_1 = require("../Icon");
const MultiSelectedItemTooltip_1 = require("./MultiSelectedItemTooltip");
const DESTROY_BUTTON_TEXT = '削除';
const multiSelectedItem = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-MultiComboBox-selectedItem shr-flex shr-items-center shr-gap-0.75 shr-leading-normal [&]:shr-rounded-em',
        itemLabel: 'smarthr-ui-MultiComboBox-selectedItemLabel',
        deleteButton: [
            'smarthr-ui-MultiComboBox-deleteButton',
            'shr-group/deleteButton',
            'shr-shrink shr-rounded-full shr-leading-[0] shr-text-black',
            'focus-visible:shr-shadow-[unset]',
        ],
        deleteButtonIcon: 'group-focus-visible/deleteButton:shr-focus-indicator group-focus-visible/deleteButton:shr-rounded-full',
    },
    variants: {
        enableEllipsis: {
            true: {
                itemLabel: 'shr-overflow-hidden shr-overflow-ellipsis shr-whitespace-nowrap',
            },
        },
        disabled: {
            true: {
                deleteButton: 'shr-cursor-not-allowed',
            },
            false: {
                deleteButton: 'shr-cursor-pointer',
            },
        },
    },
});
function MultiSelectedItem({ item, disabled, onDelete, enableEllipsis, buttonRef, decorators, }) {
    const labelRef = (0, react_1.useRef)(null);
    const [needsTooltip, setNeedsTooltip] = (0, react_1.useState)(false);
    const { deletable = true } = item;
    const actualOnDelete = (0, react_1.useCallback)(() => {
        onDelete && onDelete(item);
    }, [item, onDelete]);
    (0, react_1.useEffect)(() => {
        const elem = labelRef.current;
        if (!elem || !enableEllipsis) {
            return;
        }
        if (elem.offsetWidth < elem.scrollWidth) {
            setNeedsTooltip(true);
        }
    }, [enableEllipsis]);
    const { wrapper, itemLabel, deleteButton, deleteButtonIcon } = multiSelectedItem();
    const { wrapperStyle, itemLabelStyle, deleteButtonStyle, deleteButtonIconStyle } = (0, react_1.useMemo)(() => ({
        wrapperStyle: wrapper(),
        itemLabelStyle: itemLabel({ enableEllipsis }),
        deleteButtonStyle: deleteButton({ disabled }),
        deleteButtonIconStyle: deleteButtonIcon(),
    }), [deleteButton, deleteButtonIcon, disabled, enableEllipsis, itemLabel, wrapper]);
    return (react_1.default.createElement(MultiSelectedItemTooltip_1.MultiSelectedItemTooltip, { needsTooltip: needsTooltip, text: item.label },
        react_1.default.createElement(Chip_1.Chip, { disabled: disabled, className: wrapperStyle },
            react_1.default.createElement("span", { className: itemLabelStyle, ref: labelRef }, item.label),
            deletable && (react_1.default.createElement(Button_1.UnstyledButton, { className: deleteButtonStyle, disabled: disabled, onClick: actualOnDelete, onKeyDown: (e) => {
                    if (e.key === 'Enter' || e.key === 'Backspace' || e.key === ' ') {
                        e.stopPropagation();
                        // HINT: イベントの伝播が止まる関係でonClickに設定したonDeleteは実行されない
                        // このタイミングで明示的に削除処理を実行する
                        actualOnDelete();
                    }
                }, ref: buttonRef, tabIndex: -1 },
                react_1.default.createElement(Icon_1.FaTimesCircleIcon, { color: disabled ? 'TEXT_DISABLED' : 'inherit', alt: decorators?.destroyButtonIconAlt?.(DESTROY_BUTTON_TEXT) || DESTROY_BUTTON_TEXT, className: deleteButtonIconStyle }))))));
}
exports.MultiSelectedItem = MultiSelectedItem;
//# sourceMappingURL=MultiSelectedItem.js.map