"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SingleComboBox = void 0;
const react_1 = __importStar(require("react"));
const react_innertext_1 = __importDefault(require("react-innertext"));
const tailwind_variants_1 = require("tailwind-variants");
const useClick_1 = require("../../hooks/useClick");
const useTailwindTheme_1 = require("../../hooks/useTailwindTheme");
const util_1 = require("../../libs/util");
const Button_1 = require("../Button");
const Icon_1 = require("../Icon");
const Input_1 = require("../Input");
const useListBox_1 = require("./useListBox");
const useOptions_1 = require("./useOptions");
const DESTROY_BUTTON_TEXT = '削除';
const singleCombobox = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-SingleComboBox shr-inline-block',
        input: 'smarthr-ui-SingleComboBox-input shr-w-full',
        caretDownLayout: [
            'shr-relative -shr-me-0.5 shr-p-0.5',
            'before:shr-border-0',
            'before:shr-absolute before:shr-inset-x-0 before:shr-inset-y-0.25 before:shr-w-0 before:shr-border-l before:shr-border-solid before:shr-border-default before:shr-content-[""]',
        ],
        caretDownIcon: 'shr-block',
        clearButton: [
            'smarthr-ui-SingleComboBox-clearButton',
            'shr-group/clearButton',
            'shr-me-0.5 shr-cursor-pointer',
            'focus-visible:shr-shadow-none',
        ],
        clearButtonIcon: [
            'shr-block',
            'group-focus-visible/clearButton:shr-focus-indicator group-focus-visible/clearButton:shr-rounded-full',
        ],
    },
    variants: {
        disabled: {
            true: {
                wrapper: 'shr-cursor-not-allowed',
            },
        },
        hidden: {
            true: {
                clearButton: 'shr-hidden',
            },
        },
    },
});
const ActualSingleComboBox = ({ items, selectedItem, defaultItem, name, disabled = false, required = false, prefix, error = false, creatable = false, placeholder = '', dropdownHelpMessage, isLoading, width, dropdownWidth = 'auto', className, onChange, onChangeInput, onAdd, onSelect, onClear, onClearClick, onChangeSelected, onFocus, onBlur, onKeyPress, decorators, inputAttributes, style, ...props }, ref) => {
    const { textColor } = (0, useTailwindTheme_1.useTheme)();
    const outerRef = (0, react_1.useRef)(null);
    const inputRef = (0, react_1.useRef)(null);
    const clearButtonRef = (0, react_1.useRef)(null);
    const [isFocused, setIsFocused] = (0, react_1.useState)(false);
    const [isExpanded, setIsExpanded] = (0, react_1.useState)(false);
    const [inputValue, setInputValue] = (0, react_1.useState)('');
    const [isComposing, setIsComposing] = (0, react_1.useState)(false);
    const [isEditing, setIsEditing] = (0, react_1.useState)(false);
    (0, react_1.useImperativeHandle)(ref, () => inputRef.current);
    const { options } = (0, useOptions_1.useOptions)({
        items,
        selected: selectedItem,
        creatable,
        inputValue,
        isFilteringDisabled: !isEditing,
    });
    const { renderListBox, activeOption, handleKeyDown: handleListBoxKeyDown, listBoxId, listBoxRef, } = (0, useListBox_1.useListBox)({
        options,
        dropdownHelpMessage,
        dropdownWidth,
        onAdd,
        onSelect: (0, react_1.useCallback)((selected) => {
            onSelect && onSelect(selected);
            onChangeSelected && onChangeSelected(selected);
            // HINT: Dropdown系コンポーネント内でComboBoxを使うと、選択肢がportalで表現されている関係上Dropdownが閉じてしまう
            // requestAnimationFrameを追加、処理を遅延させることで正常に閉じる/閉じないの判定を行えるようにする
            requestAnimationFrame(() => {
                setIsExpanded(false);
            });
            setIsEditing(false);
        }, [onChangeSelected, onSelect]),
        isExpanded,
        isLoading,
        triggerRef: outerRef,
        decorators,
    });
    const focus = (0, react_1.useCallback)(() => {
        onFocus && onFocus();
        setIsFocused(true);
        if (!isFocused) {
            setIsExpanded(true);
        }
    }, [onFocus, isFocused]);
    const unfocus = (0, react_1.useCallback)(() => {
        if (!isFocused)
            return;
        onBlur && onBlur();
        setIsFocused(false);
        setIsExpanded(false);
        setIsEditing(false);
        if (!selectedItem && defaultItem) {
            setInputValue((0, react_innertext_1.default)(defaultItem.label));
            onSelect && onSelect(defaultItem);
        }
    }, [isFocused, onBlur, selectedItem, defaultItem, onSelect]);
    const onClickClear = (0, react_1.useCallback)((e) => {
        e.stopPropagation();
        let isExecutedPreventDefault = false;
        onClearClick &&
            onClearClick({
                ...e,
                preventDefault: () => {
                    e.preventDefault();
                    isExecutedPreventDefault = true;
                },
            });
        if (!isExecutedPreventDefault) {
            onClear && onClear();
            onChangeSelected && onChangeSelected(null);
            inputRef.current?.focus();
            setIsFocused(true);
            setIsExpanded(true);
        }
    }, [onClearClick, onClear, onChangeSelected]);
    const onClickInput = (0, react_1.useCallback)((e) => {
        if (disabled) {
            e.stopPropagation();
            return;
        }
        if (inputRef.current) {
            inputRef.current.focus();
        }
        if (!isExpanded) {
            setIsExpanded(true);
        }
    }, [disabled, inputRef, isExpanded, setIsExpanded]);
    const actualOnChangeInput = (0, react_1.useCallback)((e) => {
        if (onChange)
            onChange(e);
        if (onChangeInput)
            onChangeInput(e);
        if (!isEditing)
            setIsEditing(true);
        const { value } = e.currentTarget;
        setInputValue(value);
        if (value === '') {
            onClear && onClear();
            onChangeSelected && onChangeSelected(null);
        }
    }, [isEditing, setIsEditing, setInputValue, onChange, onChangeInput, onClear, onChangeSelected]);
    const handleFocus = (0, react_1.useCallback)(() => {
        if (!isFocused) {
            focus();
        }
    }, [isFocused, focus]);
    const onCompositionStart = (0, react_1.useCallback)(() => setIsComposing(true), [setIsComposing]);
    const onCompositionEnd = (0, react_1.useCallback)(() => setIsComposing(false), [setIsComposing]);
    const onKeyDownInput = (0, react_1.useCallback)((e) => {
        if (isComposing) {
            return;
        }
        if (['Escape', 'Esc'].includes(e.key)) {
            if (isExpanded) {
                e.stopPropagation();
                setIsExpanded(false);
            }
        }
        else if (e.key === 'Tab') {
            unfocus();
        }
        else {
            if (['Down', 'ArrowDown', 'Up', 'ArrowUp'].includes(e.key)) {
                e.preventDefault();
            }
            inputRef.current?.focus();
            if (!isExpanded) {
                setIsExpanded(true);
            }
        }
        handleListBoxKeyDown(e);
    }, [isComposing, isExpanded, setIsExpanded, unfocus, handleListBoxKeyDown]);
    // HINT: form内にcomboboxを設置 & 検索inputにfocusした状態で
    // アイテムをキーボードで選択し、Enterを押すとinput上でEnterを押したことになるため、
    // submitイベントが発生し、formが送信される場合がある
    const handleKeyPress = (0, react_1.useCallback)((e) => {
        e.key === 'Enter' && e.preventDefault();
        onKeyPress && onKeyPress(e);
    }, [onKeyPress]);
    const caretIconColor = (0, react_1.useMemo)(() => {
        if (isFocused)
            return textColor.black;
        if (disabled)
            return textColor.disabled;
        return textColor.grey;
    }, [disabled, isFocused, textColor.black, textColor.disabled, textColor.grey]);
    (0, useClick_1.useClick)([outerRef, listBoxRef, clearButtonRef], (0, react_1.useCallback)(() => {
        if (!isFocused && onSelect && !selectedItem && defaultItem) {
            onSelect(defaultItem);
        }
    }, [isFocused, selectedItem, onSelect, defaultItem]), (0, react_1.useCallback)(() => {
        unfocus();
    }, [unfocus]));
    (0, react_1.useEffect)(() => {
        if (selectedItem) {
            setInputValue((0, react_innertext_1.default)(selectedItem.label));
        }
        else {
            setInputValue('');
        }
        if (isFocused && inputRef.current) {
            inputRef.current.focus();
        }
        else if (!selectedItem && defaultItem) {
            onSelect && onSelect(defaultItem);
        }
    }, [isFocused, selectedItem, defaultItem, onSelect]);
    const needsClearButton = selectedItem !== null && !disabled;
    const { wrapper, input, caretDownLayout, caretDownIcon, clearButton, clearButtonIcon } = singleCombobox();
    const { wrapperStyleProps, inputStyle, caretDownLayoutStyle, caretDownIconStyle, clearButtonStyle, clearButtonIconStyle, } = (0, react_1.useMemo)(() => {
        const wrapperWidth = typeof width === 'number' ? `${width}px` : width;
        return {
            wrapperStyleProps: {
                style: {
                    ...style,
                    width: wrapperWidth,
                },
                className: wrapper({ disabled, className }),
            },
            inputStyle: input(),
            caretDownLayoutStyle: caretDownLayout(),
            caretDownIconStyle: caretDownIcon(),
            clearButtonStyle: clearButton({ hidden: !needsClearButton }),
            clearButtonIconStyle: clearButtonIcon(),
        };
    }, [
        width,
        style,
        wrapper,
        disabled,
        className,
        input,
        caretDownLayout,
        caretDownIcon,
        clearButton,
        needsClearButton,
        clearButtonIcon,
    ]);
    return (react_1.default.createElement("div", { ...props, ...wrapperStyleProps, ref: outerRef },
        react_1.default.createElement(Input_1.Input, { ...inputAttributes, 
            /* eslint-disable-next-line smarthr/a11y-prohibit-input-placeholder */
            placeholder: placeholder, type: "text", name: name, value: inputValue, disabled: disabled, required: required, prefix: prefix, error: error, suffix: react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(Button_1.UnstyledButton, { onClick: onClickClear, ref: clearButtonRef, className: clearButtonStyle },
                    react_1.default.createElement(Icon_1.FaTimesCircleIcon, { color: "TEXT_BLACK", alt: decorators?.destroyButtonIconAlt?.(DESTROY_BUTTON_TEXT) || DESTROY_BUTTON_TEXT, className: clearButtonIconStyle })),
                react_1.default.createElement("span", { onClick: onClickInput, className: caretDownLayoutStyle },
                    react_1.default.createElement(Icon_1.FaCaretDownIcon, { color: caretIconColor, className: caretDownIconStyle }))), onClick: onClickInput, onChange: actualOnChangeInput, onFocus: handleFocus, onCompositionStart: onCompositionStart, onCompositionEnd: onCompositionEnd, onKeyDown: onKeyDownInput, onKeyPress: handleKeyPress, ref: inputRef, autoComplete: "off", role: "combobox", "aria-haspopup": "listbox", "aria-controls": listBoxId, "aria-expanded": isFocused, "aria-invalid": error || undefined, "aria-activedescendant": activeOption?.id, "aria-autocomplete": "list", className: inputStyle }),
        renderListBox()));
};
exports.SingleComboBox = (0, util_1.genericsForwardRef)(ActualSingleComboBox);
//# sourceMappingURL=SingleComboBox.js.map