"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Portal = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useEnhancedEffect_1 = require("../../hooks/useEnhancedEffect");
const usePortal_1 = require("../../hooks/usePortal");
const datePickerHelper_1 = require("./datePickerHelper");
const portal = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-DatePicker-calendarContainer shr-absolute shr-z-overlap shr-leading-none',
});
exports.Portal = (0, react_1.forwardRef)(({ inputRect, ...props }, ref) => {
    const { portalRoot, createPortal } = (0, usePortal_1.usePortal)();
    const [position, setPosition] = (0, react_1.useState)({
        top: 0,
        left: 0,
    });
    const containerRef = (0, react_1.useRef)(null);
    (0, react_1.useImperativeHandle)(ref, () => containerRef.current);
    (0, useEnhancedEffect_1.useEnhancedEffect)(() => {
        if (!containerRef.current) {
            return;
        }
        setPosition((0, datePickerHelper_1.getPortalPosition)(inputRect, containerRef.current.offsetHeight));
    }, [inputRect, portalRoot]);
    const containerStyleProps = (0, react_1.useMemo)(() => {
        const container = portal();
        return {
            className: container,
            style: {
                top: `${position.top}px`,
                left: `${position.left}px`,
            },
        };
    }, [position.left, position.top]);
    return createPortal(react_1.default.createElement("div", { ...props, ...containerStyleProps, ref: containerRef }));
});
//# sourceMappingURL=Portal.js.map