import { ComponentProps, FC } from 'react';
import { DefinitionListItem } from './DefinitionListItem';
type ItemType = ComponentProps<typeof DefinitionListItem>;
type Props = {
    /** 定義リストのアイテムの配列 */
    items: Array<Omit<ItemType, 'termStyleType'>>;
    /** 最大列数 */
    maxColumns?: number;
    /** 用語の見た目の種類 */
    termStyleType?: ItemType['termStyleType'];
};
type ElementProps = Omit<ComponentProps<'dl'>, keyof Props>;
export declare const DefinitionList: FC<Props & ElementProps>;
export {};
