"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefinitionListItem = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useTailwindTheme_1 = require("../../hooks/useTailwindTheme");
const Layout_1 = require("../Layout");
const Text_1 = require("../Text");
const definitionListItem = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-DefinitionListItem shr-border-b-shorthand shr-min-w-[12em] shr-grow shr-border-dotted',
            'contrast-more:shr-border-b-high-contrast',
        ],
        termEl: 'smarthr-ui-DefinitionListItem-term',
        descriptionEl: 'smarthr-ui-DefinitionListItem-description shr-ms-[initial] shr-pb-0.25 shr-min-h-[calc(1em*theme(lineHeight.normal))]',
    },
    variants: {
        fullWidth: {
            true: {
                wrapper: 'shr-basis-full',
            },
        },
    },
});
const DefinitionListItem = ({ maxColumns, fullWidth, term, termStyleType, description, className, }) => {
    const { spacing } = (0, useTailwindTheme_1.useTheme)();
    const { wrapperStyleProps, termStyle, descriptionStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, termEl, descriptionEl } = definitionListItem();
        return {
            wrapperStyleProps: {
                className: wrapper({ fullWidth, className }),
                style: {
                    flexBasis: 
                    // fullWidth の方が強い
                    !fullWidth && maxColumns
                        ? `calc((100% - ${spacing[1.5]} * ${maxColumns - 1}) / ${maxColumns})`
                        : undefined,
                },
            },
            termStyle: termEl(),
            descriptionStyle: descriptionEl(),
        };
    }, [className, fullWidth, maxColumns, spacing]);
    return (react_1.default.createElement(Layout_1.Stack, { ...wrapperStyleProps, gap: 0.25 },
        react_1.default.createElement(Text_1.Text, { as: "dt", size: "S", leading: "TIGHT", styleType: termStyleType, className: termStyle }, term),
        react_1.default.createElement(Text_1.Text, { as: "dd", size: "M", color: "TEXT_BLACK", leading: "NORMAL", className: descriptionStyle }, description)));
};
exports.DefinitionListItem = DefinitionListItem;
//# sourceMappingURL=DefinitionListItem.js.map