"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionDialogContentInner = void 0;
const react_1 = __importStar(require("react"));
const Button_1 = require("../../Button");
const Heading_1 = require("../../Heading");
const Layout_1 = require("../../Layout");
const ResponseMessage_1 = require("../../ResponseMessage");
const SectioningContent_1 = require("../../SectioningContent");
const Text_1 = require("../../Text");
const dialogHelper_1 = require("../dialogHelper");
const useDialogInnerStyle_1 = require("../useDialogInnerStyle");
const CLOSE_BUTTON_LABEL = 'キャンセル';
const ActionDialogContentInner = ({ children, title, titleId, subtitle, titleTag, actionText, actionTheme = 'primary', onClickAction, onClickClose, responseMessage, actionDisabled = false, closeDisabled, subActionArea, decorators, }) => {
    const handleClickAction = (0, react_1.useCallback)(() => {
        onClickAction(onClickClose);
    }, [onClickAction, onClickClose]);
    const { offsetHeight, titleRef, bottomRef } = (0, dialogHelper_1.useOffsetHeight)();
    const isRequestProcessing = responseMessage && responseMessage.status === 'processing';
    const { titleAreaStyle, bodyStyleProps, actionAreaStyle, buttonAreaStyle, messageStyle } = (0, useDialogInnerStyle_1.useDialoginnerStyle)(offsetHeight);
    return (react_1.default.createElement(SectioningContent_1.Section, null,
        react_1.default.createElement(Heading_1.Heading, { tag: titleTag },
            react_1.default.createElement(Layout_1.Stack, { gap: 0.25, as: "span", ref: titleRef, className: titleAreaStyle },
                subtitle && (react_1.default.createElement(Text_1.Text, { size: "S", leading: "TIGHT", color: "TEXT_GREY", className: "smarthr-ui-Dialog-subtitle" }, subtitle)),
                react_1.default.createElement(Text_1.Text, { id: titleId, size: "L", leading: "TIGHT", className: "smarthr-ui-Dialog-title" }, title))),
        react_1.default.createElement("div", { ...bodyStyleProps }, children),
        react_1.default.createElement(Layout_1.Stack, { gap: 0.5, ref: bottomRef, className: actionAreaStyle },
            react_1.default.createElement(Layout_1.Cluster, { justify: "space-between" },
                subActionArea,
                react_1.default.createElement(Layout_1.Cluster, { gap: { row: 0.5, column: 1 }, className: buttonAreaStyle },
                    react_1.default.createElement(Button_1.Button, { onClick: onClickClose, disabled: closeDisabled || isRequestProcessing, className: "smarthr-ui-Dialog-closeButton" }, decorators?.closeButtonLabel?.(CLOSE_BUTTON_LABEL) || CLOSE_BUTTON_LABEL),
                    react_1.default.createElement(Button_1.Button, { variant: actionTheme, onClick: handleClickAction, disabled: actionDisabled, loading: isRequestProcessing, className: "smarthr-ui-Dialog-actionButton" }, actionText))),
            (responseMessage?.status === 'success' || responseMessage?.status === 'error') && (react_1.default.createElement("div", { className: messageStyle },
                react_1.default.createElement(ResponseMessage_1.ResponseMessage, { type: responseMessage.status, role: "alert" }, responseMessage.text))))));
};
exports.ActionDialogContentInner = ActionDialogContentInner;
//# sourceMappingURL=ActionDialogContentInner.js.map