import { ComponentProps, FC, PropsWithChildren, RefObject } from 'react';
export type DialogContentInnerProps = PropsWithChildren<{
    /**
     * オーバーレイをクリックした時に発火するコールバック関数
     */
    onClickOverlay?: () => void;
    /**
     * エスケープキーを押下した時に発火するコールバック関数
     */
    onPressEscape?: () => void;
    /**
     * ダイアログを開いているかどうか
     */
    isOpen: boolean;
    /**
     * ダイアログの幅
     */
    width?: string | number;
    /**
     * ダイアログを開いたときの初期 top 位置
     */
    top?: number;
    /**
     * ダイアログを開いたときの初期 right 位置
     */
    right?: number;
    /**
     * ダイアログを開いたときの初期 bottom 位置
     */
    bottom?: number;
    /**
     * ダイアログを開いたときの初期 left 位置
     */
    left?: number;
    /**
     * ダイアログの `id`
     */
    id?: string;
    /**
     * ダイアログを開いた時にフォーカスする対象
     */
    firstFocusTarget?: RefObject<HTMLElement>;
    /**
     * ダイアログの `aria-label`
     */
    ariaLabel?: string;
    /**
     * ダイアログの `aria-labelledby`
     */
    ariaLabelledby?: string;
}>;
type ElementProps = Omit<ComponentProps<'div'>, keyof DialogContentInnerProps>;
export declare const DialogContentInner: FC<DialogContentInnerProps & ElementProps>;
export {};
