"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialogContentInner = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useHandleEscape_1 = require("../../hooks/useHandleEscape");
const useTailwindTheme_1 = require("../../hooks/useTailwindTheme");
const DialogOverlap_1 = require("./DialogOverlap");
const DialogPositionProvider_1 = require("./DialogPositionProvider");
const FocusTrap_1 = require("./FocusTrap");
const useBodyScrollLock_1 = require("./useBodyScrollLock");
function exist(value) {
    return value !== undefined && value !== null;
}
const dialogContentInner = (0, tailwind_variants_1.tv)({
    slots: {
        layout: 'smarthr-ui-Dialog-wrapper shr-fixed shr-inset-0',
        inner: 'smarthr-ui-Dialog contrast-more:shr-border-highContrast shr-absolute shr-rounded-m shr-bg-white shr-shadow-layer-3 contrast-more:shr-border-shorthand',
        background: 'smarthr-ui-Dialog-background shr-fixed shr-inset-0 shr-bg-scrim',
    },
});
const DialogContentInner = ({ onClickOverlay, onPressEscape = () => {
    /* noop */
}, isOpen, id, width, top, right, bottom, left, firstFocusTarget, ariaLabel, ariaLabelledby, children, className, ...props }) => {
    const { spacing } = (0, useTailwindTheme_1.useTheme)();
    const { layoutStyle, innerStyleProps, backgroundStyle } = (0, react_1.useMemo)(() => {
        const { layout, inner, background } = dialogContentInner();
        const positionTop = exist(top) ? `${top}px` : 'auto';
        const positionRight = exist(right) ? `${right}px` : 'auto';
        const positionBottom = exist(bottom) ? `${bottom}px` : 'auto';
        const positionLeft = exist(left) ? `${left}px` : 'auto';
        const actualWidth = typeof width === 'number' ? `${width}px` : width;
        const minimumMaxWidth = `calc(100vw - max(${left || 0}px, ${spacing[0.5]}) - max(${right || 0}px, ${spacing[0.5]}))`;
        const translateX = exist(right) || exist(left) ? '0' : 'calc((100vw - 100%) / 2)';
        const translateY = exist(top) || exist(bottom) ? '0' : 'calc((100svh - 100%) / 2)';
        return {
            layoutStyle: layout(),
            innerStyleProps: {
                className: inner({ className }),
                style: {
                    inset: `${positionTop} ${positionRight} ${positionBottom} ${positionLeft}`,
                    width: exist(actualWidth) ? actualWidth : undefined,
                    maxWidth: exist(actualWidth)
                        ? `min(${minimumMaxWidth}, ${actualWidth})`
                        : minimumMaxWidth,
                    transform: `translate(${translateX}, ${translateY})`,
                },
            },
            backgroundStyle: background(),
        };
    }, [bottom, className, left, right, spacing, top, width]);
    const innerRef = (0, react_1.useRef)(null);
    (0, useHandleEscape_1.useHandleEscape)((0, react_1.useCallback)(() => {
        if (!isOpen) {
            return;
        }
        onPressEscape();
    }, [isOpen, onPressEscape]));
    const handleClickOverlay = (0, react_1.useCallback)(() => {
        if (!isOpen) {
            return;
        }
        onClickOverlay && onClickOverlay();
    }, [isOpen, onClickOverlay]);
    (0, useBodyScrollLock_1.useBodyScrollLock)(isOpen);
    return (react_1.default.createElement(DialogPositionProvider_1.DialogPositionProvider, { top: top, bottom: bottom },
        react_1.default.createElement(DialogOverlap_1.DialogOverlap, { isOpen: isOpen },
            react_1.default.createElement("div", { className: layoutStyle, id: id },
                react_1.default.createElement("div", { onClick: handleClickOverlay, className: backgroundStyle, role: "presentation" }),
                react_1.default.createElement("div", { ...props, ...innerStyleProps, ref: innerRef, role: "dialog", "aria-label": ariaLabel, "aria-labelledby": ariaLabelledby, "aria-modal": "true" },
                    react_1.default.createElement(FocusTrap_1.FocusTrap, { firstFocusTarget: firstFocusTarget }, children))))));
};
exports.DialogContentInner = DialogContentInner;
//# sourceMappingURL=DialogContentInner.js.map