"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialogOverlap = void 0;
const react_1 = __importStar(require("react"));
const react_transition_group_1 = require("react-transition-group");
const tailwind_variants_1 = require("tailwind-variants");
const dialogOverlap = (0, tailwind_variants_1.tv)({
    base: [
        'shr-absolute',
        'shr-z-overlap-base',
        '[&.shr-dialog-transition-enter]:shr-opacity-0',
        '[&.shr-dialog-transition-enter-active]:shr-transition-opacity',
        '[&.shr-dialog-transition-enter-active]:shr-duration-300',
        '[&.shr-dialog-transition-enter-active]:shr-ease-in-out',
        // enter と enter-active は同時に付与されるので、enter-active を強める
        '[&&.shr-dialog-transition-enter-active]:shr-opacity-100',
        '[&.shr-dialog-transition-exit]:shr-opacity-100',
        '[&.shr-dialog-transition-exit-active]:shr-transition-opacity',
        '[&.shr-dialog-transition-exit-active]:shr-duration-300',
        '[&.shr-dialog-transition-exit-active]:shr-ease-in-out',
        // exit と exit-active は同時に付与されるので、exit-active を強める
        '[&&.shr-dialog-transition-exit-active]:shr-opacity-0',
    ],
});
const DialogOverlap = ({ isOpen, children }) => {
    const styles = (0, react_1.useMemo)(() => dialogOverlap(), []);
    const [childrenBuffer, setChildrenBuffer] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        if (isOpen) {
            setChildrenBuffer(children);
        }
    }, [isOpen, children]);
    return (react_1.default.createElement(react_transition_group_1.CSSTransition, { classNames: "shr-dialog-transition", in: isOpen, timeout: 300, unmountOnExit: true },
        react_1.default.createElement("div", { className: styles }, isOpen ? children : childrenBuffer)));
};
exports.DialogOverlap = DialogOverlap;
//# sourceMappingURL=DialogOverlap.js.map