"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageDialogContentInner = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../../Button");
const Heading_1 = require("../../Heading");
const Layout_1 = require("../../Layout");
const SectioningContent_1 = require("../../SectioningContent");
const Text_1 = require("../../Text");
const dialogHelper_1 = require("../dialogHelper");
const CLOSE_BUTTON_LABEL = '閉じる';
const messegeDialogContentInner = (0, tailwind_variants_1.tv)({
    slots: {
        titleArea: 'smarthr-ui-Dialog-titleArea shr-border-b-shorthand shr-my-[unset] shr-px-1.5 shr-py-1',
        body: 'smarthr-ui-Dialog-description shr-overflow-auto shr-p-1.5 shr-text-base',
        footer: 'smarthr-ui-Dialog-buttonArea shr-border-t-shorthand shr-flex shr-justify-end shr-px-1.5 shr-py-1',
    },
});
const MessageDialogContentInner = ({ title, subtitle, titleTag, titleId, description, onClickClose, decorators, }) => {
    const { offsetHeight, titleRef, bottomRef } = (0, dialogHelper_1.useOffsetHeight)();
    const { titleAreaStyle, bodyStyleProps, footerStyle } = (0, react_1.useMemo)(() => {
        const { titleArea, body, footer } = messegeDialogContentInner();
        return {
            titleAreaStyle: titleArea(),
            bodyStyleProps: {
                style: {
                    maxHeight: `calc(100svh - ${offsetHeight}px)`,
                },
                className: body(),
            },
            footerStyle: footer(),
        };
    }, [offsetHeight]);
    return (react_1.default.createElement(SectioningContent_1.Section, null,
        react_1.default.createElement(Heading_1.Heading, { tag: titleTag },
            react_1.default.createElement(Layout_1.Stack, { gap: 0.25, as: "span", ref: titleRef, className: titleAreaStyle },
                subtitle && (react_1.default.createElement(Text_1.Text, { size: "S", color: "TEXT_GREY", className: "smarthr-ui-Dialog-subtitle" }, subtitle)),
                react_1.default.createElement(Text_1.Text, { id: titleId, size: "L", className: "smarthr-ui-Dialog-title" }, title))),
        react_1.default.createElement("div", { ...bodyStyleProps }, description),
        react_1.default.createElement("footer", { ref: bottomRef, className: footerStyle },
            react_1.default.createElement(Button_1.Button, { onClick: onClickClose, className: "smarthr-ui-Dialog-closeButton" }, decorators?.closeButtonLabel?.(CLOSE_BUTTON_LABEL) || CLOSE_BUTTON_LABEL))));
};
exports.MessageDialogContentInner = MessageDialogContentInner;
//# sourceMappingURL=MessageDialogContentInner.js.map