"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBodyScrollLock = void 0;
const react_1 = require("react");
const useBodyScrollLock = (isOpen) => {
    const [scrollBarWidth, setScrollBarWidth] = (0, react_1.useState)(null);
    const [paddingRight, setPaddingRight] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        setScrollBarWidth(window.innerWidth - document.body.clientWidth);
    }, []);
    (0, react_1.useEffect)(() => {
        if (scrollBarWidth === null) {
            return;
        }
        const originalPaddingRight = getComputedStyle(document.body).getPropertyValue('padding-right');
        setPaddingRight(scrollBarWidth + parseInt(originalPaddingRight, 10));
    }, [scrollBarWidth]);
    (0, react_1.useEffect)(() => {
        if (!isOpen)
            return;
        if (paddingRight !== null) {
            document.body.style.paddingInlineEnd = `${paddingRight}px`;
        }
        document.body.style.overflow = 'hidden';
        return () => {
            document.body.style.paddingInlineEnd = '';
            document.body.style.overflow = '';
        };
    }, [isOpen, paddingRight]);
};
exports.useBodyScrollLock = useBodyScrollLock;
//# sourceMappingURL=useBodyScrollLock.js.map