"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDialoginnerStyle = void 0;
const react_1 = require("react");
const tailwind_variants_1 = require("tailwind-variants");
const dialogContentInner = (0, tailwind_variants_1.tv)({
    slots: {
        titleArea: ['smarthr-ui-Dialog-titleArea', 'shr-border-b-shorthand shr-px-1.5 shr-py-1'],
        body: ['smarthr-ui-Dialog-body', 'shr-overflow-auto'],
        actionArea: ['smarthr-ui-Dialog-actionArea', 'shr-border-t-shorthand shr-px-1.5 shr-py-1'],
        buttonArea: ['smarthr-ui-Dialog-buttonArea', 'shr-ms-auto'],
        message: 'shr-text-right',
    },
});
const useDialoginnerStyle = (offsetHeight) => (0, react_1.useMemo)(() => {
    const { titleArea, body, actionArea, buttonArea, message } = dialogContentInner();
    return {
        titleAreaStyle: titleArea(),
        bodyStyleProps: {
            className: body(),
            style: {
                maxHeight: `calc(100svh - ${offsetHeight}px)`,
            },
        },
        actionAreaStyle: actionArea(),
        buttonAreaStyle: buttonArea(),
        messageStyle: message(),
    };
}, [offsetHeight]);
exports.useDialoginnerStyle = useDialoginnerStyle;
//# sourceMappingURL=useDialogInnerStyle.js.map