import React, { ChangeEvent, ComponentPropsWithRef, DragEvent, PropsWithChildren } from 'react';
import type { DecoratorsType } from '../../types';
type ElementProps = Omit<ComponentPropsWithRef<'div'>, keyof DropZoneProps>;
type DropZoneProps = PropsWithChildren<{
    /**
     * ボタンまたはドラッグ&ドロップでファイルが追加された時に発火するコールバック関数
     */
    onSelectFiles: (e: DragEvent<HTMLElement> | ChangeEvent<HTMLInputElement>, files: FileList | null) => void;
    /**
     * 許可するファイル型を表す1つ以上の固有ファイル型指定子
     * <b>（ドラッグ&ドロップの挙動には影響しません）</b>
     */
    accept?: string;
    /** 複数ファイルを選択できるかどうか */
    multiple?: boolean;
    name?: string;
    /** コンポーネント内の文言を変更するための関数を設定 */
    decorators?: DecoratorsType<'selectButtonLabel'>;
}>;
export declare const DropZone: React.ForwardRefExoticComponent<Omit<{
    /**
     * ボタンまたはドラッグ&ドロップでファイルが追加された時に発火するコールバック関数
     */
    onSelectFiles: (e: DragEvent<HTMLElement> | ChangeEvent<HTMLInputElement>, files: FileList | null) => void;
    /**
     * 許可するファイル型を表す1つ以上の固有ファイル型指定子
     * <b>（ドラッグ&ドロップの挙動には影響しません）</b>
     */
    accept?: string | undefined;
    /** 複数ファイルを選択できるかどうか */
    multiple?: boolean | undefined;
    name?: string | undefined;
    /** コンポーネント内の文言を変更するための関数を設定 */
    decorators?: DecoratorsType<"selectButtonLabel"> | undefined;
} & {
    children?: React.ReactNode;
} & ElementProps, "ref"> & React.RefAttributes<HTMLInputElement>>;
export {};
