"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropZone = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Icon_1 = require("../Icon");
const dropZone = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-DropZone',
            'shr-border-shorthand shr-flex shr-flex-col shr-items-center shr-justify-center shr-bg-column shr-p-2.5',
        ],
        input: 'shr-hidden',
    },
    variants: {
        filesDraggedOver: {
            true: {
                wrapper: 'shr-border-main',
            },
            false: {
                wrapper: 'shr-border-dashed',
            },
        },
    },
});
const SELECT_BUTTON_LABEL = 'ファイルを選択';
const overrideEventDefault = (e) => {
    e.preventDefault();
    e.stopPropagation();
};
exports.DropZone = (0, react_1.forwardRef)(({ children, onSelectFiles, multiple = true, decorators, ...props }, ref) => {
    const fileRef = (0, react_1.useRef)(null);
    const [filesDraggedOver, setFilesDraggedOver] = (0, react_1.useState)(false);
    const { wrapper, input } = (0, react_1.useMemo)(() => dropZone({ filesDraggedOver }), [filesDraggedOver]);
    (0, react_1.useImperativeHandle)(ref, () => fileRef.current);
    const selectButtonLabel = (0, react_1.useMemo)(() => decorators?.selectButtonLabel?.(SELECT_BUTTON_LABEL) || SELECT_BUTTON_LABEL, [decorators]);
    const onDrop = (0, react_1.useCallback)((e) => {
        overrideEventDefault(e);
        setFilesDraggedOver(false);
        onSelectFiles(e, e.dataTransfer.files);
    }, [setFilesDraggedOver, onSelectFiles]);
    const onDragOver = (0, react_1.useCallback)((e) => {
        overrideEventDefault(e);
        setFilesDraggedOver(true);
    }, [setFilesDraggedOver]);
    const onDragLeave = (0, react_1.useCallback)(() => {
        setFilesDraggedOver(false);
    }, [setFilesDraggedOver]);
    const onChange = (0, react_1.useCallback)((e) => {
        onSelectFiles(e, e.target.files);
    }, [onSelectFiles]);
    const onClickButton = () => {
        fileRef.current.click();
    };
    return (react_1.default.createElement("div", { onDrop: onDrop, onDragOver: onDragOver, onDragLeave: onDragLeave, className: wrapper() },
        children,
        react_1.default.createElement(Button_1.Button, { prefix: react_1.default.createElement(Icon_1.FaFolderOpenIcon, null), onClick: onClickButton }, selectButtonLabel),
        react_1.default.createElement("input", { ...props, ref: fileRef, type: "file", multiple: multiple, onChange: onChange, className: input() })));
});
//# sourceMappingURL=DropZone.js.map