"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownContentInner = exports.DropdownContentInnerContext = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useTailwindTheme_1 = require("../../hooks/useTailwindTheme");
const DropdownCloser_1 = require("./DropdownCloser");
const dropdownHelper_1 = require("./dropdownHelper");
const useKeyboardNavigation_1 = require("./useKeyboardNavigation");
const contentInner = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-Dropdown-content shr-absolute shr-z-overlap-base shr-flex shr-break-words shr-rounded-m shr-bg-white shr-shadow-layer-3',
        controllableWrapper: 'shr-flex shr-flex-col',
    },
    variants: {
        isActive: {
            true: {
                wrapper: 'shr-visible',
            },
            false: {
                wrapper: 'shr-invisible',
            },
        },
    },
});
exports.DropdownContentInnerContext = (0, react_1.createContext)({
    maxHeight: '',
});
const DropdownContentInner = ({ triggerRect, scrollable, children, className, controllable, ...props }) => {
    const { spacing } = (0, useTailwindTheme_1.useTheme)();
    const [isActive, setIsActive] = (0, react_1.useState)(false);
    const [contentBox, setContentBox] = (0, react_1.useState)({
        top: 'auto',
        maxHeight: '',
    });
    const wrapperRef = (0, react_1.useRef)(null);
    const focusTargetRef = (0, react_1.useRef)(null);
    const { wrapper, controllableWrapper } = (0, react_1.useMemo)(() => contentInner(), []);
    const wrapperStyleProps = (0, react_1.useMemo)(() => {
        const leftMargin = contentBox.left === undefined ? spacing[0.5] : `max(${contentBox.left}, 0px)`;
        const rightMargin = contentBox.right === undefined ? spacing[0.5] : `max(${contentBox.right}, 0px)`;
        const maxWidthStyle = `calc(100% - ${leftMargin} - ${rightMargin})`;
        return {
            className: `${wrapper({ isActive, className })}`,
            style: {
                insetBlockStart: contentBox.top,
                insetInlineStart: contentBox.left || undefined,
                insetInlineEnd: contentBox.right || undefined,
                maxWidth: maxWidthStyle,
            },
        };
    }, [className, contentBox.left, contentBox.right, contentBox.top, isActive, spacing, wrapper]);
    const controllableWrapperStyleProps = (0, react_1.useMemo)(() => ({
        className: controllableWrapper(),
        style: {
            maxHeight: contentBox.maxHeight && scrollable ? contentBox.maxHeight : 'initial',
        },
    }), [contentBox.maxHeight, scrollable, controllableWrapper]);
    (0, react_1.useEffect)(() => {
        if (wrapperRef.current) {
            setContentBox((0, dropdownHelper_1.getContentBoxStyle)(triggerRect, {
                width: wrapperRef.current.offsetWidth,
                height: wrapperRef.current.offsetHeight,
            }, {
                width: document.body.clientWidth,
                height: innerHeight,
            }, {
                top: scrollY,
                left: scrollX,
            }));
            setIsActive(true);
        }
    }, [triggerRect]);
    (0, react_1.useEffect)(() => {
        if (isActive) {
            focusTargetRef.current?.focus();
        }
    }, [isActive]);
    (0, useKeyboardNavigation_1.useKeyboardNavigation)(wrapperRef, focusTargetRef);
    return (react_1.default.createElement("div", { ...props, ...wrapperStyleProps, ref: wrapperRef },
        react_1.default.createElement("div", { tabIndex: -1, ref: focusTargetRef }),
        controllable ? (react_1.default.createElement("div", { ...controllableWrapperStyleProps }, children)) : (react_1.default.createElement(exports.DropdownContentInnerContext.Provider, { value: { maxHeight: contentBox.maxHeight } },
            react_1.default.createElement(DropdownCloser_1.DropdownCloser, null, children)))));
};
exports.DropdownContentInner = DropdownContentInner;
//# sourceMappingURL=DropdownContentInner.js.map