"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownMenuButton = void 0;
const react_1 = __importStar(require("react"));
const react_innertext_1 = __importDefault(require("react-innertext"));
const tailwind_variants_1 = require("tailwind-variants");
const __1 = require("..");
const Button_1 = require("../../Button");
const Icon_1 = require("../../Icon");
const dropdownMenuButton = (0, tailwind_variants_1.tv)({
    slots: {
        triggerWrapper: 'smarthr-ui-DropdownMenuButton',
        triggerButton: 'smarthr-ui-DropdownMenuButton-trigger [&[aria-expanded="true"]_.smarthr-ui-Icon:last-child]:shr-rotate-180',
        actionList: [
            'smarthr-ui-DropdownMenuButton-panel',
            'shr-my-0 shr-list-none shr-px-0.25 shr-py-0.5',
            '[&_.smarthr-ui-Button]:shr-w-full [&_.smarthr-ui-Button]:shr-justify-start [&_.smarthr-ui-Button]:shr-border-none [&_.smarthr-ui-Button]:shr-py-0.5 [&_.smarthr-ui-Button]:shr-font-normal',
            '[&_.smarthr-ui-AnchorButton]:shr-w-full [&_.smarthr-ui-AnchorButton]:shr-justify-start [&_.smarthr-ui-AnchorButton]:shr-border-none [&_.smarthr-ui-AnchorButton]:shr-py-0.5 [&_.smarthr-ui-AnchorButton]:shr-font-normal',
            [
                /* unset した Button の右 padding 分 */
                '[&_.smarthr-ui-Button-disabledWrapper]:shr-pe-1',
                '[&_.smarthr-ui-Button-disabledWrapper]:shr-gap-x-0.5',
                '[&_.smarthr-ui-Button-disabledWrapper_>_.smarthr-ui-Button]:shr-w-[unset] [&_.smarthr-ui-Button-disabledWrapper_>_.smarthr-ui-Button]:shr-pe-[unset]',
            ],
            // hover 時に背景の白が出るので隠している
            '[&_li:hover]:-shr-mx-0.25 [&_li:hover]:shr-bg-white-darken [&_li:hover]:shr-px-0.25',
        ],
    },
});
const DropdownMenuButton = ({ label, children, triggerSize, onlyIconTrigger = false, triggerIcon: TriggerIcon, className, ...props }) => {
    const containerRef = react_1.default.useRef(null);
    const triggerLabel = (0, react_1.useMemo)(() => {
        const Icon = TriggerIcon || Icon_1.FaEllipsisIcon;
        return onlyIconTrigger ? (react_1.default.createElement(Icon, { alt: typeof label === 'string' ? label : (0, react_innertext_1.default)(label) })) : (label);
    }, [label, TriggerIcon, onlyIconTrigger]);
    const triggerSuffix = (0, react_1.useMemo)(
    // eslint-disable-next-line react/jsx-no-useless-fragment
    () => (onlyIconTrigger ? react_1.default.createElement(react_1.default.Fragment, null) : react_1.default.createElement(Icon_1.FaCaretDownIcon, { alt: "\u5019\u88DC\u3092\u958B\u304F" })), [onlyIconTrigger]);
    const handleKeyDown = (0, react_1.useCallback)((e) => {
        if (!containerRef.current || !document.activeElement) {
            return;
        }
        const allItems = Array.from(containerRef.current.querySelectorAll('li > *'));
        const { hoveredItem, tabbableItems: enabledItems, focusedIndex, } = allItems.reduce((acc, item) => {
            if (item.matches(':hover') && acc.hoveredItem === null) {
                acc.hoveredItem = item;
            }
            // NOTE: disalbedの判定は、自身がdisabledか、または子要素にdisabledがあるかで判定する。
            const isDisabled = item.matches(':disabled') ||
                Array.from(item.children).some((child) => child.matches(':disabled'));
            if (isDisabled) {
                return acc;
            }
            acc.tabbableItems.push(item);
            if (document.activeElement === item) {
                acc.focusedIndex = acc.tabbableItems.length - 1;
            }
            return acc;
        }, {
            hoveredItem: null,
            tabbableItems: [],
            focusedIndex: -1,
        });
        if (e.key === 'Up' || e.key === 'ArrowUp' || e.key === 'Left' || e.key === 'ArrowLeft') {
            const calculateNextIndex = () => {
                // MEMO: itemにフォーカスがない && ホバー状態のアイテムがある場合は、その一つ前のアイテムをフォーカスする
                if (focusedIndex < 0 && hoveredItem) {
                    return enabledItems.indexOf(hoveredItem) - 1;
                }
                // MEMO: フォーカスされているアイテムが最前列の場合は、最後尾のアイテムをフォーカスする
                if (focusedIndex <= 0) {
                    return enabledItems.length - 1;
                }
                return focusedIndex - 1;
            };
            const nextIndex = calculateNextIndex();
            const nextItem = enabledItems[nextIndex];
            if (nextItem instanceof HTMLElement) {
                nextItem.focus();
            }
        }
        if (e.key === 'Down' || e.key === 'ArrowDown' || e.key === 'Right' || e.key === 'ArrowRight') {
            const calculateNextIndex = () => {
                // MEMO: フォーカスされているアイテムが最後尾の場合は、最初のアイテムをフォーカスする
                if (focusedIndex > -1) {
                    return (focusedIndex + 1) % enabledItems.length;
                }
                // MEMO: itemにフォーカスがない && ホバー状態のアイテムがある場合は、その一つ後のアイテムをフォーカスする
                if (hoveredItem) {
                    return (enabledItems.indexOf(hoveredItem) + 1) % enabledItems.length;
                }
                return 0;
            };
            const nextIndex = calculateNextIndex();
            const nextItem = enabledItems[nextIndex];
            if (nextItem instanceof HTMLElement) {
                nextItem.focus();
            }
        }
    }, []);
    (0, react_1.useEffect)(() => {
        document.addEventListener('keydown', handleKeyDown);
        return () => {
            document.removeEventListener('keydown', handleKeyDown);
        };
    }, [handleKeyDown]);
    const { triggerWrapperStyle, triggerButtonStyle, actionListStyle } = (0, react_1.useMemo)(() => {
        const { triggerWrapper, triggerButton, actionList } = dropdownMenuButton();
        return {
            triggerWrapperStyle: triggerWrapper({ className }),
            triggerButtonStyle: triggerButton(),
            actionListStyle: actionList(),
        };
    }, [className]);
    return (react_1.default.createElement(__1.Dropdown, null,
        react_1.default.createElement(__1.DropdownTrigger, { className: triggerWrapperStyle },
            react_1.default.createElement(Button_1.Button, { ...props, suffix: triggerSuffix, size: triggerSize, square: onlyIconTrigger, className: triggerButtonStyle }, triggerLabel)),
        react_1.default.createElement(__1.DropdownContent, null,
            react_1.default.createElement(__1.DropdownScrollArea, { as: "ul", ref: containerRef, className: actionListStyle }, react_1.default.Children.map(children, (item, i) => 
            // MEMO: {flag && <Button/>}のような書き方に対応させる為、型を変換する
            // itemの存在チェックでfalsyな値は弾かれている想定
            item ? react_1.default.createElement("li", { key: i }, actionItem(item)) : null)))));
};
exports.DropdownMenuButton = DropdownMenuButton;
const actionItem = (item) => react_1.default.cloneElement(item, { variant: 'text', wide: true });
//# sourceMappingURL=DropdownMenuButton.js.map