import React, { ComponentProps, FC, ReactNode } from 'react';
import { BaseProps as ButtonProps } from '../../Button';
import type { DecoratorsType, ResponseMessageType } from '../../../types';
type Props = {
    isFiltered?: boolean;
    onApply: React.MouseEventHandler<HTMLButtonElement>;
    onCancel?: React.MouseEventHandler<HTMLButtonElement>;
    onReset?: React.MouseEventHandler<HTMLButtonElement>;
    children: ReactNode;
    hasStatusText?: boolean;
    decorators?: DecoratorsType<'status' | 'triggerButton' | 'applyButton' | 'cancelButton' | 'resetButton'>;
    responseMessage?: ResponseMessageType;
    /** 引き金となるボタンの大きさ */
    triggerSize?: ButtonProps['size'];
};
type ElementProps = Omit<ComponentProps<'button'>, keyof Props>;
export declare const FilterDropdown: FC<Props & ElementProps>;
export {};
