"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SortDropdown = void 0;
const react_1 = __importDefault(require("react"));
const Button_1 = require("../../Button");
const Fieldset_1 = require("../../Fieldset");
const FormControl_1 = require("../../FormControl");
const Layout_1 = require("../../Layout");
const RadioButton_1 = require("../../RadioButton");
const Select_1 = require("../../Select");
const Dropdown_1 = require("../Dropdown");
const DropdownCloser_1 = require("../DropdownCloser");
const DropdownContent_1 = require("../DropdownContent");
const DropdownScrollArea_1 = require("../DropdownScrollArea");
const DropdownTrigger_1 = require("../DropdownTrigger");
const useSortDropdown_1 = require("./useSortDropdown");
const SortDropdown = ({ sortFields, defaultOrder, onApply, onCancel, decorators, ...props }) => {
    const { labels: { triggerLabel, sortFieldLabel, sortOrderLabel, ascLabel, descLabel, applyButtonLabel, cancelButtonLabel, }, SortIcon, setCheckedInnerOrder, innerValues: { innerFields, innerCheckedOrder }, handler: { handleApply, handleChange }, styles: { bodyStyle, selectStyle, footerStyle }, } = (0, useSortDropdown_1.useSortDropdown)({
        sortFields,
        defaultOrder,
        onApply,
        decorators,
    });
    return (react_1.default.createElement(Dropdown_1.Dropdown, null,
        react_1.default.createElement(DropdownTrigger_1.DropdownTrigger, null,
            react_1.default.createElement(Button_1.Button, { ...props, suffix: react_1.default.createElement(SortIcon, null) }, triggerLabel)),
        react_1.default.createElement(DropdownContent_1.DropdownContent, { controllable: true },
            react_1.default.createElement(DropdownScrollArea_1.DropdownScrollArea, null,
                react_1.default.createElement(Layout_1.Stack, { className: bodyStyle },
                    react_1.default.createElement(FormControl_1.FormControl, { title: sortFieldLabel },
                        react_1.default.createElement(Select_1.Select, { name: "sortFields", options: innerFields, onChange: handleChange, className: selectStyle })),
                    react_1.default.createElement(Fieldset_1.Fieldset, { title: sortOrderLabel, innerMargin: 0.5 },
                        react_1.default.createElement(Layout_1.Cluster, { gap: 1.25 },
                            react_1.default.createElement(RadioButton_1.RadioButton, { name: "sortOrder", value: "asc", defaultChecked: innerCheckedOrder === 'asc', onChange: () => setCheckedInnerOrder('asc') }, ascLabel),
                            react_1.default.createElement(RadioButton_1.RadioButton, { name: "sortOrder", value: "desc", defaultChecked: innerCheckedOrder === 'desc', onChange: () => setCheckedInnerOrder('desc') }, descLabel)))),
                react_1.default.createElement(Layout_1.Cluster, { gap: 1, align: "center", justify: "flex-end", as: "footer", className: footerStyle },
                    react_1.default.createElement(DropdownCloser_1.DropdownCloser, null,
                        react_1.default.createElement(Button_1.Button, { onClick: onCancel }, cancelButtonLabel)),
                    react_1.default.createElement(DropdownCloser_1.DropdownCloser, null,
                        react_1.default.createElement(Button_1.Button, { variant: "primary", onClick: handleApply }, applyButtonLabel)))))));
};
exports.SortDropdown = SortDropdown;
//# sourceMappingURL=SortDropdown.js.map