"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorScreen = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Heading_1 = require("../Heading");
const Layout_1 = require("../Layout");
const SmartHRLogo_1 = require("../SmartHRLogo");
const TextLink_1 = require("../TextLink");
const errorScreen = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-ErrorScreen shr-bg-background',
});
const ErrorScreen = ({ logo = react_1.default.createElement(SmartHRLogo_1.SmartHRLogo, { fill: "brand", className: "shr-p-0.75" }), title, links, children, footer, className, ...props }) => {
    const styles = (0, react_1.useMemo)(() => errorScreen({ className }), [className]);
    return (react_1.default.createElement(Layout_1.Center, { ...props, minHeight: "100vh", verticalCentering: true, className: styles },
        react_1.default.createElement(Layout_1.Stack, { gap: 1.5, align: "center", className: "[&&&]:shr-my-auto" },
            react_1.default.createElement("div", { className: "smarthr-ui-ErrorScreen-logo" }, logo),
            react_1.default.createElement(Layout_1.Stack, { align: "center" },
                title && react_1.default.createElement(Heading_1.PageHeading, { className: "smarthr-ui-ErrorScreen-title" }, title),
                children && react_1.default.createElement("div", { className: "smarthr-ui-ErrorScreen-content" }, children),
                links?.length && (react_1.default.createElement(Layout_1.Stack, { as: "ul", gap: 0.5, align: "center", className: "smarthr-ui-ErrorScreen-linkList shr-list-none" }, links.map((link, index) => (react_1.default.createElement("li", { key: index },
                    react_1.default.createElement(TextLink_1.TextLink, { ...(link.target ? { target: link.target } : {}), href: link.url, className: "smarthr-ui-ErrorScreen-link" }, link.label)))))))),
        footer && react_1.default.createElement("div", { className: "shr-self-stretch" }, footer)));
};
exports.ErrorScreen = ErrorScreen;
//# sourceMappingURL=ErrorScreen.js.map