"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SideMenuItem = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const sideMenuItem = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: ['smarthr-ui-SideMenu-item', 'shr-relative shr-ps-0.75'],
        innerLink: [
            // 親要素ではなくリンクにスタイリングするため block でいっぱいに広げている
            'shr-block',
            'shr-rounded-m shr-px-1 shr-py-0.75 shr-no-underline',
            'aria-current-page:shr-bg-grey-9 aria-current-page:shr-font-bold',
            'hover:shr-bg-grey-9-darken',
            // フォーカスリングを前に出したいので、スタッキングコンテキストを発生させている
            'focus-visible:shr-focus-indicator focus-visible:shr-relative focus-visible:shr-z-1',
        ],
    },
    variants: {
        current: {
            true: {
                wrapper: 'before:shr-absolute before:shr-inset-y-0 before:shr-left-0 before:shr-block before:shr-w-[3px] before:shr-bg-main before:shr-content-[""]',
            },
        },
    },
});
const SideMenuItem = ({ href, children, current, className, ...rest }) => {
    const { wrapperStyle, innerLinkStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, innerLink } = sideMenuItem();
        return {
            wrapperStyle: wrapper({ current, className }),
            innerLinkStyle: innerLink(),
        };
    }, [className, current]);
    return (react_1.default.createElement("li", { ...rest, className: wrapperStyle },
        react_1.default.createElement("a", { href: href, "aria-current": current && 'page', className: innerLinkStyle }, children)));
};
exports.SideMenuItem = SideMenuItem;
//# sourceMappingURL=SideMenuItem.js.map