"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlashMessage = exports.roles = exports.messageTypes = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Icon_1 = require("../Icon");
const ResponseMessage_1 = require("../ResponseMessage");
exports.messageTypes = ['success', 'info', 'warning', 'error'];
exports.roles = ['alert', 'status'];
const REMOVE_DELAY = 8000;
const flashMessage = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-FlashMessage',
            'shr-border-shorthand shr-fixed shr-bottom-0.5 shr-left-0.5 shr-z-flash-message shr-flex shr-items-center shr-gap-0.5 shr-rounded-m shr-bg-white shr-p-1 shr-shadow-layer-4',
            '[&_.smarthr-ui-Icon-withText]:-shr-my-0.25 [&_.smarthr-ui-Icon-withText]:shr-grow',
            /* Icon + margin + 8文字 + margin + Button(border + padding + fontSize) */
            'shr-min-w-[calc(1em+theme(spacing[0.5])+8em+theme(spacing[0.5])+(theme(borderWidth.DEFAULT)*2)+(theme(spacing[0.5])*2)+theme(fontSize.sm))]',
        ],
        responseMessage: ['smarthr-ui-FlashMessage-icon', ''],
        closeButton: ['smarthr-ui-FlashMessage-button', '-shr-my-0.5 -shr-mr-0.5'],
    },
    variants: {
        animation: {
            bounce: {
                wrapper: [
                    'shr-animate-[flash-message-bounce_1s_0s_both]',
                    'motion-reduce:shr-animate-none',
                ],
            },
            none: {},
        },
    },
});
/**
 * @deprecated `FlashMessage` は気づきにくいため、安易な使用はお勧めしません。`NotificationBar` や `Dialog` の使用を検討してください。
 */
const FlashMessage = ({ visible, type, text, animation = 'bounce', role = 'alert', className, onClose, autoClose = true, ...rest }) => {
    (0, react_1.useEffect)(() => {
        if (!visible || !autoClose) {
            return;
        }
        const timerId = setTimeout(onClose, REMOVE_DELAY);
        return () => {
            clearTimeout(timerId);
        };
    }, [autoClose, onClose, visible]);
    const { wrapperStyle, responseMessageStyle, closeButtonStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, responseMessage, closeButton } = flashMessage();
        return {
            wrapperStyle: wrapper({ animation, className }),
            responseMessageStyle: responseMessage(),
            closeButtonStyle: closeButton(),
        };
    }, [animation, className]);
    if (!visible)
        return null;
    return (react_1.default.createElement("div", { ...rest, className: wrapperStyle, role: role },
        react_1.default.createElement(ResponseMessage_1.ResponseMessage, { type: type, iconGap: 0.5, className: responseMessageStyle }, text),
        react_1.default.createElement(Button_1.Button, { className: closeButtonStyle, onClick: onClose, size: "s", square: true },
            react_1.default.createElement(Icon_1.FaXmarkIcon, { alt: "\u9589\u3058\u308B" }))));
};
exports.FlashMessage = FlashMessage;
//# sourceMappingURL=FlashMessage.js.map