"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FloatArea = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Base_1 = require("../Base");
const Layout_1 = require("../Layout");
const ResponseMessage_1 = require("../ResponseMessage");
const floatArea = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-FloatArea shr-z-[500]',
    variants: {
        fixed: {
            true: 'shr-fixed',
            false: 'shr-sticky',
        },
        top: {
            0: 'shr-top-0',
            0.25: 'shr-top-0.25',
            0.5: 'shr-top-0.5',
            0.75: 'shr-top-0.75',
            1: 'shr-top-1',
            1.25: 'shr-top-1.25',
            1.5: 'shr-top-1.5',
            2: 'shr-top-2',
            2.5: 'shr-top-2.5',
            3: 'shr-top-3',
            3.5: 'shr-top-3.5',
            4: 'shr-top-4',
            8: 'shr-top-8',
            X3S: 'shr-top-0.25',
            XXS: 'shr-top-0.5',
            XS: 'shr-top-1',
            S: 'shr-top-1.5',
            M: 'shr-top-2',
            L: 'shr-top-2.5',
            XL: 'shr-top-3',
            XXL: 'shr-top-3.5',
            X3L: 'shr-top-4',
        },
        bottom: {
            0: 'shr-bottom-0',
            0.25: 'shr-bottom-0.25',
            0.5: 'shr-bottom-0.5',
            0.75: 'shr-bottom-0.75',
            1: 'shr-bottom-1',
            1.25: 'shr-bottom-1.25',
            1.5: 'shr-bottom-1.5',
            2: 'shr-bottom-2',
            2.5: 'shr-bottom-2.5',
            3: 'shr-bottom-3',
            3.5: 'shr-bottom-3.5',
            4: 'shr-bottom-4',
            8: 'shr-bottom-8',
            X3S: 'shr-bottom-0.25',
            XXS: 'shr-bottom-0.5',
            XS: 'shr-bottom-1',
            S: 'shr-bottom-1.5',
            M: 'shr-bottom-2',
            L: 'shr-bottom-2.5',
            XL: 'shr-bottom-3',
            XXL: 'shr-bottom-3.5',
            X3L: 'shr-bottom-4',
        },
    },
});
const FloatArea = ({ primaryButton, secondaryButton, tertiaryButton, responseMessage, fixed = false, className, top, bottom, width, zIndex, ...rest }) => {
    const styleProps = (0, react_1.useMemo)(() => ({
        className: floatArea({
            fixed,
            top,
            bottom,
            className,
        }),
        style: { width, zIndex },
    }), [className, bottom, fixed, top, width, zIndex]);
    return (react_1.default.createElement(Base_1.Base, { ...styleProps, ...rest, layer: 3, padding: 1 },
        react_1.default.createElement(Layout_1.Cluster, { gap: 1 },
            tertiaryButton,
            react_1.default.createElement("div", { className: "shr-ms-auto" },
                react_1.default.createElement(Layout_1.Cluster, { gap: 1, align: "center" },
                    (responseMessage?.status === 'success' || responseMessage?.status === 'error') && (react_1.default.createElement(ResponseMessage_1.ResponseMessage, { type: responseMessage.status }, responseMessage.text)),
                    react_1.default.createElement(Layout_1.Cluster, { gap: 1 },
                        secondaryButton,
                        primaryButton))))));
};
exports.FloatArea = FloatArea;
//# sourceMappingURL=FloatArea.js.map