"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormControl = exports.ActualFormControl = void 0;
const react_1 = __importStar(require("react"));
const styled_components_1 = require("styled-components");
const tailwind_variants_1 = require("tailwind-variants");
const useId_1 = require("../../hooks/useId");
const ComboBox_1 = require("../ComboBox");
const DatePicker_1 = require("../DatePicker");
const DropZone_1 = require("../DropZone");
const Icon_1 = require("../Icon");
const Input_1 = require("../Input");
const InputFile_1 = require("../InputFile");
const Layout_1 = require("../Layout");
const Select_1 = require("../Select");
const StatusLabel_1 = require("../StatusLabel");
const Text_1 = require("../Text");
const Textarea_1 = require("../Textarea");
const VisuallyHiddenText_1 = require("../VisuallyHiddenText/VisuallyHiddenText");
const formGroup = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            'smarthr-ui-FormControl',
            'shr-mx-[unset] shr-border-none shr-p-[unset]',
            'disabled:shr-text-disabled',
            '[&:disabled_.smarthr-ui-FormControl-label_>_span]:shr-text-disabled',
            '[&:disabled_.smarthr-ui-FormControl-errorMessage]:shr-text-inherit',
            '[&:disabled_.smarthr-ui-FormControl-supplementaryMessage]:shr-text-inherit',
            '[&:disabled_.smarthr-ui-Input]:shr-border-default/50 [&:disabled_.smarthr-ui-Input]:shr-bg-white-darken',
        ],
        label: [
            'smarthr-ui-FormControl-label',
            // flex-item が stretch してクリッカブル領域が広がりすぎないようにする
            'shr-self-start',
            'shr-px-[unset]',
        ],
        errorList: ['shr-list-none'],
        errorIcon: ['smarthr-ui-FormControl-errorMessage', 'shr-text-danger'],
    },
});
const childrenWrapper = (0, tailwind_variants_1.tv)({
    variants: {
        innerMargin: {
            0: '[&&&]:shr-mt-0',
            0.25: '[&&&]:shr-mt-0.25',
            0.5: '[&&&]:shr-mt-0.5',
            0.75: '[&&&]:shr-mt-0.75',
            1: '[&&&]:shr-mt-1',
            1.25: '[&&&]:shr-mt-1.25',
            1.5: '[&&&]:shr-mt-1.5',
            2: '[&&&]:shr-mt-2',
            2.5: '[&&&]:shr-mt-2.5',
            3: '[&&&]:shr-mt-3',
            3.5: '[&&&]:shr-mt-3.5',
            4: '[&&&]:shr-mt-4',
            8: '[&&&]:shr-mt-8',
            X3S: '[&&&]:shr-mt-0.25',
            XXS: '[&&&]:shr-mt-0.5',
            XS: '[&&&]:shr-mt-1',
            S: '[&&&]:shr-mt-1.5',
            M: '[&&&]:shr-mt-2',
            L: '[&&&]:shr-mt-2.5',
            XL: '[&&&]:shr-mt-3',
            XXL: '[&&&]:shr-mt-3.5',
            X3L: '[&&&]:shr-mt-4',
        },
        isRoleGroup: {
            true: '',
            false: '',
        },
    },
    compoundVariants: [
        {
            innerMargin: undefined,
            isRoleGroup: true,
            className: '[:not([hidden])_~_&&&]:shr-mt-1',
        },
        {
            innerMargin: undefined,
            isRoleGroup: false,
            className: '[:not([hidden])_~_&&&]:shr-mt-0.5',
        },
    ],
});
const ActualFormControl = ({ title, titleType = 'blockTitle', dangerouslyTitleHidden = false, htmlFor, labelId, innerMargin, statusLabelProps = [], helpMessage, exampleMessage, errorMessages, supplementaryMessage, as = 'div', className, children, ...props }) => {
    const managedHtmlFor = (0, useId_1.useId)(htmlFor);
    const managedLabelId = (0, useId_1.useId)(labelId);
    const isRoleGroup = as === 'fieldset';
    const statusLabelList = Array.isArray(statusLabelProps) ? statusLabelProps : [statusLabelProps];
    const describedbyIds = (0, react_1.useMemo)(() => Object.entries({ helpMessage, exampleMessage, supplementaryMessage, errorMessages })
        .filter(({ 1: value }) => value)
        .map(([key]) => `${managedHtmlFor}_${key}`)
        .join(' '), [helpMessage, exampleMessage, supplementaryMessage, errorMessages, managedHtmlFor]);
    const actualErrorMessages = (0, react_1.useMemo)(() => {
        if (!errorMessages) {
            return [];
        }
        return Array.isArray(errorMessages) ? errorMessages : [errorMessages];
    }, [errorMessages]);
    const { wrapperStyle, labelStyle, errorListStyle, errorIconStyle, childrenWrapperStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, label, errorList, errorIcon } = formGroup();
        return {
            wrapperStyle: wrapper({ className }),
            labelStyle: label({ className: dangerouslyTitleHidden ? (0, VisuallyHiddenText_1.visuallyHiddenText)() : '' }),
            errorListStyle: errorList(),
            errorIconStyle: errorIcon(),
            childrenWrapperStyle: childrenWrapper({ innerMargin, isRoleGroup }),
        };
    }, [className, dangerouslyTitleHidden, innerMargin, isRoleGroup]);
    return (react_1.default.createElement(Layout_1.Stack, { ...props, as: as, gap: innerMargin ?? 0.5, "aria-labelledby": isRoleGroup ? managedLabelId : undefined, "aria-describedby": isRoleGroup && describedbyIds ? describedbyIds : undefined, className: wrapperStyle },
        react_1.default.createElement(Layout_1.Cluster, { align: "center", htmlFor: !isRoleGroup ? managedHtmlFor : undefined, id: managedLabelId, className: labelStyle, as: isRoleGroup ? 'legend' : 'label', 
            // Stack 対象にしないための hidden
            hidden: dangerouslyTitleHidden || undefined },
            react_1.default.createElement(Text_1.Text, { as: "span", styleType: titleType }, title),
            statusLabelList.length > 0 && (react_1.default.createElement(Layout_1.Cluster, { gap: 0.25, as: "span" }, statusLabelList.map((statusLabelProp, index) => (react_1.default.createElement(StatusLabel_1.StatusLabel, { ...statusLabelProp, key: index })))))),
        helpMessage && (react_1.default.createElement("p", { className: "smarthr-ui-FormControl-helpMessage", id: `${managedHtmlFor}_helpMessage` }, helpMessage)),
        exampleMessage && (react_1.default.createElement(Text_1.Text, { as: "p", color: "TEXT_GREY", italic: true, id: `${managedHtmlFor}_exampleMessage`, className: "smarthr-ui-FormControl-exampleMessage" }, exampleMessage)),
        actualErrorMessages.length > 0 && (react_1.default.createElement("div", { id: `${managedHtmlFor}_errorMessages`, className: errorListStyle, role: "alert" }, actualErrorMessages.map((message, index) => (react_1.default.createElement("p", { key: index },
            react_1.default.createElement(Icon_1.FaCircleExclamationIcon, { text: message, className: errorIconStyle })))))),
        react_1.default.createElement("div", { className: childrenWrapperStyle }, decorateFirstInputElement(children, {
            managedHtmlFor,
            describedbyIds,
            error: actualErrorMessages.length > 0,
        })),
        supplementaryMessage && (react_1.default.createElement(Text_1.Text, { as: "p", size: "S", color: "TEXT_GREY", id: `${managedHtmlFor}_supplementaryMessage`, className: "smarthr-ui-FormControl-supplementaryMessage" }, supplementaryMessage))));
};
exports.ActualFormControl = ActualFormControl;
const decorateFirstInputElement = (children, params) => {
    const { managedHtmlFor, describedbyIds, error } = params;
    let foundFirstInput = false;
    const decorate = (targets) => react_1.default.Children.map(targets, (child) => {
        if (foundFirstInput || !react_1.default.isValidElement(child)) {
            return child;
        }
        if (!isInputElement(child)) {
            return react_1.default.cloneElement(child, {}, decorate(child.props.children));
        }
        foundFirstInput = true;
        const inputAttributes = {
            id: managedHtmlFor,
        };
        if (error) {
            inputAttributes.error = true;
        }
        if (describedbyIds !== '') {
            inputAttributes['aria-describedby'] = describedbyIds;
        }
        if (isComboBoxElement(child)) {
            return react_1.default.cloneElement(child, { inputAttributes });
        }
        else {
            return react_1.default.cloneElement(child, inputAttributes);
        }
    });
    return decorate(children);
};
/**
 * - CheckBox / RadioButton は内部に label を含むため対象外
 * - SearchInput は label を含むため対象外
 * - InputWithTooltip は領域が狭く FormControl を置けない場所での使用を想定しているため対象外
 *
 * @param node
 * @returns
 */
const isInputElement = (element) => {
    const type = (0, styled_components_1.isStyledComponent)(element.type) ? element.type.target : element.type;
    return (type === Input_1.Input ||
        type === Input_1.CurrencyInput ||
        type === Textarea_1.Textarea ||
        type === DatePicker_1.DatePicker ||
        type === Select_1.Select ||
        type === ComboBox_1.SingleComboBox ||
        type === ComboBox_1.MultiComboBox ||
        type === InputFile_1.InputFile ||
        type === DropZone_1.DropZone);
};
const isComboBoxElement = (element) => {
    const type = (0, styled_components_1.isStyledComponent)(element.type) ? element.type.target : element.type;
    return type === ComboBox_1.SingleComboBox || type === ComboBox_1.MultiComboBox;
};
exports.FormControl = exports.ActualFormControl;
//# sourceMappingURL=FormControl.js.map