"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppLauncher = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../../Button");
const Dropdown_1 = require("../../Dropdown");
const Heading_1 = require("../../Heading");
const Icon_1 = require("../../Icon");
const Layout_1 = require("../../Layout");
const SectioningContent_1 = require("../../SectioningContent");
const TextLink_1 = require("../../TextLink");
const TRIGGER_LABEL = 'アプリ';
const appLauncher = (0, tailwind_variants_1.tv)({
    slots: {
        appsButton: [
            'shr-border-transparent shr-font-normal shr-text-white [&]:shr-bg-transparent [&]:shr-px-0.25',
            'hover:shr-border-transparent hover:[&]:shr-bg-transparent',
            'focus-visible:shr-border-transparent focus-visible:[&]:shr-bg-transparent',
        ],
        contentWrapper: ['smarthr-ui-AppLauncher', 'shr-p-1.5 shr-leading-normal'],
        category: 'smarthr-ui-AppLauncher-category',
        appList: 'shr-list-none',
        link: 'smarthr-ui-AppLauncher-link',
        footer: [
            'smarthr-ui-AppLauncher-footer',
            'shr-border-t-shorthand -shr-mx-0.75 shr-px-0.75 shr-pt-1 [&&&]:-shr-mb-0.25',
        ],
    },
});
const AppLauncher = ({ apps, urlToShowAll, decorators, ...props }) => {
    const triggerLabel = (0, react_1.useMemo)(() => decorators?.triggerLabel?.(TRIGGER_LABEL) || TRIGGER_LABEL, [decorators]);
    const baseApps = apps.find(({ type }) => type === 'base');
    const others = apps.filter((category) => category !== baseApps);
    const { appsButton, contentWrapper, category, appList, link, footer } = appLauncher();
    return (react_1.default.createElement(Dropdown_1.Dropdown, { ...props },
        react_1.default.createElement(Dropdown_1.DropdownTrigger, null,
            react_1.default.createElement(Button_1.Button, { prefix: react_1.default.createElement(Icon_1.FaToolboxIcon, null), className: appsButton() }, triggerLabel)),
        react_1.default.createElement(Dropdown_1.DropdownContent, { controllable: true },
            react_1.default.createElement(Layout_1.Stack, { as: "nav", gap: 1.5, className: contentWrapper() },
                react_1.default.createElement(Dropdown_1.DropdownScrollArea, null,
                    react_1.default.createElement(Layout_1.Stack, { gap: 1.5 },
                        baseApps && (react_1.default.createElement(SectioningContent_1.Section, null,
                            react_1.default.createElement(Layout_1.Stack, { gap: 0.5, className: category() },
                                react_1.default.createElement(Heading_1.Heading, { type: "subSubBlockTitle" }, baseApps.heading),
                                react_1.default.createElement(Layout_1.Cluster, { as: "ul", gap: 1, className: appList() }, appItems(baseApps.items, link()))))),
                        react_1.default.createElement(Layout_1.Cluster, { gap: 1.5 }, others.map(({ heading, items }, i) => (react_1.default.createElement(SectioningContent_1.Section, { key: i },
                            react_1.default.createElement(Layout_1.Stack, { gap: 0.5, className: category() },
                                react_1.default.createElement(Heading_1.Heading, { type: "subSubBlockTitle" }, heading),
                                react_1.default.createElement(Layout_1.Stack, { gap: 0.5, as: "ul", className: appList() }, appItems(items, link()))))))))),
                urlToShowAll && (react_1.default.createElement("div", { className: footer() },
                    react_1.default.createElement(TextLink_1.TextLink, { href: urlToShowAll, style: { width: 'fit-content' } }, "\u3059\u3079\u3066\u898B\u308B")))))));
};
exports.AppLauncher = AppLauncher;
const appItems = (items, linkStyle) => items.map((item, index) => (react_1.default.createElement("li", { key: index },
    react_1.default.createElement(TextLink_1.TextLink, { href: item.url, target: item.target, className: linkStyle }, item.label))));
//# sourceMappingURL=AppLauncher.js.map