"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Header = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Layout_1 = require("../Layout");
const SmartHRLogo_1 = require("../SmartHRLogo");
const Text_1 = require("../Text");
const _1 = require(".");
const header = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: ['smarthr-ui-Header', 'shr-bg-brand shr-px-1.25', 'max-md:shr-px-0.75'],
        logoLink: [
            'smarthr-ui-Header-logoLink',
            /* ロゴが持つ padding 分だけ調整 */
            '-shr-ms-0.75',
            'focus-visible:shr-focus-indicator',
        ],
        tenantInfo: ['smarthr-ui-Header-tenantInfo', 'shr-ms-auto'],
        tenantNameText: 'shr-px-0.25',
        actions: ['smarthr-ui-Header-actions', 'shr-ms-auto'],
    },
});
const Header = ({ logo = react_1.default.createElement(SmartHRLogo_1.SmartHRLogo, { className: "shr-p-0.75" }), logoHref = '/', tenants, currentTenantId, onTenantSelect, children, className, }) => {
    const { wrapperStyle, logoLinkStyle, tenantInfoStyle, tenantNameTextStyle, actionsStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, logoLink, tenantInfo, tenantNameText, actions } = header();
        return {
            wrapperStyle: wrapper({ className }),
            logoLinkStyle: logoLink(),
            tenantInfoStyle: tenantInfo(),
            tenantNameTextStyle: tenantNameText(),
            actionsStyle: actions(),
        };
    }, [className]);
    const currentTenantName = (0, react_1.useMemo)(() => {
        if (tenants && tenants.length >= 1) {
            const current = tenants.find(({ id }) => id === currentTenantId);
            return current ? current.name : tenants[0].name;
        }
        return undefined;
    }, [currentTenantId, tenants]);
    const tenantInfo = (0, react_1.useMemo)(() => tenants && tenants.length > 1 ? (react_1.default.createElement(_1.HeaderDropdownMenuButton, { label: currentTenantName }, tenants.map(({ id, name }) => (react_1.default.createElement(Button_1.Button, { key: id, onClick: () => onTenantSelect && onTenantSelect(id) }, name))))) : (react_1.default.createElement(Text_1.Text, { color: "TEXT_WHITE", className: tenantNameTextStyle }, currentTenantName)), [currentTenantName, onTenantSelect, tenants, tenantNameTextStyle]);
    return (react_1.default.createElement(Layout_1.Cluster, { as: "header", justify: "space-between", gap: { column: 0.25, row: 0 }, className: wrapperStyle },
        react_1.default.createElement(Layout_1.Cluster, { align: "center", gap: { column: 0.25, row: 0 } },
            react_1.default.createElement("a", { href: logoHref, className: logoLinkStyle }, logo),
            currentTenantName && react_1.default.createElement("div", { className: tenantInfoStyle }, tenantInfo)),
        react_1.default.createElement(Layout_1.Cluster, { align: "center", justify: "flex-end", gap: { column: 0.5, row: 0.25 }, className: actionsStyle }, children)));
};
exports.Header = Header;
//# sourceMappingURL=Header.js.map