"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderLink = void 0;
const react_1 = __importDefault(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const TextLink_1 = require("../TextLink");
const headerLink = (0, tailwind_variants_1.tv)({
    base: [
        'shr-px-0.25 shr-text-white [&]:shr-shadow-none',
        'hover:shr-text-white',
        'focus-visible:shr-focus-indicator',
    ],
});
const HeaderLink = ({ className, ...props }) => {
    const style = headerLink({ className });
    return (
    // eslint-disable-next-line smarthr/a11y-anchor-has-href-attribute
    react_1.default.createElement(TextLink_1.TextLink, { ...props, target: "_blank", suffix: null, className: style }));
};
exports.HeaderLink = HeaderLink;
//# sourceMappingURL=HeaderLink.js.map