import { ComponentProps, FC, PropsWithChildren } from 'react';
import { TextProps } from '../Text';
export type Props = PropsWithChildren<{
    /** テキストのスタイル */
    type?: HeadingTypes;
    /**
     * @deprecated SectioningContent(Article, Aside, Nav, Section)を使ってHeadingと関連する範囲を明確に指定してください
     */
    tag?: HeadingTagTypes;
    /** 視覚的に非表示にするフラグ */
    visuallyHidden?: boolean;
}>;
export type HeadingTypes = 'screenTitle' | 'sectionTitle' | 'blockTitle' | 'subBlockTitle' | 'subSubBlockTitle';
export type HeadingTagTypes = 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6';
type ElementProps = Omit<ComponentProps<'h1'>, keyof Props | keyof TextProps | 'role' | 'aria-level'>;
export declare const MAPPER_SIZE_AND_WEIGHT: {
    [key in HeadingTypes]: TextProps;
};
export declare const Heading: FC<Props & ElementProps>;
export declare const PageHeading: FC<Omit<Props & ElementProps, 'visuallyHidden' | 'tag'>>;
export {};
