"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageHeading = exports.Heading = exports.MAPPER_SIZE_AND_WEIGHT = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const SectioningContent_1 = require("../SectioningContent");
const Text_1 = require("../Text");
const VisuallyHiddenText_1 = require("../VisuallyHiddenText");
exports.MAPPER_SIZE_AND_WEIGHT = {
    screenTitle: {
        size: 'XL',
        weight: 'normal',
    },
    sectionTitle: {
        size: 'L',
        weight: 'normal',
    },
    blockTitle: {
        size: 'M',
        weight: 'bold',
    },
    subBlockTitle: {
        size: 'M',
        weight: 'bold',
        color: 'TEXT_GREY',
    },
    subSubBlockTitle: {
        size: 'S',
        weight: 'bold',
        color: 'TEXT_GREY',
    },
};
const generateTagProps = (level, tag) => {
    let role = undefined;
    let ariaLevel = undefined;
    // TODO: h1はPageHeadingで設定するため、自動計算では必ずh2以下になるようにする
    if (!tag && level > 6) {
        role = 'heading';
        ariaLevel = level;
    }
    return {
        as: tag || (level <= 6 ? `h${level}` : 'span'),
        role,
        'aria-level': ariaLevel,
    };
};
const heading = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-Heading',
    variants: {
        visuallyHidden: {
            false: 'shr-m-[unset]',
        },
    },
    defaultVariants: {
        visuallyHidden: false,
    },
});
const Heading = ({ tag, type = 'sectionTitle', className, visuallyHidden, ...props }) => {
    const level = (0, react_1.useContext)(SectioningContent_1.LevelContext);
    const tagProps = (0, react_1.useMemo)(() => generateTagProps(level, tag), [level, tag]);
    const styles = (0, react_1.useMemo)(() => heading({ visuallyHidden, className }), [className, visuallyHidden]);
    const actualProps = {
        ...props,
        ...exports.MAPPER_SIZE_AND_WEIGHT[type],
        ...tagProps,
        className: styles,
    };
    return visuallyHidden ? (react_1.default.createElement(VisuallyHiddenText_1.VisuallyHiddenText, { ...actualProps })) : (react_1.default.createElement(Text_1.Text, { ...actualProps, leading: "TIGHT" }));
};
exports.Heading = Heading;
const PageHeading = ({ type = 'screenTitle', ...props }) => react_1.default.createElement(exports.Heading, { ...props, type: type, tag: "h1" }); // eslint-disable-line smarthr/a11y-heading-in-sectioning-content
exports.PageHeading = PageHeading;
//# sourceMappingURL=Heading.js.map