"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createIcon = exports.generateIcon = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useTailwindTheme_1 = require("../../hooks/useTailwindTheme");
const VisuallyHiddenText_1 = require("../VisuallyHiddenText");
const generateIcon = (svg) => (0, exports.createIcon)(svg);
exports.generateIcon = generateIcon;
const colorSet = {
    TEXT_BLACK: 'black',
    TEXT_WHITE: 'white',
    TEXT_GREY: 'grey',
    TEXT_DISABLED: 'disabled',
    TEXT_LINK: 'link',
    MAIN: 'main',
    DANGER: 'danger',
    WARNING: 'warning-yellow',
    BRAND: 'brand',
};
const existsColor = (color) => color in colorSet;
const fontSizeMap = {
    XXS: '2xs',
    XS: 'xs',
    S: 'sm',
    M: 'base',
    L: 'lg',
    XL: 'xl',
    XXL: '2xl',
};
const icon = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-Icon group-[]/iconWrapper:shr-shrink-0 group-[]/iconWrapper:shr-translate-y-[0.125em] forced-colors:shr-fill-[CanvasText]',
});
const wrapper = (0, tailwind_variants_1.tv)({
    base: ['smarthr-ui-Icon-withText shr-group/iconWrapper shr-inline-flex shr-items-baseline'],
    variants: {
        gap: {
            0: 'shr-gap-x-0',
            0.25: 'shr-gap-x-0.25',
            0.5: 'shr-gap-x-0.5',
            0.75: 'shr-gap-x-0.75',
            1: 'shr-gap-x-1',
            1.25: 'shr-gap-x-1.25',
            1.5: 'shr-gap-x-1.5',
            2: 'shr-gap-x-2',
            2.5: 'shr-gap-x-2.5',
            3: 'shr-gap-x-3',
            3.5: 'shr-gap-x-3.5',
            4: 'shr-gap-x-4',
            8: 'shr-gap-x-8',
            '-0.25': '-shr-gap-x-0.25',
            '-0.5': '-shr-gap-x-0.5',
            '-0.75': '-shr-gap-x-0.75',
            '-1': '-shr-gap-x-1',
            '-1.25': '-shr-gap-x-1.25',
            '-1.5': '-shr-gap-x-1.5',
            '-2': '-shr-gap-x-2',
            '-2.5': '-shr-gap-x-2.5',
            '-3': '-shr-gap-x-3',
            '-3.5': '-shr-gap-x-3.5',
            '-4': '-shr-gap-x-4',
            '-8': '-shr-gap-x-8',
            X3S: 'shr-gap-x-0.25',
            XXS: 'shr-gap-x-0.5',
            XS: 'shr-gap-x-1',
            S: 'shr-gap-x-1.5',
            M: 'shr-gap-x-2',
            L: 'shr-gap-x-2.5',
            XL: 'shr-gap-x-3',
            XXL: 'shr-gap-x-3.5',
            X3L: 'shr-gap-x-4',
        },
    },
});
const createIcon = (SvgIcon) => {
    const Icon = ({ color, className, role = 'img', alt, 'aria-hidden': ariaHidden, focusable = false, text, iconGap = 0.25, right = false, size, ...props }) => {
        const hasLabelByAria = props['aria-label'] !== undefined || props['aria-labelledby'] !== undefined;
        const isAriaHidden = ariaHidden !== undefined ? ariaHidden : !hasLabelByAria;
        const iconStyle = (0, react_1.useMemo)(() => icon({ className }), [className]);
        const wrapperStyle = (0, react_1.useMemo)(() => wrapper({ gap: iconGap }), [iconGap]);
        const { colors, textColor, fontSize } = (0, useTailwindTheme_1.useTheme)();
        const replacedColor = (0, react_1.useMemo)(() => {
            if (color && existsColor(color)) {
                const colorName = colorSet[color];
                if (colorName in textColor) {
                    return textColor[colorName];
                }
                return colors[colorName];
            }
            return color;
        }, [color, colors, textColor]);
        const existsText = !!text;
        const iconSize = size ? fontSize[fontSizeMap[size]] : '1em'; // 指定がない場合は親要素のフォントサイズを継承する
        const svgIcon = (react_1.default.createElement(SvgIcon, { ...props, stroke: "currentColor", fill: "currentColor", strokeWidth: "0", 
            // size は react-icons のアイコンの大きさ、width / height は自前で SVG からアイコンを作る場合の大きさ指定
            size: iconSize, width: iconSize, height: iconSize, color: replacedColor, className: iconStyle, role: role, "aria-hidden": isAriaHidden || alt !== undefined || undefined, focusable: focusable }));
        if (existsText) {
            return (react_1.default.createElement("span", { className: wrapperStyle },
                alt && react_1.default.createElement(VisuallyHiddenText_1.VisuallyHiddenText, null, alt),
                right && text,
                svgIcon,
                !right && text));
        }
        return (react_1.default.createElement(react_1.default.Fragment, null,
            alt && react_1.default.createElement(VisuallyHiddenText_1.VisuallyHiddenText, null, alt),
            svgIcon));
    };
    Icon.displayName = SvgIcon.name;
    return Icon;
};
exports.createIcon = createIcon;
//# sourceMappingURL=generateIcon.js.map