import React, { FC, PropsWithChildren } from 'react';
import { BaseElementProps } from '../Base';
import { HeadingTagTypes } from '../Heading';
import type { DecoratorsType } from '../../types';
type Props = PropsWithChildren<{
    /** パネルのタイトル */
    title: React.ReactNode;
    /**
     * @deprecated titleTagは非推奨です
     */
    titleTag?: HeadingTagTypes;
    /** 表示する情報のタイプ */
    type?: 'success' | 'info' | 'warning' | 'error' | 'sync';
    /** `true` のとき、開閉ボタンを表示する */
    togglable?: boolean;
    /** パネルの開閉の状態 */
    active?: boolean;
    /** 開閉ボタン押下時に発火するコールバック関数 */
    onClickTrigger?: (active: boolean) => void;
    /** コンポーネント内の文言を変更するための関数を設定 */
    decorators?: DecoratorsType<'openButtonLabel' | 'closeButtonLabel'>;
}>;
export declare const InformationPanel: FC<Props & Omit<BaseElementProps, keyof Props>>;
export {};
