"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InformationPanel = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useId_1 = require("../../hooks/useId");
const Base_1 = require("../Base");
const Button_1 = require("../Button");
const Heading_1 = require("../Heading");
const Icon_1 = require("../Icon");
const Layout_1 = require("../Layout");
const ResponseMessage_1 = require("../ResponseMessage");
const OPEN_BUTTON_LABEL = '開く';
const CLOSE_BUTTON_LABEL = '閉じる';
const informationPanel = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-InformationPanel shr-p-1.5 shr-shadow-layer-3',
        header: 'smarthr-ui-InformationPanel-title',
        togglableButton: 'smarthr-ui-InformationPanel-closeButton -shr-my-0.5 shr-ms-auto',
        content: 'smarthr-ui-InformationPanel-content shr-text-base aria-hidden:shr-hidden',
    },
});
const InformationPanel = ({ title, titleTag, type = 'info', togglable = true, active: activeProps = true, className, children, onClickTrigger, decorators, ...props }) => {
    const [active, setActive] = (0, react_1.useState)(activeProps);
    const titleId = (0, useId_1.useId)();
    const contentId = (0, useId_1.useId)();
    const handleClickTrigger = (0, react_1.useCallback)(() => {
        if (onClickTrigger) {
            onClickTrigger(active);
        }
        else {
            setActive(!active);
        }
    }, [active, onClickTrigger]);
    (0, react_1.useEffect)(() => {
        setActive(activeProps);
    }, [activeProps]);
    const { wrapperStyle, headerStyle, togglableButtonStyle, contentStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, header, togglableButton, content } = informationPanel();
        return {
            wrapperStyle: wrapper({ className }),
            headerStyle: header(),
            togglableButtonStyle: togglableButton(),
            contentStyle: content(),
        };
    }, [className]);
    return (react_1.default.createElement(Base_1.Base, { ...props, as: "section", className: wrapperStyle },
        react_1.default.createElement(Layout_1.Stack, { gap: 1.25 },
            react_1.default.createElement(Layout_1.Cluster, { align: "center", justify: "space-between" },
                react_1.default.createElement(Heading_1.Heading, { type: "blockTitle", tag: titleTag, id: titleId, className: headerStyle },
                    react_1.default.createElement(ResponseMessage_1.ResponseMessage, { type: type, iconGap: 0.5 }, title)),
                togglable && (react_1.default.createElement(Button_1.Button, { suffix: active ? react_1.default.createElement(Icon_1.FaCaretUpIcon, null) : react_1.default.createElement(Icon_1.FaCaretDownIcon, null), size: "s", onClick: handleClickTrigger, "aria-expanded": togglable ? active : undefined, "aria-controls": contentId, className: togglableButtonStyle }, active
                    ? decorators?.closeButtonLabel?.(CLOSE_BUTTON_LABEL) || CLOSE_BUTTON_LABEL
                    : decorators?.openButtonLabel?.(OPEN_BUTTON_LABEL) || OPEN_BUTTON_LABEL))),
            react_1.default.createElement("div", { id: contentId, "aria-hidden": !active, className: contentStyle }, children))));
};
exports.InformationPanel = InformationPanel;
//# sourceMappingURL=InformationPanel.js.map