"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputWithTooltip = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Tooltip_1 = require("../../Tooltip");
const Input_1 = require("../Input");
const inputWithTooltip = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-InputWithTooltip [&]:shr-overflow-y-visible',
});
exports.InputWithTooltip = (0, react_1.forwardRef)(({ tooltipMessage, width, ...props }, ref) => {
    const widthStyle = typeof width === 'number' ? `${width}px` : width;
    const tooltipStyleProps = (0, react_1.useMemo)(() => {
        const tooltip = inputWithTooltip();
        return {
            className: tooltip,
            style: {
                width: widthStyle,
            },
        };
    }, [widthStyle]);
    return (react_1.default.createElement(Tooltip_1.Tooltip, { ...tooltipStyleProps, message: tooltipMessage, tabIndex: -1, ariaDescribedbyTarget: "inner" },
        react_1.default.createElement(Input_1.Input, { ...props, width: widthStyle, ref: ref })));
});
//# sourceMappingURL=InputWithTooltip.js.map