import React from 'react';
import type { Gap } from '../../../types';
import type { ComponentPropsWithRef, PropsWithChildren } from 'react';
type Props = PropsWithChildren<{
    /** コンテンツの最小高さ */
    minHeight?: number | string;
    /** コンテンツの最大幅 */
    maxWidth?: number | string;
    /** 境界とコンテンツの間の余白 */
    padding?: Gap;
    /** 天地中央揃えも有効化するかどうか */
    verticalCentering?: boolean;
    as?: string | React.ComponentType<any>;
}>;
type ElementProps = Omit<ComponentPropsWithRef<'div'>, keyof Props>;
export declare const Center: React.ForwardRefExoticComponent<Omit<{
    /** コンテンツの最小高さ */
    minHeight?: string | number | undefined;
    /** コンテンツの最大幅 */
    maxWidth?: string | number | undefined;
    /** 境界とコンテンツの間の余白 */
    padding?: Gap | undefined;
    /** 天地中央揃えも有効化するかどうか */
    verticalCentering?: boolean | undefined;
    as?: string | React.ComponentType<any> | undefined;
} & {
    children?: React.ReactNode;
} & ElementProps, "ref"> & React.RefAttributes<HTMLDivElement>>;
export {};
