"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Reel = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useSectioningWrapper_1 = require("../../SectioningContent/useSectioningWrapper");
const reel = (0, tailwind_variants_1.tv)({
    base: [
        'shr-flex shr-overflow-x-auto shr-overflow-y-hidden',
        '[&_>_*]:shr-flex- [&_>_*]:shr-flex-shrink-0 [&_>_*]:shr-basis-auto',
        /*
          Chromeで空の要素にflex-gapがあると印刷時にレイアウトが崩れるので gap の値を0にする
          See https://bugs.chromium.org/p/chromium/issues/detail?id=1161709
        */
        'empty:shr-gap-0',
    ],
    variants: {
        gap: {
            0: 'shr-gap-0',
            0.25: 'shr-gap-0.25',
            0.5: 'shr-gap-0.5',
            0.75: 'shr-gap-0.75',
            1: 'shr-gap-1',
            1.25: 'shr-gap-1.25',
            1.5: 'shr-gap-1.5',
            2: 'shr-gap-2',
            2.5: 'shr-gap-2.5',
            3: 'shr-gap-3',
            3.5: 'shr-gap-3.5',
            4: 'shr-gap-4',
            8: 'shr-gap-8',
            '-0.25': '-shr-gap-0.25',
            '-0.5': '-shr-gap-0.5',
            '-0.75': '-shr-gap-0.75',
            '-1': '-shr-gap-1',
            '-1.25': '-shr-gap-1.25',
            '-1.5': '-shr-gap-1.5',
            '-2': '-shr-gap-2',
            '-2.5': '-shr-gap-2.5',
            '-3': '-shr-gap-3',
            '-3.5': '-shr-gap-3.5',
            '-4': '-shr-gap-4',
            '-8': '-shr-gap-8',
            X3S: 'shr-gap-0.25',
            XXS: 'shr-gap-0.5',
            XS: 'shr-gap-1',
            S: 'shr-gap-1.5',
            M: 'shr-gap-2',
            L: 'shr-gap-2.5',
            XL: 'shr-gap-3',
            XXL: 'shr-gap-3.5',
            X3L: 'shr-gap-4',
        },
        padding: {
            0: 'shr-p-0',
            0.25: 'shr-p-0.25',
            0.5: 'shr-p-0.5',
            0.75: 'shr-p-0.75',
            1: 'shr-p-1',
            1.25: 'shr-p-1.25',
            1.5: 'shr-p-1.5',
            2: 'shr-p-2',
            2.5: 'shr-p-2.5',
            3: 'shr-p-3',
            3.5: 'shr-p-3.5',
            4: 'shr-p-4',
            8: 'shr-p-8',
            X3S: 'shr-p-0.25',
            XXS: 'shr-p-0.5',
            XS: 'shr-p-1',
            S: 'shr-p-1.5',
            M: 'shr-p-2',
            L: 'shr-p-2.5',
            XL: 'shr-p-3',
            XXL: 'shr-p-3.5',
            X3L: 'shr-p-4',
        },
    },
});
exports.Reel = (0, react_1.forwardRef)(({ as: Component = 'div', gap = 0.5, padding = 0, className, ...props }, ref) => {
    const styles = (0, react_1.useMemo)(() => reel({ gap, padding, className }), [className, gap, padding]);
    const Wrapper = (0, useSectioningWrapper_1.useSectionWrapper)(Component);
    return (react_1.default.createElement(Wrapper, null,
        react_1.default.createElement(Component, { ...props, ref: ref, className: styles })));
});
//# sourceMappingURL=Reel.js.map