"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Stack = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useSectioningWrapper_1 = require("../../SectioningContent/useSectioningWrapper");
const stack = (0, tailwind_variants_1.tv)({
    base: 'shr-flex-col shr-justify-start [&_>_*]:shr-my-0',
    variants: {
        inline: {
            true: 'shr-inline-flex',
            false: 'shr-flex',
        },
        gap: {
            0: 'shr-space-y-0',
            0.25: 'shr-space-y-0.25',
            0.5: 'shr-space-y-0.5',
            0.75: 'shr-space-y-0.75',
            1: 'shr-space-y-1',
            1.25: 'shr-space-y-1.25',
            1.5: 'shr-space-y-1.5',
            2: 'shr-space-y-2',
            2.5: 'shr-space-y-2.5',
            3: 'shr-space-y-3',
            3.5: 'shr-space-y-3.5',
            4: 'shr-space-y-4',
            8: 'shr-space-y-8',
            X3S: 'shr-space-y-0.25',
            XXS: 'shr-space-y-0.5',
            XS: 'shr-space-y-1',
            S: 'shr-space-y-1.5',
            M: 'shr-space-y-2',
            L: 'shr-space-y-2.5',
            XL: 'shr-space-y-3',
            XXL: 'shr-space-y-3.5',
            X3L: 'shr-space-y-4',
        },
        align: {
            start: 'shr-items-start',
            'flex-start': 'shr-items-start',
            end: 'shr-items-end',
            'flex-end': 'shr-items-end',
            center: 'shr-items-center',
            baseline: 'shr-items-baseline',
            stretch: 'shr-items-stretch',
        },
    },
});
exports.Stack = (0, react_1.forwardRef)(({ as: Component = 'div', inline = false, gap = 1, align, className, ...props }, ref) => {
    const styles = (0, react_1.useMemo)(() => stack({ inline, align, gap, className }), [align, className, gap, inline]);
    const Wrapper = (0, useSectioningWrapper_1.useSectionWrapper)(Component);
    return (react_1.default.createElement(Wrapper, null,
        react_1.default.createElement(Component, { ...props, ref: ref, className: styles })));
});
//# sourceMappingURL=Stack.js.map