"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineClamp = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Tooltip_1 = require("../Tooltip");
const lineClamp = (0, tailwind_variants_1.tv)({
    base: 'smarthr-ui-LineClamp',
    variants: {
        maxLines: {
            1: 'shr-inline-block shr-w-full shr-overflow-hidden shr-overflow-ellipsis shr-whitespace-nowrap shr-align-middle',
            2: 'shr-line-clamp-[2]',
            3: 'shr-line-clamp-[3]',
            4: 'shr-line-clamp-[4]',
            5: 'shr-line-clamp-[5]',
            6: 'shr-line-clamp-[6]',
        },
    },
});
const LineClamp = ({ maxLines = 3, children, className, ...props }) => {
    if (maxLines < 1) {
        throw new Error('"maxLines" cannot be less than 0.');
    }
    const [isTooltipVisible, setTooltipVisible] = (0, react_1.useState)(false);
    const ref = (0, react_1.useRef)(null);
    const isMultiLineOverflow = () => {
        const el = ref.current;
        return el ? el.scrollWidth > el.clientWidth || el.scrollHeight > el.clientHeight : false;
    };
    (0, react_1.useEffect)(() => {
        setTooltipVisible(isMultiLineOverflow());
    }, [maxLines, children]);
    const ActualLineClamp = () => (react_1.default.createElement("span", { ...props, className: styles, ref: ref }, children));
    const styles = (0, react_1.useMemo)(() => lineClamp({ maxLines, className }), [className, maxLines]);
    return isTooltipVisible ? (react_1.default.createElement(Tooltip_1.Tooltip, { message: children, multiLine: true, vertical: "auto" },
        react_1.default.createElement(ActualLineClamp, null))) : (react_1.default.createElement(ActualLineClamp, null));
};
exports.LineClamp = LineClamp;
//# sourceMappingURL=LineClamp.js.map