"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Loader = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const VisuallyHiddenText_1 = require("../VisuallyHiddenText");
const loaderStyle = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: ['smarthr-ui-Loader', 'shr-inline-block', 'shr-overflow-hidden'],
        spinner: [
            'smarthr-ui-Loader-spinner', // Button コンポーネントで使用
            'shr-relative',
            'shr-block',
            'shr-mx-auto',
            'shr-animate-[spin_1.6s_linear_infinite]',
        ],
        line: [
            'smarthr-ui-Loader-line', // Button コンポーネントで使用
            'shr-absolute',
            'shr-block',
            'shr-w-full',
            'shr-h-full',
            'shr-opacity-0',
        ],
        cog: [
            'shr-inline-block',
            'shr-relative',
            'shr-w-1/2',
            'shr-h-full',
            'shr-overflow-hidden',
            'shr-border-inherit',
        ],
        cogInner: [
            'shr-absolute',
            'shr-top-0',
            'shr-block',
            'shr-w-[200%]',
            'shr-h-full',
            'shr-box-border',
            'shr-border-solid',
            'shr-border-inherit',
            'shr-border-b-transparent',
            'shr-rounded-[50%]',
        ],
        textSlot: ['shr-block', 'shr-mt-1', 'shr-text-base', 'shr-text-center'],
    },
    variants: {
        size: {
            s: {
                spinner: ['shr-w-1.5', 'shr-h-1.5'],
                cogInner: ['shr-border-2'],
            },
            m: {
                spinner: ['shr-w-3', 'shr-h-3'],
                cogInner: ['shr-border-4'],
            },
        },
        type: {
            primary: {
                textSlot: ['shr-text-black'],
                line: ['shr-border-main'],
            },
            light: {
                textSlot: ['shr-text-white'],
                line: ['shr-border-white'],
            },
        },
        lineNum: {
            1: {
                line: [
                    'shr-animate-[loader-line-full-unfill-rotate_4.8s_ease-in-out_infinite_both,_loader-line1-fade-in-out_4.8s_ease-in-out_infinite_both]',
                ],
            },
            2: {
                line: [
                    'shr-animate-[loader-line-full-unfill-rotate_4.8s_ease-in-out_infinite_both,_loader-line2-fade-in-out_4.8s_ease-in-out_infinite_both]',
                ],
            },
            3: {
                line: [
                    'shr-animate-[loader-line-full-unfill-rotate_4.8s_ease-in-out_infinite_both,_loader-line3-fade-in-out_4.8s_ease-in-out_infinite_both]',
                ],
            },
            4: {
                line: [
                    'shr-animate-[loader-line-full-unfill-rotate_4.8s_ease-in-out_infinite_both,_loader-line4-fade-in-out_4.8s_ease-in-out_infinite_both]',
                ],
            },
        },
        position: {
            left: {
                cogInner: [
                    'shr-border-r-transparent',
                    'shr-rotate-[129deg]',
                    'shr-animate-[loader-left-spin_1.2s_ease-in-out_infinite_both]',
                    'shr-left-0',
                ],
            },
            right: {
                cogInner: [
                    'shr-border-l-transparent',
                    'shr-rotate-[-129deg]',
                    'shr-animate-[loader-right-spin_1.2s_ease-in-out_infinite_both]',
                    '-shr-left-full',
                ],
            },
        },
    },
});
const Loader = ({ size = 'm', alt = '処理中', text, type = 'primary', role = 'status', className, ...props }) => {
    const { wrapper, spinner, line, cog, cogInner, textSlot } = loaderStyle({
        type,
        size,
    });
    const wrapperStyle = (0, react_1.useMemo)(() => wrapper({ className }), [wrapper, className]);
    const spinnerStyle = (0, react_1.useMemo)(() => spinner(), [spinner]);
    const cogStyle = (0, react_1.useMemo)(() => cog(), [cog]);
    const textStyle = (0, react_1.useMemo)(() => textSlot(), [textSlot]);
    return (react_1.default.createElement("span", { ...props, className: wrapperStyle, role: role },
        react_1.default.createElement("span", { className: spinnerStyle },
            [...Array(4)].map((_, index) => (react_1.default.createElement("span", { className: line({ lineNum: (index + 1) }), key: index },
                react_1.default.createElement("span", { className: cogStyle },
                    react_1.default.createElement("span", { className: cogInner({ position: 'left' }) })),
                react_1.default.createElement("span", { className: cogStyle },
                    react_1.default.createElement("span", { className: cogInner({ position: 'right' }) }))))),
            react_1.default.createElement(VisuallyHiddenText_1.VisuallyHiddenText, null, alt)),
        text && react_1.default.createElement("span", { className: textStyle }, text)));
};
exports.Loader = Loader;
//# sourceMappingURL=Loader.js.map