"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationBar = exports.notificationBar = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Base_1 = require("../Base");
const Button_1 = require("../Button");
const Icon_1 = require("../Icon");
const Layout_1 = require("../Layout");
exports.notificationBar = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-NotificationBar shr-flex shr-items-baseline shr-justify-between shr-gap-0.5 shr-p-0.75',
        inner: 'shr-flex-grow',
        messageArea: [
            'smarthr-ui-NotificationBar-messageArea',
            'shr-flex shr-grow',
            '[&_.smarthr-ui-Icon-withText]:shr-leading-tight',
        ],
        icon: '',
        actionArea: 'smarthr-ui-NotificationBar-actionArea -shr-my-0.5 shr-shrink-0',
        closeButton: 'smarthr-ui-NotificationBar-closeButton -shr-mb-0.5 -shr-mr-0.5 -shr-mt-0.5 shr-flex-shrink-0 shr-text-black',
    },
    variants: {
        /** 下地 */
        base: {
            none: {},
            base: {
                wrapper: 'shr-py-1 shr-pe-1 shr-ps-1.5',
            },
        },
        /** メッセージの種類 */
        type: {
            info: {
                icon: 'shr-text-grey',
            },
            success: {},
            warning: {
                icon: 'shr-text-black',
            },
            error: {},
            sync: {
                icon: 'shr-text-main',
            },
        },
        /** 強調するかどうか */
        bold: {
            true: '',
            false: '',
        },
        /** スライドインするかどうか */
        animate: {
            true: {
                wrapper: 'shr-animate-[notification-bar-slide-in_0.2s_ease-out]',
            },
        },
    },
    compoundVariants: [
        {
            type: ['info', 'success', 'warning', 'error', 'sync'],
            bold: false,
            className: {
                wrapper: 'shr-bg-white shr-text-black',
            },
        },
        {
            type: 'success',
            bold: false,
            className: {
                icon: 'shr-text-main',
            },
        },
        {
            type: 'error',
            bold: false,
            className: {
                icon: 'shr-text-danger',
            },
        },
        {
            type: ['info', 'sync'],
            bold: true,
            className: {
                wrapper: 'shr-bg-white',
            },
        },
        {
            type: 'success',
            bold: true,
            className: {
                wrapper: 'shr-bg-main shr-text-white',
                icon: 'shr-text-white',
                closeButton: 'shr-text-white hover:[&]:shr-bg-main-darken focus-visible:[&]:shr-bg-main-darken',
            },
        },
        {
            type: 'warning',
            bold: true,
            className: {
                wrapper: 'shr-bg-warning-yellow shr-text-black',
                closeButton: 'shr-text-black hover:[&]:shr-bg-warning-yellow-darken focus-visible:[&]:shr-bg-warning-yellow-darken',
            },
        },
        {
            type: 'error',
            bold: true,
            className: {
                wrapper: 'shr-bg-danger shr-text-white',
                icon: 'shr-text-white',
                closeButton: 'shr-text-white hover:[&]:shr-bg-danger-darken focus-visible:[&]:shr-bg-danger-darken',
            },
        },
    ],
});
const NotificationBar = ({ type, bold = false, animate, message, onClose, children, role = type.match(/^(info|sync)$/) ? 'status' : 'alert', base = 'none', layer, className, ...props }) => {
    const Icon = (0, react_1.useMemo)(() => {
        switch (type) {
            case 'info':
                return Icon_1.FaCircleInfoIcon;
            case 'success': {
                return Icon_1.FaCircleCheckIcon;
            }
            case 'warning': {
                return bold ? Icon_1.FaTriangleExclamationIcon : Icon_1.WarningIcon;
            }
            case 'error': {
                return Icon_1.FaCircleExclamationIcon;
            }
            case 'sync': {
                return Icon_1.FaRotateIcon;
            }
        }
    }, [type, bold]);
    const { baseComponent: WrapBase = react_1.default.Fragment, baseProps = {} } = (0, react_1.useMemo)(() => base === 'base'
        ? {
            baseComponent: Base_1.Base,
            baseProps: {
                layer,
                overflow: 'hidden',
            },
        }
        : {}, [base, layer]);
    const { wrapperStyle, innerStyle, messageAreaStyle, iconStyle, actionAreaStyle, closeButtonStyle, } = (0, react_1.useMemo)(() => {
        const { wrapper, inner, messageArea, icon, actionArea, closeButton } = (0, exports.notificationBar)({
            type,
            bold,
            base,
        });
        return {
            wrapperStyle: wrapper({ animate, className }),
            innerStyle: inner(),
            messageAreaStyle: messageArea(),
            iconStyle: icon(),
            actionAreaStyle: actionArea(),
            closeButtonStyle: closeButton(),
        };
    }, [animate, base, bold, className, type]);
    return (react_1.default.createElement(WrapBase, { ...baseProps },
        react_1.default.createElement("div", { ...props, className: wrapperStyle, role: role },
            react_1.default.createElement(Layout_1.Cluster, { gap: 1, align: "center", justify: "flex-end", className: innerStyle },
                react_1.default.createElement("div", { className: messageAreaStyle },
                    react_1.default.createElement(Icon, { text: message, iconGap: 0.5, className: iconStyle })),
                children && (react_1.default.createElement(Layout_1.Cluster, { align: "center", justify: "flex-end", className: actionAreaStyle }, children))),
            onClose && (react_1.default.createElement(Button_1.Button, { variant: "text", size: "s", onClick: onClose, className: closeButtonStyle },
                react_1.default.createElement(Icon_1.FaXmarkIcon, { alt: "\u9589\u3058\u308B" }))))));
};
exports.NotificationBar = NotificationBar;
//# sourceMappingURL=NotificationBar.js.map