"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PageCounter = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Layout_1 = require("../Layout");
const Text_1 = require("../Text");
const executeDecorator = (defaultText, decorator) => decorator?.(defaultText) || defaultText;
const UNIT_TOTAL_TEXT = '件中';
const UNIT_TEXT = '件';
const RANGE_SEPARATOR = '–';
const RANGE_SEPARATOR_VISUALLY_HIDDEN_TEXT = 'から';
const pageCounter = (0, tailwind_variants_1.tv)({ base: 'shr-text-base' });
const PageCounter = ({ start, end, total = 0, decorators, className, ...props }) => {
    const unitTotalText = (0, react_1.useMemo)(() => executeDecorator(UNIT_TOTAL_TEXT, decorators?.unitForTotal), [decorators?.unitForTotal]);
    const unitText = (0, react_1.useMemo)(() => executeDecorator(UNIT_TEXT, decorators?.unit), [decorators?.unit]);
    const rangeSeparatorDecorators = (0, react_1.useMemo)(() => ({
        text: () => executeDecorator(RANGE_SEPARATOR, decorators?.rangeSeparator),
        visuallyHiddenText: () => executeDecorator(RANGE_SEPARATOR_VISUALLY_HIDDEN_TEXT, decorators?.rangeSeparatorVisuallyHiddenText),
    }), [decorators?.rangeSeparator, decorators?.rangeSeparatorVisuallyHiddenText]);
    const style = (0, react_1.useMemo)(() => pageCounter({ className }), [className]);
    return (react_1.default.createElement(Layout_1.Cluster, { ...props, inline: true, align: "baseline", className: style },
        total > 0 && (react_1.default.createElement(Layout_1.Cluster, { as: "span", gap: 0.25, inline: true, align: "baseline" },
            react_1.default.createElement(Text_1.Text, { weight: "bold", as: "b" }, total.toLocaleString()),
            unitTotalText)),
        react_1.default.createElement(Layout_1.Cluster, { as: "span", gap: 0.25, inline: true, align: "baseline" },
            react_1.default.createElement(Text_1.Text, { weight: "bold", as: "b" }, start.toLocaleString()),
            react_1.default.createElement(Text_1.RangeSeparator, { decorators: rangeSeparatorDecorators }),
            react_1.default.createElement(Text_1.Text, { weight: "bold", as: "b" }, end.toLocaleString()),
            unitText)));
};
exports.PageCounter = PageCounter;
//# sourceMappingURL=PageCounter.js.map