"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pagination = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const lodash_1 = require("../../libs/lodash");
const Layout_1 = require("../Layout");
const SectioningContent_1 = require("../SectioningContent");
const PaginationControllerItemButton_1 = require("./PaginationControllerItemButton");
const PaginationItemButton_1 = require("./PaginationItemButton");
const pagination = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-Pagination shr-inline-block shr-max-w-full',
        list: 'shr-m-0.25 shr-list-none shr-ps-[unset]',
        firstListItem: 'smarthr-ui-Pagination-first',
        prevListItem: 'smarthr-ui-Pagination-prev',
        nextListItem: 'smarthr-ui-Pagination-next',
        lastListItem: 'smarthr-ui-Pagination-last',
    },
    variants: {
        withoutNumbers: {
            true: {
                firstListItem: 'shr-mr-0.5',
                prevListItem: 'shr-mr-0',
                nextListItem: 'shr-ml-0',
                lastListItem: 'shr-ml-0.5',
            },
            false: {
                prevListItem: 'shr-mr-0.5',
                nextListItem: 'shr-ml-0.5',
            },
        },
    },
});
const Pagination = ({ total, current, onClick, padding = 4, className = '', withoutNumbers = false, ...props }) => {
    const { wrapper, list, firstListItem, prevListItem, nextListItem, lastListItem } = pagination();
    const { wrapperStyle, listStyle, firstListItemStyle, prevListItemStyle, nextListItemStyle, lastListItemStyle, } = (0, react_1.useMemo)(() => {
        const itemArg = { withoutNumbers };
        return {
            wrapperStyle: wrapper({ className }),
            listStyle: list(),
            firstListItemStyle: firstListItem(itemArg),
            prevListItemStyle: prevListItem(itemArg),
            nextListItemStyle: nextListItem(itemArg),
            lastListItemStyle: lastListItem(itemArg),
        };
    }, [
        className,
        withoutNumbers,
        wrapper,
        list,
        firstListItem,
        prevListItem,
        nextListItem,
        lastListItem,
    ]);
    if (total <= 1)
        return null;
    const pages = !withoutNumbers
        ? [
            ...(0, lodash_1.range)(current - padding, current).filter((page) => page >= 1),
            ...(0, lodash_1.range)(current, current + padding + 1).filter((page) => page <= total),
        ].map((page) => (react_1.default.createElement("li", { key: `pagination-${page}`, className: page === current ? 'smarthr-ui-Pagination-current' : 'smarthr-ui-Pagination-page' },
            react_1.default.createElement(PaginationItemButton_1.PaginationItemButton, { page: page, currentPage: current, onClick: onClick }))))
        : null;
    const disabledPrev = current === 1;
    const disabledNext = current === total;
    return (
    // eslint-disable-next-line smarthr/a11y-heading-in-sectioning-content
    react_1.default.createElement(SectioningContent_1.Nav, { ...props, className: wrapperStyle, "aria-label": "\u30DA\u30FC\u30B8\u30CD\u30FC\u30B7\u30E7\u30F3" },
        react_1.default.createElement(Layout_1.Reel, null,
            react_1.default.createElement(Layout_1.Cluster, { as: "ul", className: listStyle },
                react_1.default.createElement("li", { className: firstListItemStyle },
                    react_1.default.createElement(PaginationControllerItemButton_1.PaginationControllerItemButton, { onClick: onClick, direction: "prev", targetPage: 1, disabled: disabledPrev, double: true })),
                react_1.default.createElement("li", { className: prevListItemStyle },
                    react_1.default.createElement(PaginationControllerItemButton_1.PaginationControllerItemButton, { onClick: onClick, direction: "prev", targetPage: current - 1, disabled: disabledPrev })),
                pages,
                react_1.default.createElement("li", { className: nextListItemStyle },
                    react_1.default.createElement(PaginationControllerItemButton_1.PaginationControllerItemButton, { onClick: onClick, direction: "next", targetPage: current + 1, disabled: disabledNext })),
                react_1.default.createElement("li", { className: lastListItemStyle },
                    react_1.default.createElement(PaginationControllerItemButton_1.PaginationControllerItemButton, { onClick: onClick, direction: "next", targetPage: total, disabled: disabledNext, double: true }))))));
};
exports.Pagination = Pagination;
//# sourceMappingURL=Pagination.js.map