"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationControllerItemButton = void 0;
const react_1 = __importDefault(require("react"));
const Button_1 = require("../Button");
const Icon_1 = require("../Icon");
const getIconProps = (direction, double) => direction === 'prev'
    ? double
        ? { Icon: Icon_1.FaAngleDoubleLeftIcon, alt: '最初へ' }
        : { Icon: Icon_1.FaChevronLeftIcon, alt: '前へ' }
    : double
        ? { Icon: Icon_1.FaAngleDoubleRightIcon, alt: '最後へ' }
        : { Icon: Icon_1.FaChevronRightIcon, alt: '次へ' };
const PaginationControllerItemButton = ({ direction, disabled, double = false, targetPage, onClick, }) => {
    const { Icon, ...iconProps } = getIconProps(direction, double);
    return (react_1.default.createElement(Button_1.Button, { square: true, size: "s", className: "shr-rounded-s", onClick: () => onClick(targetPage), disabled: disabled, "aria-label": iconProps.alt },
        react_1.default.createElement(Icon, { color: disabled ? 'TEXT_DISABLED' : 'TEXT_BLACK', alt: iconProps.alt })));
};
exports.PaginationControllerItemButton = PaginationControllerItemButton;
//# sourceMappingURL=PaginationControllerItemButton.js.map