"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioButton = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useId_1 = require("../../hooks/useId");
const radioButton = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-RadioButton shr-inline-flex shr-items-baseline',
        label: 'smarthr-ui-RadioButton-label shr-ms-0.5 shr-text-base shr-leading-tight',
        innerWrapper: 'shr-relative shr-inline-block shr-h-em shr-w-em shr-shrink-0 shr-translate-y-[0.125em] shr-leading-none',
        box: [
            'shr-pointer-events-none',
            'shr-border-shorthand shr-box-border shr-block shr-h-full shr-w-full shr-rounded-full shr-bg-white',
            /* 強制カラーモードのときは、ブラウザ標準のUIを表示する */
            'forced-colors:shr-hidden',
            'contrast-more:shr-border-high-contrast',
            'peer-checked:shr-border-main peer-checked:shr-bg-main contrast-more:peer-checked:shr-border-high-contrast',
            'peer-checked:before:shr-pointer-events-none peer-checked:before:shr-absolute peer-checked:before:shr-left-1/2 peer-checked:before:shr-top-1/2 peer-checked:before:shr-h-[0.375em] peer-checked:before:shr-w-[0.375em] peer-checked:before:-shr-translate-x-1/2 peer-checked:before:-shr-translate-y-1/2 peer-checked:before:shr-rounded-full peer-checked:before:shr-bg-white peer-checked:before:shr-content-[""]',
            'peer-disabled:shr-border-default/50 peer-disabled:shr-bg-white-darken',
            'peer-disabled:peer-checked:shr-border-default peer-disabled:peer-checked:shr-bg-border peer-disabled:peer-checked:before:shr-bg-white-darken',
            'peer-focus-visible:shr-focus-indicator',
        ],
        input: [
            'smarthr-ui-RadioButton-radioButton shr-peer',
            'shr-absolute shr-left-0 shr-top-0 shr-m-0 shr-h-full shr-w-full shr-cursor-pointer shr-opacity-0',
            'disabled:shr-pointer-events-none',
            /* 強制カラーモードのときは、ブラウザ標準のUIを表示する */
            'forced-colors:shr-static forced-colors:shr-opacity-100',
        ],
    },
    variants: {
        disabled: {
            true: {
                label: 'shr-cursor-[revert] shr-text-disabled',
            },
            false: {
                label: 'shr-cursor-pointer',
                box: 'peer-hover:shr-shadow-input-hover',
            },
        },
    },
});
exports.RadioButton = (0, react_1.forwardRef)(({ onChange, children, className, ...props }, ref) => {
    const { wrapperStyle, innerWrapperStyle, boxStyle, inputStyle, labelStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, innerWrapper, box, input, label } = radioButton();
        return {
            wrapperStyle: wrapper({ className }),
            innerWrapperStyle: innerWrapper(),
            boxStyle: box({ disabled: !!props.disabled }),
            inputStyle: input(),
            labelStyle: label({ disabled: !!props.disabled }),
        };
    }, [className, props.disabled]);
    const handleChange = (0, react_1.useCallback)((e) => {
        if (onChange)
            onChange(e);
    }, [onChange]);
    const radioButtonId = (0, useId_1.useId)(props.id);
    return (react_1.default.createElement("span", { className: wrapperStyle },
        react_1.default.createElement("span", { className: innerWrapperStyle },
            react_1.default.createElement("input", { ...props, type: "radio", id: radioButtonId, onChange: handleChange, className: inputStyle, ref: ref }),
            react_1.default.createElement("span", { className: boxStyle, "aria-hidden": "true" })),
        children && (react_1.default.createElement("label", { htmlFor: radioButtonId, className: labelStyle }, children))));
});
//# sourceMappingURL=RadioButton.js.map