"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioButtonPanel = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Base_1 = require("../Base");
const RadioButton_1 = require("../RadioButton");
const MEANLESS_TAG_NAMES = ['div', 'span'];
const radioButtonPanel = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-RadioButtonPanel',
        'shr-border-shorthand shr-list-none shr-shadow-none',
        // なぜか :has が動作しないので重ねて書いている
        'has-[:focus-visible]:shr-focus-indicator [&:has(:focus-visible)]:shr-focus-indicator',
        '[&_.smarthr-ui-RadioButton-radioButton:focus-visible_+_span]:shr-shadow-none',
        '[&_.smarthr-ui-RadioButton-label]:shr-ms-0.75',
        'has-[:disabled]:shr-cursor-default has-[:disabled]:[&_.smarthr-ui-RadioButton-label]:shr-cursor-default',
    ],
    variants: {
        disabled: {
            false: 'shr-cursor-pointer [&_.smarthr-ui-RadioButton-label]:shr-cursor-pointer',
        },
    },
});
const RadioButtonPanel = ({ onClick, as, className, ...props }) => {
    const styles = (0, react_1.useMemo)(() => radioButtonPanel({ disabled: !!props.disabled, className }), [className, props.disabled]);
    // 外側の装飾を押しても内側のラジオボタンが押せるようにする
    const innerRef = (0, react_1.useRef)(null);
    const handleOuterClick = () => {
        innerRef.current?.click();
    };
    return (
    // eslint-disable-next-line smarthr/a11y-delegate-element-has-role-presentation
    react_1.default.createElement(Base_1.Base, { padding: 1, role: MEANLESS_TAG_NAMES.includes(`${as || ''}`) ? 'presentation' : undefined, onClick: handleOuterClick, as: as, className: styles },
        react_1.default.createElement(RadioButton_1.RadioButton, { ...props, ref: innerRef })));
};
exports.RadioButtonPanel = RadioButtonPanel;
//# sourceMappingURL=RadioButtonPanel.js.map