"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseMessage = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Icon_1 = require("../Icon");
const responseMessage = (0, tailwind_variants_1.tv)({
    base: '',
    variants: {
        type: {
            info: 'shr-fill-grey',
            success: 'shr-fill-main',
            warning: '',
            error: 'shr-fill-danger',
            sync: 'shr-fill-main',
        },
    },
});
const ResponseMessage = ({ type = 'info', children, ...other }) => {
    const styles = (0, react_1.useMemo)(() => responseMessage({ type }), [type]);
    const Icon = (0, react_1.useMemo)(() => {
        switch (type) {
            case 'info':
                return Icon_1.FaCircleInfoIcon;
            case 'success':
                return Icon_1.FaCircleCheckIcon;
            case 'warning':
                return Icon_1.WarningIcon;
            case 'error':
                return Icon_1.FaCircleExclamationIcon;
            case 'sync':
                return Icon_1.FaRotateIcon;
        }
    }, [type]);
    return react_1.default.createElement(Icon, { ...other, text: children, className: styles });
};
exports.ResponseMessage = ResponseMessage;
//# sourceMappingURL=ResponseMessage.js.map