import React, { ComponentPropsWithRef, FC, PropsWithChildren } from 'react';
type BaseProps = PropsWithChildren<{
    as?: 'article' | 'aside' | 'nav' | 'section';
    baseLevel?: number;
}>;
type SectioningContentProps = Omit<ComponentPropsWithRef<'section'>, keyof BaseProps> & BaseProps;
declare const SectioningContent: React.ForwardRefExoticComponent<Omit<SectioningContentProps, "ref"> & React.RefAttributes<HTMLElement>>;
type Props = Omit<React.ComponentProps<typeof SectioningContent>, 'as'>;
export declare const Section: FC<Props>;
export declare const Article: FC<Props>;
export declare const Aside: FC<Props>;
export declare const Nav: FC<Props>;
export declare const SectioningFragment: FC<PropsWithChildren<{
    baseLevel?: number;
}>>;
export {};
