"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SegmentedControl = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const segmentedControl = (0, tailwind_variants_1.tv)({
    slots: {
        container: 'smarthr-ui-SegmentedControl shr-inline-flex',
        buttonGroup: '-shr-space-x-px',
        button: [
            'smarthr-ui-SegmentedControl-button',
            'shr-m-0',
            'shr-rounded-none',
            'aria-checked:shr-border-main',
            'aria-checked:shr-bg-main',
            'aria-checked:shr-text-white',
            'aria-checked:hover:shr-border-main/50',
            'aria-checked:hover:shr-bg-main/50',
            'focus-visible:shr-focus-indicator',
            'first:shr-rounded-tl-m',
            'first:shr-rounded-bl-m',
            'last:shr-rounded-tr-m',
            'last:shr-rounded-br-m',
        ],
    },
});
const SegmentedControl = ({ options, value, onClickOption, size = 'default', isSquare = false, className = '', ...props }) => {
    const [isFocused, setIsFocused] = (0, react_1.useState)(false);
    const containerRef = (0, react_1.useRef)(null);
    const { containerStyle, buttonGroupStyle, buttonStyle } = (0, react_1.useMemo)(() => {
        const { container, buttonGroup, button } = segmentedControl();
        return {
            containerStyle: container({ className }),
            buttonGroupStyle: buttonGroup(),
            buttonStyle: button(),
        };
    }, [className]);
    const handleKeyDown = (0, react_1.useCallback)((e) => {
        if (!isFocused || !containerRef.current || !document.activeElement) {
            return;
        }
        const radios = Array.from(containerRef.current.querySelectorAll('[role="radio"]:not(:disabled)'));
        if (radios.length < 2) {
            return;
        }
        const focusedIndex = radios.indexOf(document.activeElement);
        if (focusedIndex === -1) {
            return;
        }
        switch (e.key) {
            case 'Down':
            case 'ArrowDown':
            case 'Right':
            case 'ArrowRight': {
                const nextIndex = focusedIndex + 1;
                const nextRadio = radios[nextIndex % radios.length];
                if (nextRadio instanceof HTMLButtonElement) {
                    nextRadio.focus();
                }
                break;
            }
            case 'Up':
            case 'ArrowUp':
            case 'Left':
            case 'ArrowLeft': {
                const nextIndex = focusedIndex - 1;
                const nextRadio = radios[(nextIndex + radios.length) % radios.length];
                if (nextRadio instanceof HTMLButtonElement) {
                    nextRadio.focus();
                }
                break;
            }
        }
    }, [isFocused]);
    (0, react_1.useEffect)(() => {
        document.addEventListener('keydown', handleKeyDown);
        return () => {
            document.removeEventListener('keydown', handleKeyDown);
        };
    }, [handleKeyDown]);
    const includesSelected = value && options.some((option) => option.value === value);
    const getRovingTabIndex = (0, react_1.useCallback)((option, index) => {
        if (isFocused) {
            return -1;
        }
        if (!includesSelected) {
            return index === 0 ? 0 : -1;
        }
        return option.value === value ? 0 : -1;
    }, [includesSelected, isFocused, value]);
    return (react_1.default.createElement("div", { ...props, className: containerStyle, onFocus: () => setIsFocused(true), onBlur: () => setIsFocused(false), ref: containerRef, role: "toolbar" },
        react_1.default.createElement("div", { role: "radiogroup", className: buttonGroupStyle }, options.map((option, i) => {
            const onClick = onClickOption ? () => onClickOption(option.value) : undefined;
            return (react_1.default.createElement(Button_1.Button, { "aria-label": option.ariaLabel, key: option.value, disabled: option.disabled, onClick: onClick, size: size, square: isSquare, tabIndex: getRovingTabIndex(option, i), role: "radio", "aria-checked": !!value && value === option.value, className: buttonStyle }, option.content));
        }))));
};
exports.SegmentedControl = SegmentedControl;
//# sourceMappingURL=SegmentedControl.js.map