"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Select = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const ua_1 = require("../../libs/ua");
const util_1 = require("../../libs/util");
const Icon_1 = require("../Icon");
const BLANK_LABEL = '選択してください';
const select = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: 'smarthr-ui-Select shr-relative shr-inline-block',
        selectEl: [
            'shr-peer shr-border-shorthand shr-w-full shr-cursor-pointer shr-appearance-none shr-rounded-m shr-bg-white shr-text-base shr-leading-tight shr-text-black shr-outline-none',
            'hover:shr-bg-white-darken',
            'focus-visible:shr-focus-indicator',
            'disabled:shr-pointer-events-none disabled:shr-bg-white-darken disabled:shr-text-disabled disabled:shr-opacity-100',
            'contrast-more:shr-border-r-highContrast',
            /* padding に依る積み上げでは文字が見切れてしまうため */
            'shr-min-h-[calc(theme(fontSize.base)_+_theme(spacing[0.75])_*_2_+_theme(spacing.px)_*_2)]',
        ],
        iconWrap: [
            'shr-pointer-events-none shr-absolute shr-inset-y-0 shr-inline-flex shr-items-center shr-text-grey',
            'peer-focus-visible:shr-text-black peer-disabled:shr-text-disabled',
        ],
        blankOptgroup: 'shr-hidden',
    },
    variants: {
        size: {
            default: {
                selectEl: 'shr-py-0.5 shr-pe-2 shr-ps-0.5',
                iconWrap: 'shr-end-0.75',
            },
            s: {
                selectEl: [
                    'shr-px-0.5 shr-py-0.25 shr-text-sm',
                    /* padding に依る積み上げでは文字が見切れてしまうため */
                    'shr-min-h-[calc(theme(fontSize.sm)_+_theme(spacing[0.5])_*_2_+_theme(spacing.px)_*_2)]',
                ],
                iconWrap: 'shr-end-0.5 shr-text-sm',
            },
        },
        error: {
            true: {
                selectEl: 'shr-border-danger',
            },
            false: {
                selectEl: 'shr-border-default disabled:shr-border-disabled',
            },
        },
    },
});
const ActualSelect = ({ options, onChange, onChangeValue, error = false, width, hasBlank = false, decorators, size = 'default', className, disabled, ...props }, ref) => {
    const handleChange = (0, react_1.useCallback)((e) => {
        if (onChange)
            onChange(e);
        if (onChangeValue) {
            const flattenOptions = options.reduce((pre, cur) => pre.concat('value' in cur ? cur : cur.options), []);
            const selectedOption = flattenOptions.find((option) => option.value === e.target.value);
            if (selectedOption) {
                onChangeValue(selectedOption.value);
            }
        }
    }, [onChange, onChangeValue, options]);
    const { wrapperStyleProps, selectStyle, iconWrapStyle, blankOptGroupStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, selectEl, iconWrap, blankOptgroup } = select();
        return {
            wrapperStyleProps: {
                className: wrapper({ className }),
                style: {
                    width: typeof width === 'number' ? `${width}px` : width,
                },
            },
            selectStyle: selectEl({ error, size }),
            iconWrapStyle: iconWrap({ size }),
            blankOptGroupStyle: blankOptgroup(),
        };
    }, [className, error, size, width]);
    return (react_1.default.createElement("span", { ...wrapperStyleProps },
        react_1.default.createElement("select", { ...props, onChange: handleChange, "aria-invalid": error || undefined, disabled: disabled, ref: ref, className: selectStyle },
            hasBlank && (react_1.default.createElement("option", { value: "" }, decorators?.blankLabel?.(BLANK_LABEL) || BLANK_LABEL)),
            options.map((option) => {
                if ('value' in option) {
                    return (react_1.default.createElement("option", { ...option, key: option.value }, option.label));
                }
                const { options: groupedOptions, ...optgroup } = option;
                return (react_1.default.createElement("optgroup", { ...optgroup, key: optgroup.label }, groupedOptions.map((groupedOption) => (react_1.default.createElement("option", { ...groupedOption, key: groupedOption.value }, groupedOption.label)))));
            }),
            // Support for not omitting labels in Mobile Safari
            ua_1.isMobileSafari && react_1.default.createElement("optgroup", { className: blankOptGroupStyle })),
        react_1.default.createElement("span", { className: iconWrapStyle },
            react_1.default.createElement(Icon_1.FaSortIcon, null))));
};
exports.Select = (0, util_1.genericsForwardRef)(ActualSelect);
//# sourceMappingURL=Select.js.map