import { ComponentProps, ComponentPropsWithoutRef, FC } from 'react';
import { OnClick, SideNavItemButton, SideNavSizeType } from './SideNavItemButton';
type SideNavItemButtonProps = Omit<ComponentProps<typeof SideNavItemButton>, 'size' | 'onClick'>;
type Props = {
    /** 各アイテムのデータの配列 */
    items: SideNavItemButtonProps[];
    /** 各アイテムの大きさ */
    size?: SideNavSizeType;
    /** アイテムを押下したときに発火するコールバック関数 */
    onClick?: OnClick;
    /** コンポーネントに適用するクラス名 */
    className?: string;
};
type ElementProps = Omit<ComponentPropsWithoutRef<'ul'>, keyof Props>;
export declare const SideNav: FC<Props & ElementProps>;
export {};
