"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SideNavItemButton = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../Button");
const Layout_1 = require("../Layout");
const sideNavItem = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: ['smarthr-ui-SideNav-item'],
        button: [
            'shr-w-full shr-cursor-pointer shr-leading-none [&]:shr-box-border',
            'focus-visible:shr-focus-indicator',
        ],
        buttonInner: 'smarthr-ui-SideNav-itemTitle',
    },
    variants: {
        selected: {
            true: {
                wrapper: [
                    'shr-relative shr-bg-main shr-text-white',
                    'after:shr-absolute after:-shr-right-0.25 after:shr-top-1/2 after:-shr-translate-y-1/2 after:shr-translate-x-0 after:shr-border-b-4 after:shr-border-l-4 after:shr-border-r-0 after:shr-border-t-4 after:shr-border-solid after:shr-border-b-transparent after:shr-border-l-main after:shr-border-r-transparent after:shr-border-t-transparent after:shr-content-[""]',
                ],
            },
            false: {
                wrapper: 'hover:shr-bg-column-darken',
            },
        },
        size: {
            default: {
                button: 'shr-p-1 shr-text-base',
            },
            s: {
                button: 'shr-px-1 shr-py-0.5 shr-text-sm',
            },
        },
    },
});
const SideNavItemButton = ({ id, title, prefix, isSelected = false, size, onClick, }) => {
    const handleClick = onClick
        ? (e) => onClick(e, id)
        : undefined;
    const { wrapperStyle, buttonStyle, buttonInnerStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, button, buttonInner } = sideNavItem();
        return {
            wrapperStyle: wrapper({ selected: isSelected }),
            buttonStyle: button({ size }),
            buttonInnerStyle: buttonInner(),
        };
    }, [isSelected, size]);
    return (react_1.default.createElement("li", { className: wrapperStyle },
        react_1.default.createElement(Button_1.UnstyledButton, { onClick: handleClick, className: buttonStyle },
            react_1.default.createElement(Layout_1.Cluster, { inline: true, align: "center", as: "span" },
                prefix,
                react_1.default.createElement("span", { className: buttonInnerStyle }, title)))));
};
exports.SideNavItemButton = SideNavItemButton;
//# sourceMappingURL=SideNavItemButton.js.map