"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpreadsheetTable = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const SpreadsheetTableCorner_1 = require("./SpreadsheetTableCorner");
const spreadsheetTable = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-SpreadsheetTable shr-border-shorthand shr-border-collapse shr-bg-head',
        // th
        '[&_th]:shr-p-0.25 [&_th]:shr-text-sm [&_th]:shr-font-normal [&_th]:shr-text-grey',
        // th + th
        '[&_th_+_th]:shr-border-l-shorthand [&_th_+_th]:shr-border-[theme(backgroundColor[head-darken])]',
        // 左上の角： tr:first-child th:first-child
        '[&_tr:first-child_th:first-child]:shr-w-[calc(1em_*_theme(lineHeight.normal))]',
        // tr + tr th
        '[&_tr_+_tr_th]:shr-border-t-shorthand [&_tr_+_tr_th]:shr-border-[theme(backgroundColor[head-darken])]',
        // td
        '[&_td]:shr-border-shorthand [&_td]:shr-bg-white [&_td]:shr-p-0.25 [&_td]:shr-text-sm',
    ],
});
const SpreadsheetTable = ({ data, className, children, ...props }) => {
    const style = (0, react_1.useMemo)(() => spreadsheetTable({ className }), [className]);
    return (react_1.default.createElement("table", { ...props, className: style },
        data && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("thead", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement(SpreadsheetTableCorner_1.SpreadsheetTableCorner, null),
                    data[0].map((_, i) => (react_1.default.createElement("th", { key: `headRow-${i}` }, String.fromCharCode(65 + i)))))),
            react_1.default.createElement("tbody", null, data.map((row, i) => (react_1.default.createElement("tr", { key: `bodyRow-${i}` },
                react_1.default.createElement("th", null, i + 1),
                row.map((cell, j) => (react_1.default.createElement("td", { key: `bodyCell-${i}-${j}` }, cell))))))))),
        children));
};
exports.SpreadsheetTable = SpreadsheetTable;
//# sourceMappingURL=SpreadsheetTable.js.map