"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusLabel = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Icon_1 = require("../Icon");
const statusLabel = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-StatusLabel',
        'shr-box-content',
        'shr-font-bold',
        'shr-inline-flex',
        'shr-items-center',
        'shr-justify-center',
        'shr-gap-0.25',
        'shr-px-0.5',
        'shr-py-0.25',
        'shr-whitespace-nowrap',
        'shr-text-sm',
        // ラベルが天地中央に揃わないため暫定対応
        'shr-leading-[0]',
        'shr-min-w-[3.5em]',
        'shr-min-h-em',
        'shr-border-shorthand',
    ],
    variants: {
        type: {
            grey: [],
            blue: [],
            green: [],
            red: [],
            warning: ['shr-bg-warning-yellow', 'shr-text-black'],
            error: ['shr-bg-danger', 'shr-border-danger', 'shr-text-white'],
        },
        bold: {
            true: [],
        },
    },
    compoundVariants: [
        {
            type: ['blue', 'green', 'red', 'warning'],
            bold: false,
            className: ['shr-border-current'],
        },
        {
            type: ['grey', 'blue', 'green', 'red'],
            bold: false,
            className: ['shr-bg-white'],
        },
        {
            type: 'grey',
            bold: false,
            class: ['shr-border-grey-20', 'shr-text-grey', 'contrast-more:shr-border-high-contrast'],
        },
        {
            type: 'blue',
            bold: false,
            class: ['shr-text-main'],
        },
        {
            type: 'green',
            bold: false,
            /* SmartHR 基本色の Aqua04。StatusLabel 以外では使いません。
             * https://smarthr.design/basics/colors/#h4-1 */
            class: ['shr-text-[#0f7f85]'],
        },
        {
            type: 'red',
            bold: false,
            class: ['shr-text-danger'],
        },
        {
            type: 'warning',
            bold: false,
            class: ['shr-border-warning-yellow'],
        },
        {
            type: ['grey', 'blue', 'green', 'red', 'error'],
            bold: true,
            class: ['shr-text-white'],
        },
        {
            type: 'grey',
            bold: true,
            class: ['shr-bg-[theme(colors.grey.65)]', 'shr-border-grey-65'],
        },
        {
            type: 'blue',
            bold: true,
            class: ['shr-bg-main', 'shr-border-main'],
        },
        {
            type: 'green',
            bold: true,
            /* SmartHR 基本色の Aqua04。StatusLabel 以外では使いません。
             * https://smarthr.design/basics/colors/#h4-1 */
            class: ['shr-border-[#0f7f85]', 'shr-bg-[#0f7f85]'],
        },
        {
            type: 'red',
            bold: true,
            class: ['shr-bg-danger', 'shr-border-danger'],
        },
        {
            type: 'warning',
            bold: true,
            class: ['shr-border-current', 'shr-text-black'],
        },
    ],
});
const StatusLabel = ({ type = 'grey', bold = false, className, children, ...props }) => {
    const Icon = (0, react_1.useMemo)(() => {
        switch (true) {
            case type === 'warning' && bold: {
                return Icon_1.FaExclamationTriangleIcon;
            }
            case type === 'error' && bold: {
                return Icon_1.FaExclamationCircleIcon;
            }
            default: {
                return react_1.default.Fragment;
            }
        }
    }, [type, bold]);
    const wrapperStyle = (0, react_1.useMemo)(() => statusLabel({
        className,
        type,
        bold,
    }), [className, type, bold]);
    return (react_1.default.createElement("span", { ...props, className: wrapperStyle },
        react_1.default.createElement(Icon, null),
        children));
};
exports.StatusLabel = StatusLabel;
//# sourceMappingURL=StatusLabel.js.map