"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Switch = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Icon_1 = require("../Icon");
const switchStyle = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: [
            // Switch 本体
            'shr-border-shorthand shr-relative shr-inline-flex shr-w-[calc(theme(fontSize.base)*2)] shr-items-center shr-rounded-full shr-bg-white',
            // 理想的には padding: 2px; だが、box-shadow を outline で使用しているため、border と padding で2pxの疑似余白を作っている。
            'shr-p-px',
            // :focus-visible-within の代替
            'has-[:focus-visible]:shr-focus-indicator',
            'has-[:checked]:shr-border-[theme(colors.main)] has-[:checked]:shr-bg-main',
            'has-[:disabled]:shr-border-[theme(borderColor.default)] has-[:disabled]:shr-bg-border',
            'forced-colors:has-[:disabled]:shr-border-[GrayText]',
            'supports-[not_selector(:has(+_*))]:shr-border-[revert] supports-[not_selector(:has(+_*))]:shr-bg-[revert]',
            // Switch ツマミ
            'before:shr-box-border before:shr-inline-block before:shr-size-[theme(fontSize.base)] before:shr-scale-[calc(2/3)] before:shr-rounded-full before:shr-border before:shr-border-solid before:shr-border-[theme(colors.grey.30)] before:shr-bg-[theme(colors.grey.30)] before:shr-transition-[transform,margin] before:shr-duration-150 before:shr-ease-out before:shr-content-[""]',
            'has-[:checked]:before:shr-border-shorthand has-[:checked]:before:shr-ms-[theme(fontSize.base)] has-[:checked]:before:shr-scale-100 has-[:checked]:before:shr-bg-white',
            'forced-colors:has-[input:not(:disabled)]:before:shr-bg-[ButtonBorder]',
            'forced-colors:has-[:disabled:not(:checked)]:before:shr-border-solid forced-colors:has-[:disabled:not(:checked)]:before:shr-border-[GrayText]',
            'forced-colors:has-[:disabled:checked]:before:shr-border-[GrayText]',
            'supports-[not_selector(:has(+_*))]:before:hidden',
        ],
        input: [
            'shr-absolute shr-inset-0 shr-m-0 shr-h-full shr-w-full shr-cursor-pointer shr-appearance-none shr-rounded-full shr-opacity-0',
            'disabled:shr-cursor-[revert]',
            'supports-[not_selector(:has(+_*))]:shr-static supports-[not_selector(:has(+_*))]:shr-appearance-auto supports-[not_selector(:has(+_*))]:shr-opacity-100 supports-[not_selector(:has(+_*))]:shr-outline-[revert]',
        ],
        iconWrapper: [
            'shr-pointer-events-none shr-absolute shr-hidden shr-size-[theme(fontSize.base)] shr-items-center shr-justify-center',
            '[:checked~&]:shr-flex',
        ],
        icon: [
            '[:checked~*>&]:shr-fill-white',
            'forced-colors:[:checked~*>&]:shr-fill-[ButtonText]',
            'forced-colors:[:disabled~*>&]:shr-fill-[GrayText]',
        ],
    },
});
exports.Switch = (0, react_1.forwardRef)(({ className, ...props }, ref) => {
    const { wrapper, input, icon, iconWrapper } = (0, react_1.useMemo)(() => switchStyle(), []);
    return (react_1.default.createElement("span", { className: wrapper({ className }) },
        react_1.default.createElement("input", { ...props, type: "checkbox", role: "switch", className: input(), ref: ref }),
        react_1.default.createElement("span", { className: iconWrapper() },
            react_1.default.createElement(Icon_1.FaCheckIcon, { className: icon(), size: "XXS" }))));
});
//# sourceMappingURL=Switch.js.map