"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabBar = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Layout_1 = require("../Layout");
const tabBar = (0, tailwind_variants_1.tv)({
    slots: {
        wrapper: ['smarthr-ui-TabBar'],
        inner: ['shr-grow', 'shr-m-0.25'],
    },
    variants: {
        bordered: {
            true: {
                inner: [
                    'shr-relative',
                    'before:shr-absolute',
                    'before:shr-inset-x-0',
                    'before:shr-bottom-0',
                    'before:shr-border-b-shorthand',
                    'before:shr-content-[""]',
                ],
            },
        },
    },
});
const TabBar = ({ className, bordered = true, children, ...props }) => {
    const { wrapperStyle, innerStyle } = (0, react_1.useMemo)(() => {
        const { wrapper, inner } = tabBar();
        return {
            wrapperStyle: wrapper({ className }),
            innerStyle: inner({ bordered }),
        };
    }, [bordered, className]);
    return (react_1.default.createElement(Layout_1.Reel, { ...props, role: "tablist", className: wrapperStyle },
        react_1.default.createElement("div", { className: innerStyle }, children)));
};
exports.TabBar = TabBar;
//# sourceMappingURL=TabBar.js.map