import { ComponentProps, FC, PropsWithChildren } from 'react';
import { UnstyledButton } from '../Button';
type Props = PropsWithChildren<{
    /** タブの ID */
    id: string;
    /** `true` のとき、タブが選択状態のスタイルになる */
    selected?: boolean;
    /** `true` のとき、タブを無効状態にしてクリック不能にする */
    disabled?: boolean;
    /** タブをクリックした時に発火するコールバック関数 */
    onClick: (tabId: string) => void;
}>;
type ElementProps = Omit<ComponentProps<typeof UnstyledButton>, keyof Props | 'role' | 'aria-selected' | 'type'>;
export declare const TabItem: FC<Props & ElementProps>;
export {};
