"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabItem = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const ua_1 = require("../../libs/ua");
const Button_1 = require("../Button");
const tabItem = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-TabItem',
        'shr-cursor-pointer shr-appearance-none shr-border-none shr-bg-transparent shr-px-1 shr-py-0 shr-font-bold hover:shr-bg-column hover:shr-text-black [&]:shr-box-border [&]:shr-text-grey',
        'shr-h-[43px]', // TODO 高さを指定しないようにする
        'disabled:shr-cursor-not-allowed disabled:shr-bg-transparent disabled:shr-text-grey/50',
        'aria-selected:shr-border-b-shorthand aria-selected:shr-relative aria-selected:shr-border-b-[3px] aria-selected:shr-border-main aria-selected:shr-text-black',
        'aria-selected:shr-h-[40px]', // TODO 高さを指定しないようにする
    ],
    variants: {
        isTouchDevice: {
            false: 'shr-transition-colors',
        },
    },
});
const TabItem = ({ id, onClick, selected = false, className, disabled = false, ...props }) => {
    const tabItemStyle = (0, react_1.useMemo)(() => tabItem({ className, isTouchDevice: ua_1.isTouchDevice }), [className]);
    return (react_1.default.createElement(Button_1.UnstyledButton, { ...props, id: id, role: "tab", "aria-selected": selected, className: tabItemStyle, onClick: () => onClick(id), disabled: disabled, type: "button" }));
};
exports.TabItem = TabItem;
//# sourceMappingURL=TabItem.js.map