"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Table = exports.TableGroupContext = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
exports.TableGroupContext = (0, react_1.createContext)({
    group: 'body',
});
const table = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-Table',
        'shr-w-full',
        /* Headがfixed=trueの場合、separate以外だとHeadとBodyの間に隙間が生まれるため、明示的に指定しています */
        'shr-broder-separate',
        'shr-border-spacing-0',
        'shr-bg-column',
        '[&_tbody]:shr-bg-white',
        '[&_th]:contrast-more:shr-border-shorthand [&_th]:shr-bg-head [&_th]:contrast-more:shr-border-high-contrast',
        '[&_td]:contrast-more:shr-border-shorthand [&_td]:contrast-more:shr-border-high-contrast',
        'contrast-more:shr-border-shorthand contrast-more:shr-border-high-contrast',
    ],
    variants: {
        fixedHead: {
            true: [
                '[&_thead]:shr-sticky',
                '[&_thead]:shr-start-0',
                '[&_thead]:shr-top-0',
                /* zIndexの値はセマンティックトークンとして管理しているため、明示的に値を指定しないと重なり順が崩れるため設定しています */
                '[&_thead]:shr-z-fixed-menu',
            ],
        },
    },
});
const Table = ({ fixedHead = false, className, ...props }) => {
    const styles = (0, react_1.useMemo)(() => table({ fixedHead, className }), [className, fixedHead]);
    return react_1.default.createElement("table", { ...props, className: styles });
};
exports.Table = Table;
//# sourceMappingURL=Table.js.map