"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Td = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const useReelShadow_1 = require("./useReelShadow");
const Td = ({ nullable = false, fixed = false, className, ...props }) => {
    const styles = (0, react_1.useMemo)(() => {
        const tdStyles = td({ nullable, fixed, className });
        const reelShadowStyles = fixed ? (0, useReelShadow_1.reelShadowStyle)({ direction: 'right' }) : '';
        return `${tdStyles} ${reelShadowStyles}`.trim();
    }, [className, fixed, nullable]);
    return react_1.default.createElement("td", { ...props, className: styles });
};
exports.Td = Td;
const td = (0, tailwind_variants_1.tv)({
    base: [
        'smarthr-ui-Td',
        'shr-border-t-shorthand shr-h-[calc(1em_*_theme(lineHeight.normal))] shr-px-1 shr-py-0.5 shr-align-middle shr-text-base shr-leading-normal shr-text-black',
    ],
    variants: {
        nullable: {
            true: "empty:after:shr-content-['-----']",
        },
        fixed: {
            true: [
                'fixedElement',
                '[&.fixed]:shr-sticky [&.fixed]:shr-right-0 [&.fixed]:shr-bg-white [&.fixed]:after:shr-opacity-100',
            ],
        },
    },
});
//# sourceMappingURL=Td.js.map