"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTableHeadCellCount = void 0;
const react_1 = require("react");
const useTableHeadCellCount = () => {
    const [count, setCount] = (0, react_1.useState)(1000);
    const countHeadCellRef = (0, react_1.useCallback)((node) => {
        if (node !== null) {
            const parentTable = node.closest('table');
            const cells = parentTable?.querySelectorAll('thead > tr:first-child > th');
            setCount(cells?.length || 0);
        }
    }, []);
    return { count, countHeadCellRef };
};
exports.useTableHeadCellCount = useTableHeadCellCount;
//# sourceMappingURL=useTableHeadCellCount.js.map