"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Text = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Heading_1 = require("../Heading/Heading");
const text = (0, tailwind_variants_1.tv)({
    variants: {
        size: {
            XXS: 'shr-text-2xs',
            XS: 'shr-text-xs',
            S: 'shr-text-sm',
            M: 'shr-text-base',
            L: 'shr-text-lg',
            XL: 'shr-text-xl',
            XXL: 'shr-text-2xl',
        },
        weight: {
            normal: 'shr-font-normal',
            bold: 'shr-font-bold',
        },
        italic: {
            true: 'shr-italic',
        },
        color: {
            TEXT_BLACK: 'shr-text-black',
            TEXT_WHITE: 'shr-text-white',
            TEXT_GREY: 'shr-text-grey',
            TEXT_DISABLED: 'shr-text-disabled',
            TEXT_LINK: 'shr-text-link',
            inherit: 'shr-text-inherit',
        },
        leading: {
            NONE: 'shr-leading-none',
            TIGHT: 'shr-leading-tight',
            NORMAL: 'shr-leading-normal',
            LOOSE: 'shr-leading-loose',
        },
        whiteSpace: {
            normal: 'shr-whitespace-normal',
            nowrap: 'shr-whitespace-nowrap',
            pre: 'shr-whitespace-pre',
            'pre-line': 'shr-whitespace-pre-line',
            'pre-wrap': 'shr-whitespace-pre-wrap',
        },
    },
});
const Text = ({ emphasis, styleType, weight = emphasis ? 'bold' : undefined, as: Component = emphasis ? 'em' : 'span', ...props }) => {
    const { size, italic, color, leading, whiteSpace, className, ...others } = props;
    const styleTypeValues = styleType ? Heading_1.MAPPER_SIZE_AND_WEIGHT[styleType] : null;
    const styles = (0, react_1.useMemo)(() => text({
        size: size || styleTypeValues?.size,
        weight: weight || styleTypeValues?.weight,
        color: color || styleTypeValues?.color,
        italic,
        leading,
        whiteSpace,
        className,
    }), [size, weight, italic, color, leading, whiteSpace, className, styleTypeValues]);
    return react_1.default.createElement(Component, { ...others, className: styles });
};
exports.Text = Text;
//# sourceMappingURL=Text.js.map