"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextLink = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Icon_1 = require("../Icon");
const textLink = (0, tailwind_variants_1.tv)({
    slots: {
        anchor: 'shr-text-link shr-no-underline shr-shadow-underline forced-colors:shr-underline [&:not([href])]:shr-shadow-none [&:not([href])]:forced-colors:shr-no-underline',
        prefixWrapper: 'shr-me-0.25 shr-align-middle',
        suffixWrapper: 'shr-ms-0.25 shr-align-middle',
    },
});
exports.TextLink = (0, react_1.forwardRef)(({ href, target, onClick, children, prefix, suffix, className, ...others }, ref) => {
    const actualSuffix = (0, react_1.useMemo)(() => {
        if (target === '_blank' && suffix === undefined) {
            return react_1.default.createElement(Icon_1.FaExternalLinkAltIcon, { "aria-label": "\u5225\u30BF\u30D6\u3067\u958B\u304F" });
        }
        return suffix;
    }, [suffix, target]);
    const actualHref = (0, react_1.useMemo)(() => {
        if (href) {
            return href;
        }
        if (onClick) {
            return '';
        }
        return undefined;
    }, [href, onClick]);
    const actualOnClick = (0, react_1.useMemo)(() => {
        if (!onClick) {
            return undefined;
        }
        return (e) => {
            if (!href) {
                e.preventDefault();
            }
            onClick(e);
        };
    }, [href, onClick]);
    const { anchor, prefixWrapper, suffixWrapper } = (0, react_1.useMemo)(() => textLink(), []);
    return (react_1.default.createElement("a", { ...others, ref: ref, href: actualHref, target: target, onClick: actualOnClick, className: anchor({ className }) },
        prefix && react_1.default.createElement("span", { className: prefixWrapper() }, prefix),
        children,
        actualSuffix && react_1.default.createElement("span", { className: suffixWrapper() }, actualSuffix)));
});
//# sourceMappingURL=TextLink.js.map