"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTheme = void 0;
const react_1 = require("react");
const resolveConfig_1 = __importDefault(require("tailwindcss/resolveConfig"));
const TailwindThemeProvider_1 = require("../themes/tailwind/TailwindThemeProvider");
const useTheme = () => {
    const { config } = (0, react_1.useContext)(TailwindThemeProvider_1.ThemeContext);
    return (0, react_1.useMemo)(() => {
        const { theme } = (0, resolveConfig_1.default)(config);
        return theme;
    }, [config]);
};
exports.useTheme = useTheme;
//# sourceMappingURL=useTailwindTheme.js.map