declare const _default: {
    content: never[];
    theme: {
        backgroundColor: ({ theme }: import("tailwindcss/types/config").PluginUtils) => {
            black: string;
            white: string;
            'white-darken': any;
            link: string;
            background: string;
            border: any;
            brand: any;
            column: string;
            'column-darken': string;
            'base-grey': string;
            'over-background': string;
            head: string;
            'head-darken': string;
            'action-background': string;
            main: string;
            'main-darken': any;
            danger: string;
            'danger-darken': any;
            'warning-yellow': string;
            'warning-yellow-darken': any;
            overlay: string;
            scrim: string;
            grey: {
                9: any;
                '9-darken': string;
            };
            inherit: string;
            transparent: string;
        };
        borderRadius: {
            none: string;
            s: string;
            m: string;
            l: string;
            em: string;
            full: string;
        };
        boxShadow: {
            'layer-0': string;
            'layer-1': string;
            'layer-2': string;
            'layer-3': string;
            'layer-4': string;
            outline: string;
            underline: string;
            'input-hover': string;
            none: string;
        };
        colors: {
            black: string;
            white: string;
            'white-darken': string;
            main: string;
            'main-darken': string;
            brand: string;
            outline: string;
            danger: string;
            'danger-darken': string;
            'warning-yellow': string;
            'warning-yellow-darken': string;
            grey: {
                DEFAULT: string;
                5: string;
                6: string;
                7: string;
                9: string;
                20: string;
                30: string;
                65: string;
                100: string;
            };
            transparency: {
                15: string;
                30: string;
                50: string;
            };
            inherit: string;
            transparent: string;
            current: string;
        };
        fontFamily: {
            inherit: string;
        };
        fontSize: {
            '2xs': string;
            xs: string;
            sm: string;
            base: string;
            lg: string;
            xl: string;
            '2xl': string;
            inherit: string;
        };
        lineHeight: {
            none: string;
            tight: string;
            normal: string;
            loose: string;
        };
        maxWidth: {
            none: string;
            full: string;
            min: string;
            max: string;
            fit: string;
        };
        outlineColor: {
            DEFAULT: string;
        };
        spacing: {
            0: string;
            2: string;
            1: string;
            3: string;
            4: string;
            8: string;
            [-1]: string;
            1.25: string;
            1.5: string;
            2.5: string;
            0.5: string;
            [-2]: string;
            [-3]: string;
            0.25: string;
            0.75: string;
            3.5: string;
            [-0.25]: string;
            [-0.5]: string;
            [-0.75]: string;
            [-1.25]: string;
            [-1.5]: string;
            [-2.5]: string;
            [-3.5]: string;
            [-4]: string;
            [-8]: string;
            px: string;
            em: string;
        };
        stroke: {
            black: string;
        };
        textColor: ({ theme }: import("tailwindcss/types/config").PluginUtils) => {
            main: any;
            black: any;
            white: any;
            'white-darken': any;
            disabled: any;
            link: string;
            grey: any;
            danger: any;
            inherit: string;
            transparent: string;
        };
        zIndex: {
            auto: string;
            0: string;
            1: string;
            'fixed-menu': string;
            'overlap-base': string;
            overlap: string;
            'flash-message': string;
        };
        extend: {
            aria: {
                'current-page': string;
            };
            minHeight: ({ theme }: import("tailwindcss/types/config").PluginUtils) => any;
            borderColor: ({ theme }: import("tailwindcss/types/config").PluginUtils) => {
                default: any;
                disabled: any;
                darken: string;
                'high-contrast': any;
            };
            strokeWidth: {
                '0.5': string;
            };
            keyframes: ({ theme }: import("tailwindcss/types/config").PluginUtils) => {
                'loader-line-full-unfill-rotate': {
                    '12.5%': {
                        transform: string;
                    };
                    '25%': {
                        transform: string;
                    };
                    '37.5%': {
                        transform: string;
                    };
                    '50%': {
                        transform: string;
                    };
                    '62.5%': {
                        transform: string;
                    };
                    '75%': {
                        transform: string;
                    };
                    '87.5%': {
                        transform: string;
                    };
                    to: {
                        transform: string;
                    };
                };
                'loader-line1-fade-in-out': {
                    '0%': {
                        opacity: string;
                    };
                    '25%': {
                        opacity: string;
                    };
                    '26%': {
                        opacity: string;
                    };
                    '89%': {
                        opacity: string;
                    };
                    '90%': {
                        opacity: string;
                    };
                    to: {
                        opacity: string;
                    };
                };
                'loader-line2-fade-in-out': {
                    '0%': {
                        opacity: string;
                    };
                    '15%': {
                        opacity: string;
                    };
                    '25%': {
                        opacity: string;
                    };
                    '50%': {
                        opacity: string;
                    };
                    '51%': {
                        opacity: string;
                    };
                };
                'loader-line3-fade-in-out': {
                    '0%': {
                        opacity: string;
                    };
                    '40%': {
                        opacity: string;
                    };
                    '50%': {
                        opacity: string;
                    };
                    '75%': {
                        opacity: string;
                    };
                    '76%': {
                        opacity: string;
                    };
                };
                'loader-line4-fade-in-out': {
                    '0%': {
                        opacity: string;
                    };
                    '65%': {
                        opacity: string;
                    };
                    '75%': {
                        opacity: string;
                    };
                    '90%': {
                        opacity: string;
                    };
                    to: {
                        opacity: string;
                    };
                };
                'loader-left-spin': {
                    '0%, 100%': {
                        transform: string;
                    };
                    '50%': {
                        transform: string;
                    };
                };
                'loader-right-spin': {
                    '0%, 100%': {
                        transform: string;
                    };
                    '50%': {
                        transform: string;
                    };
                };
                'notification-bar-slide-in': {
                    from: {
                        opacity: string;
                        transform: string;
                    };
                    to: {
                        opacity: string;
                        transform: string;
                    };
                };
                'flash-message-bounce': {
                    'from, 20%, 53%, 80%, to': {
                        'animation-timing-function': string;
                        transform: string;
                    };
                    '40%, 43%': {
                        'animation-timing-function': string;
                        transform: string;
                    };
                    '70%': {
                        'animation-timing-function': string;
                        transform: string;
                    };
                    '90%': {
                        transform: string;
                    };
                };
            };
        };
    };
    corePlugins: {
        preflight: false;
        boxShadowColor: false;
        caretColor: false;
        divideColor: false;
        placeholderColor: false;
        ringColor: false;
        ringOffsetColor: false;
        textDecorationColor: false;
    };
    plugins: {
        handler: import("tailwindcss/types/config").PluginCreator;
        config?: Partial<import("tailwindcss/types/config").Config> | undefined;
    }[];
    prefix: string;
};
export default _default;
